(* This file extracted from the GTK tutorial.
 *
 * entry.c
 *  
 * Converted from C to Pascal by Frank Loemker
 * <floemker@techfak.uni-bielefeld.de>
 *)

uses glib, gtkmain, gtksignal, gtkwindow, gtkwidget, gtkentry, gtkenums,
     gtkobjects, gtkcheckbutton, gtktogglebutton, gtkvbox, gtkhbox,
     gtkcontainer, gtkbox, gtkbutton;

procedure enter_callback(widget,entry : PGtkWidget); cdecl;
var entry_text : Pgchar;
begin
  entry_text := gtk_entry_get_text(PGtkEntry(entry));
  writeln ('Entry contents: ',entry_text);
end;

procedure entry_toggle_editable (checkbutton,entry : PGtkWidget); cdecl;
begin
  gtk_entry_set_editable(pGtkEntry(entry),
			 gboolean(active(pGtkToggleButton(checkbutton)^)));
end;

procedure entry_toggle_visibility (checkbutton,entry : PGtkWidget); cdecl;
begin
  gtk_entry_set_visibility(pGTKENTRY(entry),
			   gboolean(active(pGtkToggleButton(checkbutton)^)));
end;

var window, vbox, hbox,
  entry, button, check : PGtkWidget;
begin
  gtk_init (@argc, @argv);

  (* create a new window *)
  window := gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize( pGTKWIDGET (window), 200, 100);
  gtk_window_set_title(pGTKWINDOW (window), 'GTK Entry');
  gtk_signal_connect(pGTKOBJECT (window), 'delete_event',
		     GtkSignalFunc (@gtk_exit), NIL);

  vbox := gtk_vbox_new (FALSE, 0);
  gtk_container_add (pGTKCONTAINER (window), vbox);
  gtk_widget_show (vbox);

  entry := gtk_entry_new_with_max_length (50);
  gtk_signal_connect(pGTKOBJECT(entry), 'activate',
		     GTKSIGNALFUNC(@enter_callback),
		     entry);
  gtk_entry_set_text (pGTKENTRY (entry), 'hello');
  gtk_entry_append_text (pGTKENTRY (entry), ' world');
  gtk_entry_select_region (pGTKENTRY (entry),
			   0, pGTKENTRY(entry)^.text_length);
  gtk_box_pack_start (pGTKBOX (vbox), entry, TRUE, TRUE, 0);
  gtk_widget_show (entry);

  hbox := gtk_hbox_new (FALSE, 0);
  gtk_container_add (pGTKCONTAINER (vbox), hbox);
  gtk_widget_show (hbox);

  check := gtk_check_button_new_with_label('Editable');
  gtk_box_pack_start (pGTKBOX (hbox), check, TRUE, TRUE, 0);
  gtk_signal_connect (pGTKOBJECT(check), 'toggled',
		      GtkSignalFunc(@entry_toggle_editable), entry);
  gtk_toggle_button_set_state(pGTKTOGGLEBUTTON(check), TRUE);
  gtk_widget_show (check);

  check := gtk_check_button_new_with_label('Visible');
  gtk_box_pack_start (pGTKBOX (hbox), check, TRUE, TRUE, 0);
  gtk_signal_connect (pGTKOBJECT(check), 'toggled',
		      GtkSignalFunc(@entry_toggle_visibility), entry);
  gtk_toggle_button_set_state(pGTKTOGGLEBUTTON(check), TRUE);
  gtk_widget_show (check);

  button := gtk_button_new_with_label ('Close');
  gtk_signal_connect_object (pGTKOBJECT (button), 'clicked',
			     GtkSignalFunc(@gtk_exit),
			     pGTKOBJECT (window));
  gtk_box_pack_start (pGTKBOX (vbox), button, TRUE, TRUE, 0);

  pGTKOBJECT(button)^.flags := pGTKOBJECT(button)^.flags or GTK_CAN_DEFAULT;
  (*  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT); *)
  gtk_widget_grab_default (button);
  gtk_widget_show (button);

  gtk_widget_show(window);

  gtk_main();
end.
