unit gdktypes;

  interface

uses glib;

Type
  PLongint  = ^Longint;
  PByte     = ^Byte;
  PWord     = ^Word;
  PINteger  = ^Integer;
  PCardinal = ^Cardinal;
  PReal     = ^Real;
  PDouble   = ^Double;

{ GDK - The GIMP Drawing Kit
   Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
  
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
  
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the GNU
   Library General Public License for more details.
  
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
 }

const
   GDK_NONE = 0;
   GDK_CURRENT_TIME = 0;
   GDK_PARENT_RELATIVE = 1;
   GDK_CORE_POINTER = $fedc;

Type gdkatom = gulong;
     PGdkAtom = ^PGdkAtom;
     GdkIc = Pointer;
          
type
   PGdkWindowType = ^GdkWindowType;
   GdkWindowType =  Longint;
Const
     GDK_WINDOW_ROOT = 0;
     GDK_WINDOW_TOPLEVEL = 1;
     GDK_WINDOW_CHILD = 2;
     GDK_WINDOW_DIALOG = 3;
     GDK_WINDOW_TEMP = 4;
     GDK_WINDOW_PIXMAP = 5;
     GDK_WINDOW_FOREIGN = 6;

type
   PGdkWindowClass = ^GdkWindowClass;
   GdkWindowClass =  Longint;
Const
     GDK_INPUT_OUTPUT = 0;
     GDK_INPUT_ONLY = 1;

type
   PGdkImageType = ^GdkImageType;
   GdkImageType =  Longint;
Const
     GDK_IMAGE_NORMAL = 0;
     GDK_IMAGE_SHARED = 1;
     GDK_IMAGE_FASTEST = 2;

type
   PGdkVisualType = ^GdkVisualType;
   GdkVisualType =  Longint;
Const
     GDK_VISUAL_STATIC_GRAY = 0;
     GDK_VISUAL_GRAYSCALE = 1;
     GDK_VISUAL_STATIC_COLOR = 2;
     GDK_VISUAL_PSEUDO_COLOR = 3;
     GDK_VISUAL_TRUE_COLOR = 4;
     GDK_VISUAL_DIRECT_COLOR = 5;

type
   PGdkFontType = ^GdkFontType;
   GdkFontType =  Longint;
Const
     GDK_FONT_FONT = 0;
     GDK_FONT_FONTSET = 1;

type
   PGdkWindowAttributesType = ^GdkWindowAttributesType;
   GdkWindowAttributesType =  Longint;
Const
     GDK_WA_TITLE = (1) shl (1);
     GDK_WA_X = (1) shl (2);
     GDK_WA_Y = (1) shl (3);
     GDK_WA_CURSOR = (1) shl (4);
     GDK_WA_COLORMAP = (1) shl (5);
     GDK_WA_VISUAL = (1) shl (6);
     GDK_WA_WMCLASS = (1) shl (7);
     GDK_WA_NOREDIR = (1) shl (8);

type
   PGdkWindowHints = ^GdkWindowHints;
   GdkWindowHints =  Longint;
Const
     GDK_HINT_POS = (1) shl (0);
     GDK_HINT_MIN_SIZE = (1) shl (1);
     GDK_HINT_MAX_SIZE = (1) shl (2);

type
   PGdkFunction  = ^GdkFunction;
   GdkFunction  =  Longint; 

Const
     GDK_COPY = 0;
     GDK_INVERT = 1;
     GDK_XOR = 2;

type
   PGdkFill = ^GdkFill;
   GdkFill =  Longint;
Const
     GDK_SOLID = 0;
     GDK_TILED = 1;
     GDK_STIPPLED = 2;
     GDK_OPAQUE_STIPPLED = 3;

type
   PGdkFillRule = ^GdkFillRule;
   GdkFillRule =  Longint;
Const
     GDK_EVEN_ODD_RULE = 0;
     GDK_WINDING_RULE = 1;

type
   PGdkLineStyle = ^GdkLineStyle;
   GdkLineStyle =  Longint;
Const
     GDK_LINE_SOLID = 0;
     GDK_LINE_ON_OFF_DASH = 1;
     GDK_LINE_DOUBLE_DASH = 2;

type
   PGdkCapStyle = ^GdkCapStyle;
   GdkCapStyle =  Longint;
Const
     GDK_CAP_NOT_LAST = 0;
     GDK_CAP_BUTT = 1;
     GDK_CAP_ROUND = 2;
     GDK_CAP_PROJECTING = 3;

type
   PGdkJoinStyle = ^GdkJoinStyle;
   GdkJoinStyle =  Longint;
Const
     GDK_JOIN_MITER = 0;
     GDK_JOIN_ROUND = 1;
     GDK_JOIN_BEVEL = 2;

type
   PGdkCursorType = ^GdkCursorType;
   GdkCursorType =  Longint;

Const
     GDK_NUM_GLYPHS = 154;
     GDK_X_CURSOR = 0;
     GDK_ARROW = 2;
     GDK_BASED_ARROW_DOWN = 4;
     GDK_BASED_ARROW_UP = 6;
     GDK_BOAT = 8;
     GDK_BOGOSITY = 10;
     GDK_BOTTOM_LEFT_CORNER = 12;
     GDK_BOTTOM_RIGHT_CORNER = 14;
     GDK_BOTTOM_SIDE = 16;
     GDK_BOTTOM_TEE = 18;
     GDK_BOX_SPIRAL = 20;
     GDK_CENTER_PTR = 22;
     GDK_CIRCLE = 24;
     GDK_CLOCK = 26;
     GDK_COFFEE_MUG = 28;
     GDK_CROSS = 30;
     GDK_CROSS_REVERSE = 32;
     GDK_CROSSHAIR = 34;
     GDK_DIAMOND_CROSS = 36;
     GDK_DOT = 38;
     GDK_DOTBOX = 40;
     GDK_DOUBLE_ARROW = 42;
     GDK_DRAFT_LARGE = 44;
     GDK_DRAFT_SMALL = 46;
     GDK_DRAPED_BOX = 48;
     GDK_EXCHANGE = 50;
     GDK_FLEUR = 52;
     GDK_GOBBLER = 54;
     GDK_GUMBY = 56;
     GDK_HAND1 = 58;
     GDK_HAND2 = 60;
     GDK_HEART = 62;
     GDK_ICON = 64;
     GDK_IRON_CROSS = 66;
     GDK_LEFT_PTR = 68;
     GDK_LEFT_SIDE = 70;
     GDK_LEFT_TEE = 72;
     GDK_LEFTBUTTON = 74;
     GDK_LL_ANGLE = 76;
     GDK_LR_ANGLE = 78;
     GDK_MAN = 80;
     GDK_MIDDLEBUTTON = 82;
     GDK_MOUSE = 84;
     GDK_PENCIL = 86;
     GDK_PIRATE = 88;
     GDK_PLUS = 90;
     GDK_QUESTION_ARROW = 92;
     GDK_RIGHT_PTR = 94;
     GDK_RIGHT_SIDE = 96;
     GDK_RIGHT_TEE = 98;
     GDK_RIGHTBUTTON = 100;
     GDK_RTL_LOGO = 102;
     GDK_SAILBOAT = 104;
     GDK_SB_DOWN_ARROW = 106;
     GDK_SB_H_DOUBLE_ARROW = 108;
     GDK_SB_LEFT_ARROW = 110;
     GDK_SB_RIGHT_ARROW = 112;
     GDK_SB_UP_ARROW = 114;
     GDK_SB_V_DOUBLE_ARROW = 116;
     GDK_SHUTTLE = 118;
     GDK_SIZING = 120;
     GDK_SPIDER = 122;
     GDK_SPRAYCAN = 124;
     GDK_STAR = 126;
     GDK_TARGET = 128;
     GDK_TCROSS = 130;
     GDK_TOP_LEFT_ARROW = 132;
     GDK_TOP_LEFT_CORNER = 134;
     GDK_TOP_RIGHT_CORNER = 136;
     GDK_TOP_SIDE = 138;
     GDK_TOP_TEE = 140;
     GDK_TREK = 142;
     GDK_UL_ANGLE = 144;
     GDK_UMBRELLA = 146;
     GDK_UR_ANGLE = 148;
     GDK_WATCH = 150;
     GDK_XTERM = 152;
     GDK_LAST_CURSOR = (152)+1;
     GDK_CURSOR_IS_PIXMAP = -1;

type
   PGdkFilterReturn = ^GdkFilterReturn;
   GdkFilterReturn =  Longint;
Const
     GDK_FILTER_CONTINUE = 0;
     GDK_FILTER_TRANSLATE = 1;
     GDK_FILTER_REMOVE = 2;

type
   PGdkVisibilityState = ^GdkVisibilityState;
   GdkVisibilityState =  Longint;
Const
     GDK_VISIBILITY_UNOBSCURED = 0;
     GDK_VISIBILITY_PARTIAL = 1;
     GDK_VISIBILITY_FULLY_OBSCURED = 2;

type
   PGdkEventType = ^GdkEventType;
   GdkEventType =  Longint;
Const
     GDK_NOTHING = -1;
     GDK_DELETE = 0;
     GDK_DESTROY = 1;
     GDK_EXPOSE = 2;
     GDK_MOTION_NOTIFY = 3;
     GDK_BUTTON_PRESS = 4;
     GDK_2BUTTON_PRESS = 5;
     GDK_3BUTTON_PRESS = 6;
     GDK_BUTTON_RELEASE = 7;
     GDK_KEY_PRESS = 8;
     GDK_KEY_RELEASE = 9;
     GDK_ENTER_NOTIFY = 10;
     GDK_LEAVE_NOTIFY = 11;
     GDK_FOCUS_CHANGE = 12;
     GDK_CONFIGURE = 13;
     GDK_MAP = 14;
     GDK_UNMAP = 15;
     GDK_PROPERTY_NOTIFY = 16;
     GDK_SELECTION_CLEAR = 17;
     GDK_SELECTION_REQUEST = 18;
     GDK_SELECTION_NOTIFY = 19;
     GDK_PROXIMITY_IN = 20;
     GDK_PROXIMITY_OUT = 21;
     GDK_DRAG_BEGIN = 22;
     GDK_DRAG_REQUEST = 23;
     GDK_DROP_ENTER = 24;
     GDK_DROP_LEAVE = 25;
     GDK_DROP_DATA_AVAIL = 26;
     GDK_CLIENT_EVENT = 27;
     GDK_VISIBILITY_NOTIFY = 28;
     GDK_NO_EXPOSE = 29;
     GDK_OTHER_EVENT = 9999;

type
   PGdkEventMask = ^GdkEventMask;
   GdkEventMask =  Longint;
Const
     GDK_EXPOSURE_MASK = (1) shl (1);
     GDK_POINTER_MOTION_MASK = (1) shl (2);
     GDK_POINTER_MOTION_HINT_MASK = (1) shl (3);
     GDK_BUTTON_MOTION_MASK = (1) shl (4);
     GDK_BUTTON1_MOTION_MASK = (1) shl (5);
     GDK_BUTTON2_MOTION_MASK = (1) shl (6);
     GDK_BUTTON3_MOTION_MASK = (1) shl (7);
     GDK_BUTTON_PRESS_MASK = (1) shl (8);
     GDK_BUTTON_RELEASE_MASK = (1) shl (9);
     GDK_KEY_PRESS_MASK = (1) shl (10);
     GDK_KEY_RELEASE_MASK = (1) shl (11);
     GDK_ENTER_NOTIFY_MASK = (1) shl (12);
     GDK_LEAVE_NOTIFY_MASK = (1) shl (13);
     GDK_FOCUS_CHANGE_MASK = (1) shl (14);
     GDK_STRUCTURE_MASK = (1) shl (15);
     GDK_PROPERTY_CHANGE_MASK = (1) shl (16);
     GDK_VISIBILITY_NOTIFY_MASK = (1) shl (17);
     GDK_PROXIMITY_IN_MASK = (1) shl (18);
     GDK_PROXIMITY_OUT_MASK = (1) shl (19);
     GDK_ALL_EVENTS_MASK = $07FFFF;

type
   PGdkNotifyType = ^GdkNotifyType;
   GdkNotifyType =  Longint;
Const
     GDK_NOTIFY_ANCESTOR = 0;
     GDK_NOTIFY_VIRTUAL = 1;
     GDK_NOTIFY_INFERIOR = 2;
     GDK_NOTIFY_NONLINEAR = 3;
     GDK_NOTIFY_NONLINEAR_VIRTUAL = 4;
     GDK_NOTIFY_UNKNOWN = 5;

type
   PGdkModifierType = ^GdkModifierType;
   GdkModifierType =  Longint;
Const
     GDK_SHIFT_MASK = (1) shl (0);
     GDK_LOCK_MASK = (1) shl (1);
     GDK_CONTROL_MASK = (1) shl (2);
     GDK_MOD1_MASK = (1) shl (3);
     GDK_MOD2_MASK = (1) shl (4);
     GDK_MOD3_MASK = (1) shl (5);
     GDK_MOD4_MASK = (1) shl (6);
     GDK_MOD5_MASK = (1) shl (7);
     GDK_BUTTON1_MASK = (1) shl (8);
     GDK_BUTTON2_MASK = (1) shl (9);
     GDK_BUTTON3_MASK = (1) shl (10);
     GDK_BUTTON4_MASK = (1) shl (11);
     GDK_BUTTON5_MASK = (1) shl (12);

type
   PGdkSubwindowMode = ^GdkSubwindowMode;
   GdkSubwindowMode =  Longint;
Const
     GDK_CLIP_BY_CHILDREN = 0;
     GDK_INCLUDE_INFERIORS = 1;

type
   PGdkInputCondition = ^GdkInputCondition;
   GdkInputCondition =  Longint;
Const
     GDK_INPUT_READ = (1) shl (0);
     GDK_INPUT_WRITE = (1) shl (1);
     GDK_INPUT_EXCEPTION = (1) shl (2);

type
   PGdkStatus = ^GdkStatus;
   GdkStatus =  Longint;
Const
     GDK_OK = 0;
     GDK_ERROR = -1;
     GDK_ERROR_PARAM = -2;
     GDK_ERROR_FILE = -3;
     GDK_ERROR_MEM = -4;

type
   PGdkByteOrder = ^GdkByteOrder;
   GdkByteOrder =  Longint;
Const
     GDK_LSB_FIRST = 0;
     GDK_MSB_FIRST = 1;

type
   PGdkGCValuesMask = ^GdkGCValuesMask;
   GdkGCValuesMask =  Longint;
Const
     GDK_GC_FOREGROUND = (1) shl (0);
     GDK_GC_BACKGROUND = (1) shl (1);
     GDK_GC_FONT = (1) shl (2);
     GDK_GC_Function  = (1) shl (3); 
     GDK_GC_FILL = (1) shl (4);
     GDK_GC_TILE = (1) shl (5);
     GDK_GC_STIPPLE = (1) shl (6);
     GDK_GC_CLIP_MASK = (1) shl (7);
     GDK_GC_SUBWINDOW = (1) shl (8);
     GDK_GC_TS_X_ORIGIN = (1) shl (9);
     GDK_GC_TS_Y_ORIGIN = (1) shl (10);
     GDK_GC_CLIP_X_ORIGIN = (1) shl (11);
     GDK_GC_CLIP_Y_ORIGIN = (1) shl (12);
     GDK_GC_EXPOSURES = (1) shl (13);
     GDK_GC_LINE_WIDTH = (1) shl (14);
     GDK_GC_LINE_STYLE = (1) shl (15);
     GDK_GC_CAP_STYLE = (1) shl (16);
     GDK_GC_JOIN_STYLE = (1) shl (17);

type
   PGdkSelection = ^GdkSelection;
   GdkSelection =  Longint;
Const
     GDK_SELECTION_PRIMARY = 1;
     GDK_SELECTION_SECONDARY = 2;

type
   PGdkPropertyState = ^GdkPropertyState;
   GdkPropertyState =  Longint;
Const
     GDK_PROPERTY_NEW_VALUE = 0;
     GDK_PROPERTY_DELETE = 1;

type
   PGdkPropMode = ^GdkPropMode;
   GdkPropMode =  Longint;
Const
     GDK_PROP_MODE_REPLACE = 0;
     GDK_PROP_MODE_PREPEND = 1;
     GDK_PROP_MODE_APPEND = 2;

type
   PGdkDndType = ^GdkDndType;
   GdkDndType =  Longint;
Const
     GDK_DNDTYPE_NOTDND = -1;
     GDK_DNDTYPE_UNKNOWN = 0;
     GDK_DNDTYPE_RAWDATA = 1;
     GDK_DNDTYPE_FILE = 2;
     GDK_DNDTYPE_FILES = 3;
     GDK_DNDTYPE_TEXT = 4;
     GDK_DNDTYPE_DIR = 5;
     GDK_DNDTYPE_LINK = 6;
     GDK_DNDTYPE_EXE = 7;
     GDK_DNDTYPE_URL = 8;
     GDK_DNDTYPE_MIME = 9;
     GDK_DNDTYPE_END = 10;

type
   PGdkInputSource = ^GdkInputSource;
   GdkInputSource =  Longint;
Const
     GDK_SOURCE_MOUSE = 0;
     GDK_SOURCE_PEN = 1;
     GDK_SOURCE_ERASER = 2;
     GDK_SOURCE_CURSOR = 3;

type
   PGdkInputMode = ^GdkInputMode;
   GdkInputMode =  Longint;
Const
     GDK_MODE_DISABLED = 0;
     GDK_MODE_SCREEN = 1;
     GDK_MODE_WINDOW = 2;

type
   PGdkAxisUse = ^GdkAxisUse;
   GdkAxisUse =  Longint;
Const
     GDK_AXIS_IGNORE = 0;
     GDK_AXIS_X = 1;
     GDK_AXIS_Y = 2;
     GDK_AXIS_PRESSURE = 3;
     GDK_AXIS_XTILT = 4;
     GDK_AXIS_YTILT = 5;
     GDK_AXIS_LAST = 6;

type
   PGdkTarget = ^GdkTarget;
   GdkTarget =  Longint;
Const
     GDK_TARGET_BITMAP = 5;
     GDK_TARGET_COLORMAP = 7;
     GDK_TARGET_DRAWABLE = 17;
     GDK_TARGET_PIXMAP = 20;
     GDK_TARGET_STRING = 31;

type
   PGdkSelectionType = ^GdkSelectionType;
   GdkSelectionType =  Longint;
Const
     GDK_SELECTION_TYPE_ATOM = 4;
     GDK_SELECTION_TYPE_BITMAP = 5;
     GDK_SELECTION_TYPE_COLORMAP = 7;
     GDK_SELECTION_TYPE_DRAWABLE = 17;
     GDK_SELECTION_TYPE_INTEGER = 19;
     GDK_SELECTION_TYPE_PIXMAP = 20;
     GDK_SELECTION_TYPE_WINDOW = 33;
     GDK_SELECTION_TYPE_STRING = 31;

type
   PGdkExtensionMode = ^GdkExtensionMode;
   GdkExtensionMode =  Longint;
Const
     GDK_EXTENSION_EVENTS_NONE = 0;
     GDK_EXTENSION_EVENTS_ALL = 1;
     GDK_EXTENSION_EVENTS_CURSOR = 2;

type
   PGdkIMStyle = ^GdkIMStyle;
   GdkIMStyle =  Longint;
Const
     GdkIMPreeditArea = $0001;
     GdkIMPreeditCallbacks = $0002;
     GdkIMPreeditPosition = $0004;
     GdkIMPreeditNothing = $0008;
     GdkIMPreeditNone = $0010;
     GdkIMStatusArea = $0100;
     GdkIMStatusCallbacks = $0200;
     GdkIMStatusNothing = $0400;
     GdkIMStatusNone = $0800;

type
   PGdkWMDecoration = ^GdkWMDecoration;
   GdkWMDecoration =  Longint;
Const
     GDK_DECOR_ALL = (1) shl (0);
     GDK_DECOR_BORDER = (1) shl (1);
     GDK_DECOR_RESIZEH = (1) shl (2);
     GDK_DECOR_TITLE = (1) shl (3);
     GDK_DECOR_MENU = (1) shl (4);
     GDK_DECOR_MINIMIZE = (1) shl (5);
     GDK_DECOR_MAXIMIZE = (1) shl (6);

type
   PGdkWMFunction  = ^GdkWMFunction; 
   GdkWMFunction  =  Longint; 
Const
     GDK_FUNC_ALL = (1) shl (0);
     GDK_FUNC_RESIZE = (1) shl (1);
     GDK_FUNC_MOVE = (1) shl (2);
     GDK_FUNC_MINIMIZE = (1) shl (3);
     GDK_FUNC_MAXIMIZE = (1) shl (4);
     GDK_FUNC_CLOSE = (1) shl (5);
{
#define GdkIMPreeditMask \
	( GdkIMPreeditArea     | GdkIMPreeditCallbacks | \
	  GdkIMPreeditPosition | GdkIMPreeditNothing | \
	  GdkIMPreeditNone )

#define GdkIMStatusMask \
	( GdkIMStatusArea | GdkIMStatusCallbacks | \
	  GdkIMStatusNothing | GdkIMStatusNone )
}

type
   PGdkInputFunction  = ^GdkInputFunction; 
   GdkInputFunction  = Procedure(data:gpointer; source:gint; condition:GdkInputCondition); cdecl; cdecl;
   PGdkDestroyNotify = ^GdkDestroyNotify;
   GdkDestroyNotify = Procedure(data:gpointer); cdecl;
   PGdkColorContextMode = ^GdkColorContextMode;
   GdkColorContextMode =  Longint;

Const
     GDK_CC_MODE_UNDEFINED = 0;
     GDK_CC_MODE_BW = 1;
     GDK_CC_MODE_STD_CMAP = 2;
     GDK_CC_MODE_TRUE = 3;
     GDK_CC_MODE_MY_GRAY = 4;
     GDK_CC_MODE_PALETTE = 5;

type
   PGdkOverlapType = ^GdkOverlapType;
   GdkOverlapType =  Longint;
Const
     GDK_OVERLAP_RECTANGLE_IN = 0;
     GDK_OVERLAP_RECTANGLE_OUT = 1;
     GDK_OVERLAP_RECTANGLE_PART = 2;

type
   PGdkColor = ^GdkColor;
{$PACKRECORDS 4}
   GdkColor = record
        pixel : gulong;
        red : gushort;
        green : gushort;
        blue : gushort;
     end;

   PGdkColormap = ^GdkColormap;
{$PACKRECORDS 4}
   GdkColormap = record
        size : gint;
        colors : PGdkColor;
     end;

   PGdkVisual = ^GdkVisual;
{$PACKRECORDS 4}
   GdkVisual = record
        Thetype : GdkVisualType;
        depth : gint;
        byte_order : GdkByteOrder;
        colormap_size : gint;
        bits_per_rgb : gint;
        red_mask : guint32;
        red_shift : gint;
        red_prec : gint;
        green_mask : guint32;
        green_shift : gint;
        green_prec : gint;
        blue_mask : guint32;
        blue_shift : gint;
        blue_prec : gint;
     end;
     
   PGdkCursor = ^GdkCursor;
{$PACKRECORDS 4}
   GdkCursor = record
        Thetype : GdkCursorType;
     end;
   PGdkFont = ^GdkFont;
{$PACKRECORDS 4}
   GdkFont = record
        thetype : GdkFontType;
        ascent : gint;
        descent : gint;
     end;


   PGdkWindowAttr = ^GdkWindowAttr;
{$PACKRECORDS 4}
   GdkWindowAttr = record
        title : Pgchar;
        event_mask : gint;
        x : gint16;
        y : gint16;
        width : gint16;
        height : gint16;
        wclass : GdkWindowClass;
        visual : PGdkVisual;
        colormap : PGdkColormap;
        window_type : GdkWindowType;
        cursor : PGdkCursor;
        wmclass_name : Pgchar;
        wmclass_class : Pgchar;
        override_redirect : gboolean;
     end;
   PGdkWindow = ^GdkWindow;
{$PACKRECORDS 4}
   GdkWindow = record
        user_data : gpointer;
     end;
   GdkPixmap = GdkWindow;
   PGdkPixmap = ^GdkWindow;
   PPGdkPixmap = ^PGdkPixmap;
   GdkBitmap = GdkWindow;
   PGdkBitMap = ^GdkBitMap;
   PPGdkBitMap = ^PGdkBitMap;
   GdkDrawable = GdkWindow;
   PGdkDrawable = ^GdkDrawable;

   PGdkImage = ^GdkImage;
   PPGdkImage = ^PGdkImage;
{$PACKRECORDS 4}
   GdkImage = record
        thetype : GdkImageType;
        visual : PGdkVisual;
        byte_order : GdkByteOrder;
        width : guint16;
        height : guint16;
        depth : guint16;
        bpp : guint16;
        bpl : guint16;
        mem : gpointer;
     end;
   PGdkGCValues = ^GdkGCValues;
{$PACKRECORDS 4}
   GdkGCValues = record
        foreground : GdkColor;
        background : GdkColor;
        font : PGdkFont;
        theFunction  : GdkFunction;
        fill : GdkFill;
        tile : PGdkPixmap;
        stipple : PGdkPixmap;
        clip_mask : PGdkPixmap;
        subwindow_mode : GdkSubwindowMode;
        ts_x_origin : gint;
        ts_y_origin : gint;
        clip_x_origin : gint;
        clip_y_origin : gint;
        graphics_exposures : gint;
        line_width : gint;
        line_style : GdkLineStyle;
        cap_style : GdkCapStyle;
        join_style : GdkJoinStyle;
     end;
   PGdkGC = ^GdkGC;
{$PACKRECORDS 4}
   GdkGC = record
        dummy_var : gint;
     end;
   PGdkPoint = ^GdkPoint;
{$PACKRECORDS 2}
   GdkPoint = record
        x : gint16;
        y : gint16;
     end;
   PGdkRectangle = ^GdkRectangle;
{$PACKRECORDS 2}
   GdkRectangle = record
        x : gint16;
        y : gint16;
        width : guint16;
        height : guint16;
     end;
   PGdkSegment = ^GdkSegment;
{$PACKRECORDS 2}
   GdkSegment = record
        x1 : gint16;
        y1 : gint16;
        x2 : gint16;
        y2 : gint16;
     end;
   PGdkColorContextDither = ^GdkColorContextDither;
{$PACKRECORDS 4}
   GdkColorContextDither = record
        fast_rgb : array[0..(32)-1] of array[0..(32)-1] of array[0..(32)-1] of gint;
        fast_err : array[0..(32)-1] of array[0..(32)-1] of array[0..(32)-1] of gint;
        fast_erg : array[0..(32)-1] of array[0..(32)-1] of array[0..(32)-1] of gint;
        fast_erb : array[0..(32)-1] of array[0..(32)-1] of array[0..(32)-1] of gint;
     end;
   PGdkColorContext = ^GdkColorContext;
{$PACKRECORDS 4}
   GdkColorContext = record
        visual : PGdkVisual;
        colormap : PGdkColormap;
        num_colors : gint;
        max_colors : gint;
        num_allocated : gint;
        mode : GdkColorContextMode;
        need_to_free_colormap : gint;
        std_cmap_atom : GdkAtom;
        clut : Pgulong;
        cmap : PGdkColor;
        color_hash : PGHashTable;
        palette : PGdkColor;
        num_palette : gint;
        fast_dither : PGdkColorContextDither;
        shifts : record
             red : gint;
             green : gint;
             blue : gint;
          end;
        masks : record
             red : gulong;
             green : gulong;
             blue : gulong;
          end;
        bits : record
             red : gint;
             green : gint;
             blue : gint;
          end;
        max_entry : gulong;
        black_pixel : gulong;
        white_pixel : gulong;
     end;

   PGdkDeviceKey = ^GdkDeviceKey;
{$PACKRECORDS 4}
   GdkDeviceKey = record
        keyval : guint;
        modifiers : GdkModifierType;
     end;

   PGdkDeviceInfo = ^GdkDeviceInfo;
{$PACKRECORDS 4}
   GdkDeviceInfo = record
        deviceid : guint32;
        name : Pgchar;
        source : GdkInputSource;
        mode : GdkInputMode;
        has_cursor : gint;
        num_axes : gint;
        axes : PGdkAxisUse;
        num_keys : gint;
        keys : PGdkDeviceKey;
     end;
   PGdkTimeCoord = ^GdkTimeCoord;
{$PACKRECORDS 4}
   GdkTimeCoord = record
        time : guint32;
        x : gdouble;
        y : gdouble;
        pressure : gdouble;
        xtilt : gdouble;
        ytilt : gdouble;
     end;

   PGdkEvent = ^GdkEvent;

   PGdkEventAny = ^GdkEventAny;
{$PACKRECORDS 4}
   GdkEventAny = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
     end;

   PGdkEventExpose = ^GdkEventExpose;
{$PACKRECORDS 2}
   GdkEventExpose = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        area : GdkRectangle;
	pad1 : gint16;
        count : gint;
     end;

   PGdkEventNoExpose = ^GdkEventNoExpose;
{$PACKRECORDS 4}
   GdkEventNoExpose = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
     end;
   PGdkEventVisibility = ^GdkEventVisibility;
{$PACKRECORDS 4}
   GdkEventVisibility = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        state : GdkVisibilityState;
     end;
   PGdkEventMotion = ^GdkEventMotion;
{$PACKRECORDS 4}
   GdkEventMotion = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        time : guint32;
        x : gdouble;
        y : gdouble;
        pressure : gdouble;
        xtilt : gdouble;
        ytilt : gdouble;
        state : guint;
        is_hint : gint16;
        source : GdkInputSource;
        deviceid : guint32;
        x_root : gdouble;
        y_root : gdouble;
     end;
   PGdkEventButton = ^GdkEventButton;
{$PACKRECORDS 4}
   GdkEventButton = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        time : guint32;
        x : gdouble;
        y : gdouble;
        pressure : gdouble;
        xtilt : gdouble;
        ytilt : gdouble;
        state : guint;
        button : guint;
        source : GdkInputSource;
        deviceid : guint32;
        x_root : gdouble;
        y_root : gdouble;
     end;
   PGdkEventKey = ^GdkEventKey;
{$PACKRECORDS 4}
   GdkEventKey = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        time : guint32;
        state : guint;
        keyval : guint;
        length : gint;
        thestring : Pgchar;
     end;
   PGdkEventCrossing = ^GdkEventCrossing;
{$PACKRECORDS 4}
   GdkEventCrossing = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        subwindow : PGdkWindow;
        detail : GdkNotifyType;
     end;
   PGdkEventFocus = ^GdkEventFocus;
{$PACKRECORDS 4}
   GdkEventFocus = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        thein : gint16;
     end;
   PGdkEventConfigure = ^GdkEventConfigure;
{$PACKRECORDS 4}
   GdkEventConfigure = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        x : gint16;
        y : gint16;
        width : gint16;
        height : gint16;
     end;
   PGdkEventProperty = ^GdkEventProperty;
{$PACKRECORDS 4}
   GdkEventProperty = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        atom : GdkAtom;
        time : guint32;
        state : guint;
     end;
   PGdkEventSelection = ^GdkEventSelection;
{$PACKRECORDS 4}
   GdkEventSelection = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        selection : GdkAtom;
        target : GdkAtom;
        theproperty : GdkAtom;
        requestor : guint32;
        time : guint32;
     end;
   PGdkEventProximity = ^GdkEventProximity;
{$PACKRECORDS 4}
   GdkEventProximity = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        time : guint32;
        source : GdkInputSource;
        deviceid : guint32;
     end;
   PGdkEventDragRequest = ^GdkEventDragRequest;
{$PACKRECORDS 2}
   GdkEventDragRequest = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
	pad1 : gint16;
        requestor : guint32;
        u : record
            case longint of
               0 : ( flags:guint );
               1 : ( allflags:glong );
          end;
        isdrop : guint8;
        drop_coords : GdkPoint;
	pad2 : gint16;
        data_type : Pgchar;
        timestamp : guint32;
     end;
   PGdkEventDragBegin = ^GdkEventDragBegin;
{$PACKRECORDS 4}
   GdkEventDragBegin = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        u : record
            case longint of
               0 : ( flags:guint );
               1 : ( allflags:glong );
          end;
     end;

   PGdkEventDropEnter = ^GdkEventDropEnter;
{$PACKRECORDS 4}
   GdkEventDropEnter = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        requestor : guint32;
        u : record
            case longint of
               0 : ( flags:guint );
               1 : ( allflags:glong );
          end;
     end;
   PGdkEventDropLeave = ^GdkEventDropLeave;
{$PACKRECORDS 4}
   GdkEventDropLeave = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        requestor : guint32;
        u : record
            case longint of
               0 : ( flags:guint );
               1 : ( allflags:glong );
          end;
     end;
   PGdkEventDropDataAvailable = ^GdkEventDropDataAvailable;
{$PACKRECORDS 4}
   GdkEventDropDataAvailable = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        requestor : guint32;
        u : record
            case longint of
               0 : ( flags:guint );
               1 : ( allflags:glong );
          end;
        data_type : Pgchar;
        data_numbytes : gulong;
        data : gpointer;
        timestamp : guint32;
        coords : GdkPoint;
     end;
   PGdkEventClient = ^GdkEventClient;
{$PACKRECORDS 4}
   GdkEventClient = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        message_type : GdkAtom;
        data_format : gushort;
        data : record
            case longint of
               0 : ( b:array[0..(20)-1] of char );
               1 : ( s:array[0..(10)-1] of integer );
               2 : ( l:array[0..(5)-1] of longint );
          end;
     end;

   PGdkXevent = ^GdkXEvent;

   PGdkEventOther = ^GdkEventOther;
{$PACKRECORDS 4}
   GdkEventOther = record
        thetype : GdkEventType;
        window : PGdkWindow;
        send_event : gint8;
        xevent : PGdkXEvent;
     end;


{$PACKRECORDS 4}
   GdkEvent = record
       case longint of
          0 : ( thetype:GdkEventType );
          1 : ( any:GdkEventAny );
          2 : ( expose:GdkEventExpose );
          3 : ( no_expose:GdkEventNoExpose );
          4 : ( visibility:GdkEventVisibility );
          5 : ( motion:GdkEventMotion );
          6 : ( button:GdkEventButton );
          7 : ( key:GdkEventKey );
          8 : ( crossing:GdkEventCrossing );
          9 : ( focus_change:GdkEventFocus );
          10 : ( configure:GdkEventConfigure );
          11 : ( theproperty:GdkEventProperty );
          12 : ( selection:GdkEventSelection );
          13 : ( proximity:GdkEventProximity );
          14 : ( dragbegin:GdkEventDragBegin );
          15 : ( dragrequest:GdkEventDragRequest );
          16 : ( dropenter:GdkEventDropEnter );
          17 : ( dropleave:GdkEventDropLeave );
          18 : ( dropdataavailable:GdkEventDropDataAvailable );
          19 : ( client:GdkEventClient );
          20 : ( other:GdkEventOther );
     end;

  GdkXEvent = pointer;
  GdkFilterFunc = Function  ( xevent : pGdkXEvent;event : pGdkEvent; data : gpointer) : GdkFilterReturn; cdecl;

type
   PGdkRegion = ^GdkRegion;
{$PACKRECORDS 4}
   GdkRegion = record
        user_data : gpointer;
     end;

  implementation



end.
