unit glib;

{  Automatically converted by H2PAS.EXE from glib.h
   Utility made by Florian Klaempfl 25th-28th september 96
   Improvements made by Mark A. Malakanov 22nd-25th may 97 
   Further improvements by Michael Van Canneyt, April 1998 }


  interface

{$linklib glib}
{$linklib c}

{ Pointers to basic pascal types, inserted by h2pas conversion program.}
Type
  PLongint  = ^Longint;
  PByte     = ^Byte;
  PWord     = ^Word;
  PINteger  = ^Integer;
  PCardinal = ^Cardinal;
  PReal     = ^Real;
  PDouble   = ^Double;
  FLoat     = single;
  
{ GLIB - Library of useful routines for C programming
   Copyright (C) 1995-1997  Peter Mattis, Spencer Kimball and Josh MacDonald
  
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
  
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.
  
   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
 }

type
   PPgchar = ^Pgchar;
   Pgchar = ^gchar;
   gchar = char;
   Pgshort = ^gshort;
   gshort = integer;
   Pglong = ^glong;
   glong = longint;
   Pgint = ^gint;
   gint = longint;
   Pgboolean = ^gboolean;
   gboolean = char;
   Pguchar = ^guchar;
   guchar = char;
   Pgushort = ^gushort;
   gushort = word;
   Pgulong = ^gulong;
   gulong = cardinal;
   Pguint = ^guint;
   guint = cardinal;
   Pgfloat = ^gfloat;
   gfloat = float;
   Pgdouble = ^gdouble;
   gdouble = double;
   Pgpointer = ^gpointer;
   gpointer = pointer;

   gint8 = ShortInt;
   guint8 = byte;
   gint16 = integer;
   guint16 = word;
   gint32 = longint;
   guint32 = cardinal;

   pgint8 = ^ShortInt;
   pguint8 = ^byte;
   pgint16 = ^integer;
   pguint16 = ^word;
   pgint32 = ^longint;
   pguint32 = ^cardinal;

   PGFunc = ^GFunc;
   GFunc = Procedure(data:gpointer; user_data:gpointer); cdecl;
   PGHFunc = ^GHFunc;
   GHFunc = Procedure(key:gpointer; value:gpointer; user_data:gpointer); cdecl;
   PGHashFunc = ^GHashFunc;
   GHashFunc = Function (key:gpointer):guint; cdecl;
   PGCompareFunc = ^GCompareFunc;
   GCompareFunc = Function (a:gpointer; b:gpointer):gint; cdecl;
   PGCacheNewFunc = ^GCacheNewFunc;
   GCacheNewFunc = Function (key:gpointer):gpointer; cdecl;
   PGCacheDupFunc = ^GCacheDupFunc;
   GCacheDupFunc = Function (value:gpointer):gpointer; cdecl;
   PGCacheDestroyFunc = ^GCacheDestroyFunc;
   GCacheDestroyFunc = Procedure(value:gpointer); cdecl;
   PGTraverseFunc = ^GTraverseFunc;
   GTraverseFunc = Function (key:gpointer; value:gpointer; data:gpointer):gint; cdecl;
   PGSearchFunc = ^GSearchFunc;
   GSearchFunc = Function (key:gpointer; data:gpointer):gint; cdecl;
   PGErrorFunc = ^GErrorFunc;
   GErrorFunc = Procedure(str:Pgchar); cdecl;
   PGWarningFunc = ^GWarningFunc;
   GWarningFunc = Procedure(str:Pgchar); cdecl;
   PGPrintFunc = ^GPrintFunc;
   GPrintFunc = Procedure(str:Pgchar); cdecl;
   PGList = ^GList;
{$PACKRECORDS 4}
   GList = record
        data : gpointer;
        next : PGList;
        prev : PGList;
     end;
   PGSList = ^GSList;
{$PACKRECORDS 4}
   GSList = record
        data : gpointer;
        next : PGSList;
     end;
   PGString = ^GString;
{$PACKRECORDS 4}
   GString = record
        str : Pgchar;
        len : gint;
     end;
   PGArray = ^GArray;
{$PACKRECORDS 4}
   GArray = record
        data : Pgchar;
        len : guint;
     end;
   PGDebugKey = ^GDebugKey;
{$PACKRECORDS 4}
   GDebugKey = record
        key : Pgchar;
        value : guint;
     end;
   PGHashTable = ^GHashTable;
{$PACKRECORDS 4}
   GHashTable = record
        dummy : gint;
     end;
   PGCache = ^GCache;
{$PACKRECORDS 4}
   GCache = record
        dummy : gint;
     end;
   PGTree = ^GTree;
{$PACKRECORDS 4}
   GTree = record
        dummy : gint;
     end;
   PGTimer = ^GTimer;
{$PACKRECORDS 4}
   GTimer = record
        dummy : gint;
     end;
   PGMemChunk = ^GMemChunk;
{$PACKRECORDS 4}
   GMemChunk = record
        dummy : gint;
     end;
   PGListAllocator = ^GListAllocator;
{$PACKRECORDS 4}
   GListAllocator = record
        dummy : gint;
     end;
   PGStringChunk = ^GStringChunk;
{$PACKRECORDS 4}
   GStringChunk = record
        dummy : gint;
     end;
   PGTraverseType = ^GTraverseType;
   GTraverseType = (G_IN_ORDER,G_PRE_ORDER,G_POST_ORDER);

Function  g_list_alloc:PGList; cdecl;
Procedure g_list_free(list:PGList); cdecl;
Procedure g_list_free_1(list:PGList); cdecl;
Function  g_list_append(list:PGList; data:gpointer):PGList; cdecl;
Function  g_list_prepend(list:PGList; data:gpointer):PGList; cdecl;
Function  g_list_insert(list:PGList; data:gpointer; position:gint):PGList; cdecl;
Function  g_list_insert_sorted(list:PGList; data:gpointer; func:GCompareFunc):PGList; cdecl;
Function  g_list_concat(list1:PGList; list2:PGList):PGList; cdecl;
Function  g_list_remove(list:PGList; data:gpointer):PGList; cdecl;
Function  g_list_remove_link(list:PGList; link:PGList):PGList; cdecl;
Function  g_list_reverse(list:PGList):PGList; cdecl;
Function  g_list_nth(list:PGList; n:guint):PGList; cdecl;
Function  g_list_find(list:PGList; data:gpointer):PGList; cdecl;
Function  g_list_last(list:PGList):PGList; cdecl;
Function  g_list_first(list:PGList):PGList; cdecl;
Function  g_list_length(list:PGList):guint; cdecl;
Procedure g_list_foreach(list:PGList; func:GFunc; user_data:gpointer); cdecl;
{
#define g_list_previous(list) ((list) ? (((GList  )list)->prev) : NULL)
#define g_list_next(list) ((list) ? (((GList  )list)->next) : NULL)
}
Function  g_slist_alloc:PGSList; cdecl;
Procedure g_slist_free(list:PGSList); cdecl;
Procedure g_slist_free_1(list:PGSList); cdecl;
Function  g_slist_append(list:PGSList; data:gpointer):PGSList; cdecl;
Function  g_slist_prepend(list:PGSList; data:gpointer):PGSList; cdecl;
Function  g_slist_insert(list:PGSList; data:gpointer; position:gint):PGSList; cdecl;
Function  g_slist_insert_sorted(list:PGSList; data:gpointer; func:GCompareFunc):PGSList; cdecl;
Function  g_slist_concat(list1:PGSList; list2:PGSList):PGSList; cdecl;
Function  g_slist_remove(list:PGSList; data:gpointer):PGSList; cdecl;
Function  g_slist_remove_link(list:PGSList; link:PGSList):PGSList; cdecl;
Function  g_slist_reverse(list:PGSList):PGSList; cdecl;
Function  g_slist_nth(list:PGSList; n:guint):PGSList; cdecl;
Function  g_slist_find(list:PGSList; data:gpointer):PGSList; cdecl;
Function  g_slist_last(list:PGSList):PGSList; cdecl;
Function  g_slist_length(list:PGSList):guint; cdecl;
Procedure g_slist_foreach(list:PGSList; func:GFunc; user_data:gpointer); cdecl;
{
#define g_slist_next(list) ((list) ? (((GSList  )list)->next) : NULL)
}
Function  g_list_allocator_new:PGListAllocator; cdecl;
Procedure g_list_allocator_free(allocator:PGListAllocator); cdecl;
Function  g_slist_set_allocator(allocator:PGListAllocator):PGListAllocator; cdecl;
Function  g_list_set_allocator(allocator:PGListAllocator):PGListAllocator; cdecl;
Function  g_hash_table_new(hash_func:GHashFunc; key_compare_func:GCompareFunc):PGHashTable; cdecl;
Procedure g_hash_table_destroy(hash_table:PGHashTable); cdecl;
Procedure g_hash_table_insert(hash_table:PGHashTable; key:gpointer; value:gpointer); cdecl;
Procedure g_hash_table_remove(hash_table:PGHashTable; key:gpointer); cdecl;
Function  g_hash_table_lookup(hash_table:PGHashTable; key:gpointer):gpointer; cdecl;
Procedure g_hash_table_freeze(hash_table:PGHashTable); cdecl;
Procedure g_hash_table_thaw(hash_table:PGHashTable); cdecl;
Procedure g_hash_table_foreach(hash_table:PGHashTable; func:GHFunc; user_data:gpointer); cdecl;
Function  g_cache_new(value_new_func:GCacheNewFunc; value_destroy_func:GCacheDestroyFunc; key_dup_func:GCacheDupFunc; key_destroy_func:GCacheDestroyFunc; hash_key_func:GHashFunc; hash_value_func:GHashFunc; key_compare_func:GCompareFunc):PGCache; cdecl;
Procedure g_cache_destroy(cache:PGCache); cdecl;
Function  g_cache_insert(cache:PGCache; key:gpointer):gpointer; cdecl;
Procedure g_cache_remove(cache:PGCache; value:gpointer); cdecl;
Procedure g_cache_key_foreach(cache:PGCache; func:GHFunc; user_data:gpointer); cdecl;
Procedure g_cache_value_foreach(cache:PGCache; func:GHFunc; user_data:gpointer); cdecl;
Function  g_tree_new(key_compare_func:GCompareFunc):PGTree; cdecl;
Procedure g_tree_destroy(tree:PGTree); cdecl;
Procedure g_tree_insert(tree:PGTree; key:gpointer; value:gpointer); cdecl;
Procedure g_tree_remove(tree:PGTree; key:gpointer); cdecl;
Function  g_tree_lookup(tree:PGTree; key:gpointer):gpointer; cdecl;
Procedure g_tree_traverse(tree:PGTree; traverse_func:GTraverseFunc; traverse_type:GTraverseType; data:gpointer); cdecl;
Function  g_tree_search(tree:PGTree; search_func:GSearchFunc; data:gpointer):gpointer; cdecl;
Function  g_tree_height(tree:PGTree):gint; cdecl;
Function  g_tree_nnodes(tree:PGTree):gint; cdecl;
Function  g_malloc(size:gulong):gpointer; cdecl;
Function  g_malloc0(size:gulong):gpointer; cdecl;
Function  g_realloc(mem:gpointer; size:gulong):gpointer; cdecl;
Procedure g_free(mem:gpointer); cdecl;
Procedure g_mem_profile; cdecl;
Procedure g_mem_check(mem:gpointer); cdecl;

const
   G_ALLOC_ONLY = 1;
   G_ALLOC_AND_FREE = 2;

Function  g_mem_chunk_new(name:Pgchar; atom_size:gint; area_size:gulong; thetype:gint):PGMemChunk; cdecl;
Procedure g_mem_chunk_destroy(mem_chunk:PGMemChunk); cdecl;
Function  g_mem_chunk_alloc(mem_chunk:PGMemChunk):gpointer; cdecl;
Procedure g_mem_chunk_free(mem_chunk:PGMemChunk; mem:gpointer); cdecl;
Procedure g_mem_chunk_clean(mem_chunk:PGMemChunk); cdecl;
Procedure g_mem_chunk_reset(mem_chunk:PGMemChunk); cdecl;
Procedure g_mem_chunk_print(mem_chunk:PGMemChunk); cdecl;
Procedure g_mem_chunk_info; cdecl;
Procedure g_blow_chunks; cdecl;
Function  g_timer_new:PGTimer; cdecl;
Procedure g_timer_destroy(timer:PGTimer); cdecl;
Procedure g_timer_start(timer:PGTimer); cdecl;
Procedure g_timer_stop(timer:PGTimer); cdecl;
Procedure g_timer_reset(timer:PGTimer); cdecl;
Function  g_timer_elapsed(timer:PGTimer; microseconds:Pgulong):gdouble; cdecl;
Function  g_strtod(nptr:Pgchar; endptr:PPgchar):gdouble; cdecl;
Function  g_strerror(errnum:gint):Pgchar; cdecl;
Function  g_strsignal(signum:gint):Pgchar; cdecl;
Function  g_strcasecmp(s1:Pgchar; s2:Pgchar):gint; cdecl;
Function  g_set_error_handler(func:GErrorFunc):GErrorFunc; cdecl;
Function  g_set_warning_handler(func:GWarningFunc):GWarningFunc; cdecl;
Function  g_set_message_handler(func:GPrintFunc):GPrintFunc; cdecl;
Function  g_set_print_handler(func:GPrintFunc):GPrintFunc; cdecl;
Function  g_parse_debug_string(TheString:Pgchar; keys:PGDebugKey; nkeys:guint):guint; cdecl;
Procedure g_debug(progname:Pchar); cdecl;
Procedure g_attach_process(progname:Pchar; query:longint); cdecl;
Procedure g_stack_trace(progname:Pchar; query:longint); cdecl;
Function  g_string_chunk_new(size:gint):PGStringChunk; cdecl;
Procedure g_string_chunk_free(chunk:PGStringChunk); cdecl;
Function  g_string_chunk_insert(chunk:PGStringChunk; thestring:Pgchar):Pgchar; cdecl;
Function  g_string_chunk_insert_const(chunk:PGStringChunk; thestring:Pgchar):Pgchar; cdecl;
Function  g_string_new(init:Pgchar):PGString; cdecl;
Procedure g_string_free(thestring:PGString; free_segment:gint); cdecl;
Function  g_string_assign(lval:PGString; rval:Pgchar):PGString; cdecl;
Function  g_string_truncate(thestring:PGString; len:gint):PGString; cdecl;
Function  g_string_append(thestring:PGString; val:Pgchar):PGString; cdecl;
Function  g_string_append_c(thestring:PGString; c:gchar):PGString; cdecl;
Function  g_string_prepend(thestring:PGString; val:Pgchar):PGString; cdecl;
Function  g_string_prepend_c(thestring:PGString; c:gchar):PGString; cdecl;
Function  g_string_insert(fthestring:PGString; pos:gint; val:Pgchar):PGString; cdecl;
Function  g_string_insert_c(fthestring:PGString; pos:gint; c:gchar):PGString; cdecl;
Function  g_string_erase(fthestring:PGString; pos:gint; len:gint):PGString; cdecl;
{
#if __GNUC__ > 2 || (__GNUC__ == 2 && __GNUC_MINOR__ > 4)
void	 g_string_sprintf   (GString  string,
			     gchar    fmt,
			     ...) __attribute__ ((format (printf, 2, 3)));

void	 g_string_sprintfa  (GString  string,
			     gchar    fmt,
			     ...) __attribute__ ((format (printf, 2, 3)));
#else
void	 g_string_sprintf   (GString  string,
			     gchar    fmt,
			     ...);

void	 g_string_sprintfa  (GString  string,
			     gchar    fmt,
			     ...);
#endif
}
{ Resizable arrays
 }
{
#define g_array_append_val(array,type,val) \
     g_rarray_append (array, (gpointer) &val, sizeof (type))
#define g_array_append_vals(array,type,vals,nvals) \
     g_rarray_append (array, (gpointer) vals, sizeof (type)   nvals)
#define g_array_prepend_val(array,type,val) \
     g_rarray_prepend (array, (gpointer) &val, sizeof (type))
#define g_array_prepend_vals(array,type,vals,nvals) \
     g_rarray_prepend (array, (gpointer) vals, sizeof (type)   nvals)
#define g_array_truncate(array,type,length) \
     g_rarray_truncate (array, length, sizeof (type))
#define g_array_index(array,type,index) \
     ((type ) array->data)[index]
}
Function  g_array_new(zero_terminated:gint):PGArray; cdecl;
Procedure g_array_free(thearray:PGArray; free_segment:gint); cdecl;
Function  g_rarray_append(thearray:PGArray; data:gpointer; size:gint):PGArray; cdecl;
Function  g_rarray_prepend(thearray:PGArray; data:gpointer; size:gint):PGArray; cdecl;
Function  g_rarray_truncate(thearray:PGArray; length:gint; size:gint):PGArray; cdecl;

Function  g_str_equal(v:gpointer; v2:gpointer):gint; cdecl;
Function  g_str_hash(v:gpointer):guint; cdecl;
Function  g_direct_hash(key:gpointer):guint; cdecl;

{ Character sets }

const
   G_CSET_UA_2_Z = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
{
#define G_CSET_LATINC	"\300\301\302\303\304\305\306"\
			"\307\310\311\312\313\314\315\316\317\320"\
			"\321\322\323\324\325\326"\
			"\330\331\332\333\334\335\336"
#define G_CSET_LATINS	"\337\340\341\342\343\344\345\346"\
			"\347\350\351\352\353\354\355\356\357\360"\
			"\361\362\363\364\365\366"\
			"\370\371\372\373\374\375\376\377"
}
{
typedef union	_GValue		GValue;
typedef struct	_GScannerConfig GScannerConfig;
typedef struct	_GScanner	GScanner;
}
   G_CSET_a_2_z = 'abcdefghijklmnopqrstuvwxyz';

type
   PGErrorType = ^GErrorType;
   GErrorType = (G_ERR_UNKNOWN,G_ERR_UNEXP_EOF,G_ERR_UNEXP_EOF_IN_STRING,
     G_ERR_UNEXP_EOF_IN_COMMENT,
     G_ERR_NON_DIGIT_IN_CONST,
     G_ERR_DIGIT_RADIX,
     G_ERR_FLOAT_RADIX,
     G_ERR_FLOAT_MALFORMED
     );

 
GTokenType = (
  G_TOKEN_EOF			:=   0,
  G_TOKEN_LEFT_PAREN		:= ord('('),
  G_TOKEN_RIGHT_PAREN		:= ord(')'),
  G_TOKEN_LEFT_CURLY		:= ord('{'),
  G_TOKEN_RIGHT_CURLY		:= ord('}'),
  G_TOKEN_LEFT_BRACE		:= ord('['),
  G_TOKEN_RIGHT_BRACE		:= ord(']'),
  G_TOKEN_EQUAL_SIGN		:= ord('='),
  G_TOKEN_COMMA			:= ord(','),
  
  G_TOKEN_NONE			:= 256,
  
  G_TOKEN_ERROR,
  
  G_TOKEN_CHAR,
  G_TOKEN_BINARY,
  G_TOKEN_OCTAL,
  G_TOKEN_INT,
  G_TOKEN_HEX,
  G_TOKEN_FLOAT,
  G_TOKEN_STRING,
  
  G_TOKEN_SYMBOL,
  G_TOKEN_IDENTIFIER,
  G_TOKEN_IDENTIFIER_NULL,
  
  G_TOKEN_COMMENT_SINGLE,
  G_TOKEN_COMMENT_MULTI,
  G_TOKEN_LAST
);

   PGvalue = ^GValue;
{$PACKRECORDS 4}
   GValue = record
       case longint of
          0 : ( v_symbol:gpointer );
          1 : ( v_identifier:^gchar );
          2 : ( v_binary:gulong );
          3 : ( v_octal:gulong );
          4 : ( v_int:gulong );
          5 : ( v_float:gdouble );
          6 : ( v_hex:gulong );
          7 : ( v_string:^gchar );
          8 : ( v_comment:^gchar );
          9 : ( v_char:guchar );
          10 : ( v_error:guint );
     end;

PGScannerConfig = ^GScannerConfig;
GScannerConfig = Record
  	 cset_skip_characters,		
  	 cset_identifier_first,
  	 cset_identifier_nth,
  	 cpair_comment_single : char;
         flags : guint;
{
  guint		case_sensitive : 1;
  guint		skip_comment_multi : 1;		
  guint		skip_comment_single : 1;	
  guint		scan_comment_multi : 1;
  guint		scan_identifier : 1;
  guint		scan_identifier_1char : 1;
  guint		scan_identifier_NULL : 1;
  guint		scan_symbols : 1;
  guint		scan_binary : 1;
  guint		scan_octal : 1;
  guint		scan_float : 1;
  guint		scan_hex : 1;
  guint		scan_hex_dollar : 1;
  guint		scan_string_sq : 1;
  guint		scan_string_dq : 1;
  guint		numbers_2_int : 1;		
  guint		int_2_float : 1;
  guint		identifier_2_string : 1;
  guint		char_2_token : 1;
  guint		symbol_2_token : 1;
} 
end;

   PGScanner = ^GScanner;
{$PACKRECORDS 4}
   GScanner = record
        user_data : gpointer;
        input_name : Pgchar;
        parse_errors : guint;
        max_parse_errors : guint;
        config : PGScannerConfig;
        token : GTokenType;
        value : GValue;
        line : guint;
        position : guint;
        next_token : GTokenType;
        next_value : GValue;
        next_line : guint;
        next_position : guint;
        symbol_table : PGHashTable;
        text : Pgchar;
        text_len : guint;
        input_fd : gint;
        peeked_char : gint;
     end;

Function  g_scanner_new(config_templ:PGScannerConfig):PGScanner; cdecl;
Procedure g_scanner_destroy(scanner:PGScanner); cdecl;
Procedure g_scanner_input_file(scanner:PGScanner; input_fd:gint); cdecl;
Procedure g_scanner_input_text(scanner:PGScanner; text:Pgchar; text_len:guint); cdecl;
Function  g_scanner_get_next_token(scanner:PGScanner):GTokenType; cdecl;
Function  g_scanner_peek_next_token(scanner:PGScanner):GTokenType; cdecl;
Function  g_scanner_cur_token(scanner:PGScanner):GTokenType; cdecl;
Function  g_scanner_cur_value(scanner:PGScanner):GValue; cdecl;
Function  g_scanner_cur_line(scanner:PGScanner):guint; cdecl;
Function  g_scanner_cur_position(scanner:PGScanner):guint; cdecl;
Function  g_scanner_eof(scanner:PGScanner):gboolean; cdecl;
Procedure g_scanner_add_symbol(scanner:PGScanner; symbol:Pgchar; value:gpointer); cdecl;
Function  g_scanner_lookup_symbol(scanner:PGScanner; symbol:Pgchar):gpointer; cdecl;
Procedure g_scanner_remove_symbol(scanner:PGScanner; symbol:Pgchar); cdecl;

  implementation


function g_list_alloc:PGList;cdecl;external;
procedure g_list_free(list:PGList);cdecl;external;
procedure g_list_free_1(list:PGList);cdecl;external;
function g_list_append(list:PGList; data:gpointer):PGList;cdecl;external;
function g_list_prepend(list:PGList; data:gpointer):PGList;cdecl;external;
function g_list_insert(list:PGList; data:gpointer; position:gint):PGList;cdecl;external;
function g_list_insert_sorted(list:PGList; data:gpointer; func:GCompareFunc):PGList;cdecl;external;
function g_list_concat(list1:PGList; list2:PGList):PGList;cdecl;external;
function g_list_remove(list:PGList; data:gpointer):PGList;cdecl;external;
function g_list_remove_link(list:PGList; link:PGList):PGList;cdecl;external;
function g_list_reverse(list:PGList):PGList;cdecl;external;
function g_list_nth(list:PGList; n:guint):PGList;cdecl;external;
function g_list_find(list:PGList; data:gpointer):PGList;cdecl;external;
function g_list_last(list:PGList):PGList;cdecl;external;
function g_list_first(list:PGList):PGList;cdecl;external;
function g_list_length(list:PGList):guint;cdecl;external;
procedure g_list_foreach(list:PGList; func:GFunc; user_data:gpointer);cdecl;external;
function g_slist_alloc:PGSList;cdecl;external;
procedure g_slist_free(list:PGSList);cdecl;external;
procedure g_slist_free_1(list:PGSList);cdecl;external;
function g_slist_append(list:PGSList; data:gpointer):PGSList;cdecl;external;
function g_slist_prepend(list:PGSList; data:gpointer):PGSList;cdecl;external;
function g_slist_insert(list:PGSList; data:gpointer; position:gint):PGSList;cdecl;external;
function g_slist_insert_sorted(list:PGSList; data:gpointer; func:GCompareFunc):PGSList;cdecl;external;
function g_slist_concat(list1:PGSList; list2:PGSList):PGSList;cdecl;external;
function g_slist_remove(list:PGSList; data:gpointer):PGSList;cdecl;external;
function g_slist_remove_link(list:PGSList; link:PGSList):PGSList;cdecl;external;
function g_slist_reverse(list:PGSList):PGSList;cdecl;external;
function g_slist_nth(list:PGSList; n:guint):PGSList;cdecl;external;
function g_slist_find(list:PGSList; data:gpointer):PGSList;cdecl;external;
function g_slist_last(list:PGSList):PGSList;cdecl;external;
function g_slist_length(list:PGSList):guint;cdecl;external;
procedure g_slist_foreach(list:PGSList; func:GFunc; user_data:gpointer);cdecl;external;
function g_list_allocator_new:PGListAllocator;cdecl;external;
procedure g_list_allocator_free(allocator:PGListAllocator);cdecl;external;
function g_slist_set_allocator(allocator:PGListAllocator):PGListAllocator;cdecl;external;
function g_list_set_allocator(allocator:PGListAllocator):PGListAllocator;cdecl;external;
function g_hash_table_new(hash_func:GHashFunc; key_compare_func:GCompareFunc):PGHashTable;cdecl;external;
procedure g_hash_table_destroy(hash_table:PGHashTable);cdecl;external;
procedure g_hash_table_insert(hash_table:PGHashTable; key:gpointer; value:gpointer);cdecl;external;
procedure g_hash_table_remove(hash_table:PGHashTable; key:gpointer);cdecl;external;
function g_hash_table_lookup(hash_table:PGHashTable; key:gpointer):gpointer;cdecl;external;
procedure g_hash_table_freeze(hash_table:PGHashTable);cdecl;external;
procedure g_hash_table_thaw(hash_table:PGHashTable);cdecl;external;
procedure g_hash_table_foreach(hash_table:PGHashTable; func:GHFunc; user_data:gpointer);cdecl;external;
function g_cache_new(value_new_func:GCacheNewFunc; value_destroy_func:GCacheDestroyFunc; key_dup_func:GCacheDupFunc; key_destroy_func:GCacheDestroyFunc; hash_key_func:GHashFunc; hash_value_func:GHashFunc; key_compare_func:GCompareFunc):PGCache;cdecl;external;
procedure g_cache_destroy(cache:PGCache);cdecl;external;
function g_cache_insert(cache:PGCache; key:gpointer):gpointer;cdecl;external;
procedure g_cache_remove(cache:PGCache; value:gpointer);cdecl;external;
procedure g_cache_key_foreach(cache:PGCache; func:GHFunc; user_data:gpointer);cdecl;external;
procedure g_cache_value_foreach(cache:PGCache; func:GHFunc; user_data:gpointer);cdecl;external;
function g_tree_new(key_compare_func:GCompareFunc):PGTree;cdecl;external;
procedure g_tree_destroy(tree:PGTree);cdecl;external;
procedure g_tree_insert(tree:PGTree; key:gpointer; value:gpointer);cdecl;external;
procedure g_tree_remove(tree:PGTree; key:gpointer);cdecl;external;
function g_tree_lookup(tree:PGTree; key:gpointer):gpointer;cdecl;external;
procedure g_tree_traverse(tree:PGTree; traverse_func:GTraverseFunc; traverse_type:GTraverseType; data:gpointer);cdecl;external;
function g_tree_search(tree:PGTree; search_func:GSearchFunc; data:gpointer):gpointer;cdecl;external;
function g_tree_height(tree:PGTree):gint;cdecl;external;
function g_tree_nnodes(tree:PGTree):gint;cdecl;external;
function g_malloc(size:gulong):gpointer;cdecl;external;
function g_malloc0(size:gulong):gpointer;cdecl;external;
function g_realloc(mem:gpointer; size:gulong):gpointer;cdecl;external;
procedure g_free(mem:gpointer);cdecl;external;
procedure g_mem_profile;cdecl;external;
procedure g_mem_check(mem:gpointer);cdecl;external;
function g_mem_chunk_new(name:Pgchar; atom_size:gint; area_size:gulong; thetype:gint):PGMemChunk;cdecl;external;
procedure g_mem_chunk_destroy(mem_chunk:PGMemChunk);cdecl;external;
function g_mem_chunk_alloc(mem_chunk:PGMemChunk):gpointer;cdecl;external;
procedure g_mem_chunk_free(mem_chunk:PGMemChunk; mem:gpointer);cdecl;external;
procedure g_mem_chunk_clean(mem_chunk:PGMemChunk);cdecl;external;
procedure g_mem_chunk_reset(mem_chunk:PGMemChunk);cdecl;external;
procedure g_mem_chunk_print(mem_chunk:PGMemChunk);cdecl;external;
procedure g_mem_chunk_info;cdecl;external;
procedure g_blow_chunks;cdecl;external;
function g_timer_new:PGTimer;cdecl;external;
procedure g_timer_destroy(timer:PGTimer);cdecl;external;
procedure g_timer_start(timer:PGTimer);cdecl;external;
procedure g_timer_stop(timer:PGTimer);cdecl;external;
procedure g_timer_reset(timer:PGTimer);cdecl;external;
function g_timer_elapsed(timer:PGTimer; microseconds:Pgulong):gdouble;cdecl;external;
function g_strtod(nptr:Pgchar; endptr:PPgchar):gdouble;cdecl;external;
function g_strerror(errnum:gint):Pgchar;cdecl;external;
function g_strsignal(signum:gint):Pgchar;cdecl;external;
function g_strcasecmp(s1:Pgchar; s2:Pgchar):gint;cdecl;external;
function g_set_error_handler(func:GErrorFunc):GErrorFunc;cdecl;external;
function g_set_warning_handler(func:GWarningFunc):GWarningFunc;cdecl;external;
function g_set_message_handler(func:GPrintFunc):GPrintFunc;cdecl;external;
function g_set_print_handler(func:GPrintFunc):GPrintFunc;cdecl;external;
function g_parse_debug_string(TheString:Pgchar; keys:PGDebugKey; nkeys:guint):guint;cdecl;external;
procedure g_debug(progname:Pchar);cdecl;external;
procedure g_attach_process(progname:Pchar; query:longint);cdecl;external;
procedure g_stack_trace(progname:Pchar; query:longint);cdecl;external;
function g_string_chunk_new(size:gint):PGStringChunk;cdecl;external;
procedure g_string_chunk_free(chunk:PGStringChunk);cdecl;external;
function g_string_chunk_insert(chunk:PGStringChunk; thestring:Pgchar):Pgchar;cdecl;external;
function g_string_chunk_insert_const(chunk:PGStringChunk; thestring:Pgchar):Pgchar;cdecl;external;
function g_string_new(init:Pgchar):PGString;cdecl;external;
procedure g_string_free(thestring:PGString; free_segment:gint);cdecl;external;
function g_string_assign(lval:PGString; rval:Pgchar):PGString;cdecl;external;
function g_string_truncate(thestring:PGString; len:gint):PGString;cdecl;external;
function g_string_append(thestring:PGString; val:Pgchar):PGString;cdecl;external;
function g_string_append_c(thestring:PGString; c:gchar):PGString;cdecl;external;
function g_string_prepend(thestring:PGString; val:Pgchar):PGString;cdecl;external;
function g_string_prepend_c(thestring:PGString; c:gchar):PGString;cdecl;external;
function g_string_insert(fthestring:PGString; pos:gint; val:Pgchar):PGString;cdecl;external;
function g_string_insert_c(fthestring:PGString; pos:gint; c:gchar):PGString;cdecl;external;
function g_string_erase(fthestring:PGString; pos:gint; len:gint):PGString;cdecl;external;
function g_array_new(zero_terminated:gint):PGArray;cdecl;external;
procedure g_array_free(thearray:PGArray; free_segment:gint);cdecl;external;
function g_rarray_append(thearray:PGArray; data:gpointer; size:gint):PGArray;cdecl;external;
function g_rarray_prepend(thearray:PGArray; data:gpointer; size:gint):PGArray;cdecl;external;
function g_rarray_truncate(thearray:PGArray; length:gint; size:gint):PGArray;cdecl;external;

function g_str_equal(v:gpointer; v2:gpointer):gint;cdecl;external;
function g_str_hash(v:gpointer):guint;cdecl;external;
function g_direct_hash(key:gpointer):guint;cdecl;external;
function g_scanner_new(config_templ:PGScannerConfig):PGScanner;cdecl;external;
procedure g_scanner_destroy(scanner:PGScanner);cdecl;external;
procedure g_scanner_input_file(scanner:PGScanner; input_fd:gint);cdecl;external;
procedure g_scanner_input_text(scanner:PGScanner; text:Pgchar; text_len:guint);cdecl;external;
function g_scanner_get_next_token(scanner:PGScanner):GTokenType;cdecl;external;
function g_scanner_peek_next_token(scanner:PGScanner):GTokenType;cdecl;external;
function g_scanner_cur_token(scanner:PGScanner):GTokenType;cdecl;external;
function g_scanner_cur_value(scanner:PGScanner):GValue;cdecl;external;
function g_scanner_cur_line(scanner:PGScanner):guint;cdecl;external;
function g_scanner_cur_position(scanner:PGScanner):guint;cdecl;external;
function g_scanner_eof(scanner:PGScanner):gboolean;cdecl;external;
procedure g_scanner_add_symbol(scanner:PGScanner; symbol:Pgchar; value:gpointer);cdecl;external;
function g_scanner_lookup_symbol(scanner:PGScanner; symbol:Pgchar):gpointer;cdecl;external;
procedure g_scanner_remove_symbol(scanner:PGScanner; symbol:Pgchar);cdecl;external;


end.
