unit gtkbox;

  interface

uses gtkcontainer,gtkwidget,glib,gtkenums;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_BOX(obj)          GTK_CHECK_CAST (obj, gtk_box_get_type (), GtkBox)
    #define GTK_BOX_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_box_get_type (), GtkBoxClass)
    #define GTK_IS_BOX(obj)       GTK_CHECK_TYPE (obj, gtk_box_get_type ())
    }

    type

       PGtkBox = ^TGtkBox;
{$PACKRECORDS 4}
       TGtkBox = record
            container : TGtkContainer;
            children : PGList;
            spacing : gint16;
            flag0 : word;
         end;

    const
       bm_homogeneous = 1;
       bp_homogeneous = 0;
    Function  homogeneous(var a : TGtkBox) : guint; 
    Procedure set_homogeneous(var a : TGtkBox; __homogeneous : guint); 

    type
       PGtkBoxClass = ^TGtkBoxClass;
{$PACKRECORDS 4}
       TGtkBoxClass = record
            parent_class : TGtkContainerClass;
         end;

       PGtkBoxChild = ^TGtkBoxChild;
{$PACKRECORDS 4}
       TGtkBoxChild = record
            widget : PGtkWidget;
            padding : guint16;
            flag0 : word;
         end;

    const
       bm_expand = 1;
       bp_expand = 0;
       bm_fill = 2;
       bp_fill = 1;
       bm_pack = 4;
       bp_pack = 2;
    Function  expand(var a : TGtkBoxChild) : guint; 
    Procedure set_expand(var a : TGtkBoxChild; __expand : guint);
    Function  fill(var a : TGtkBoxChild) : guint; 
    Procedure set_fill(var a : TGtkBoxChild; __fill : guint);
    Function  pack(var a : TGtkBoxChild) : guint;
    Procedure set_pack(var a : TGtkBoxChild; __pack : guint);

    Function  gtk_box_get_type:guint; cdecl;

    Procedure gtk_box_pack_start(box:pGtkBox; child:pGtkWidget; expand:gint; fill:gint; padding:gint); cdecl;

    Procedure gtk_box_pack_end(box:pGtkBox; child:pGtkWidget; expand:gint; fill:gint; padding:gint); cdecl;

    Procedure gtk_box_pack_start_defaults(box:pGtkBox; widget:pGtkWidget); cdecl;

    Procedure gtk_box_pack_end_defaults(box:pGtkBox; widget:pGtkWidget); cdecl;

    Procedure gtk_box_set_homogeneous(box:pGtkBox; homogeneous:gint); cdecl;

    Procedure gtk_box_set_spacing(box:pGtkBox; spacing:gint); cdecl;

    Procedure gtk_box_reorder_child(box:pGtkBox; child:pGtkWidget; pos:guint); cdecl;

    Procedure gtk_box_query_child_packing(box:pGtkBox; child:pGtkWidget; expand:pgint; fill:pgint; padding:pgint; pack_type:pGtkPackType); cdecl;

    Procedure gtk_box_set_child_packing(box:pGtkBox; child:pGtkWidget; expand:gint; fill:gint; padding:gint; pack_type:GtkPackType); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

    function homogeneous(var a : TGtkBox) : guint;
      begin
         homogeneous:=(a.flag0 and bm_homogeneous) shr bp_homogeneous;
      end;

    procedure set_homogeneous(var a : TGtkBox; __homogeneous : guint);
      begin
         a.flag0:=a.flag0 or ((__homogeneous shl bp_homogeneous) and bm_homogeneous);
      end;

    function expand(var a : TGtkBoxChild) : guint;
      begin
         expand:=(a.flag0 and bm_expand) shr bp_expand;
      end;

    procedure set_expand(var a : TGtkBoxChild; __expand : guint);
      begin
         a.flag0:=a.flag0 or ((__expand shl bp_expand) and bm_expand);
      end;

    function fill(var a : TGtkBoxChild) : guint;
      begin
         fill:=(a.flag0 and bm_fill) shr bp_fill;
      end;

    procedure set_fill(var a : TGtkBoxChild; __fill : guint);
      begin
         a.flag0:=a.flag0 or ((__fill shl bp_fill) and bm_fill);
      end;

    function pack(var a : TGtkBoxChild) : guint;
      begin
         pack:=(a.flag0 and bm_pack) shr bp_pack;
      end;

    procedure set_pack(var a : TGtkBoxChild; __pack : guint);
      begin
         a.flag0:=a.flag0 or ((__pack shl bp_pack) and bm_pack);
      end;

    function gtk_box_get_type:guint;CDECL; external;

    procedure gtk_box_pack_start(box:pGtkBox; child:pGtkWidget; expand:gint; fill:gint; padding:gint);CDECL; external;

    procedure gtk_box_pack_end(box:pGtkBox; child:pGtkWidget; expand:gint; fill:gint; padding:gint);CDECL; external;

    procedure gtk_box_pack_start_defaults(box:pGtkBox; widget:pGtkWidget);CDECL; external;

    procedure gtk_box_pack_end_defaults(box:pGtkBox; widget:pGtkWidget);CDECL; external;

    procedure gtk_box_set_homogeneous(box:pGtkBox; homogeneous:gint);CDECL; external;

    procedure gtk_box_set_spacing(box:pGtkBox; spacing:gint);CDECL; external;

    procedure gtk_box_reorder_child(box:pGtkBox; child:pGtkWidget; pos:guint);CDECL; external;

    procedure gtk_box_query_child_packing(box:pGtkBox; child:pGtkWidget; expand:pgint; fill:pgint; padding:pgint; 
                pack_type:pGtkPackType);CDECL; external;

    procedure gtk_box_set_child_packing(box:pGtkBox; child:pGtkWidget; expand:gint; fill:gint; padding:gint; 
                pack_type:GtkPackType);CDECL; external;


end.
