unit gtkbutton;

  interface

uses gdk,gtkcontainer,gtkwidget,glib;

    { Pointers to basic pascal types, inserted by h2pas conversion program.}
    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_BUTTON(obj)          (GTK_CHECK_CAST ((obj), gtk_button_get_type (), GtkButton))
    #define GTK_BUTTON_CLASS(klass)  (GTK_CHECK_CLASS_CAST ((klass), gtk_button_get_type (), GtkButtonClass))
    #define GTK_IS_BUTTON(obj)       (GTK_CHECK_TYPE ((obj), gtk_button_get_type ()))
    }

    type

       PGtkButton = ^TGtkButton;
{$PACKRECORDS 4}
       TGtkButton = record
            container : TGtkContainer;
            child : PGtkWidget;
            flag0 : word;
         end;

    const
       bm_in_button = 1;
       bp_in_button = 0;
       bm_button_down = 2;
       bp_button_down = 1;
    Function  in_button(var a : TGtkButton) : guint;
    Procedure set_in_button(var a : TGtkButton; __in_button : guint); 
    Function  button_down(var a : TGtkButton) : guint; 
    Procedure set_button_down(var a : TGtkButton; __button_down : guint);

    type
       PGtkButtonClass = ^TGtkButtonClass;
{$PACKRECORDS 4}
       TGtkButtonClass = record
            parent_class : TGtkContainerClass;
            pressed : Procedure (button:pGtkButton); cdecl;
            released : Procedure (button:pGtkButton); cdecl;
            clicked : Procedure (button:pGtkButton); cdecl;
            enter : Procedure (button:pGtkButton); cdecl;
            leave : Procedure (button:pGtkButton); cdecl;
         end;


    Function  gtk_button_get_type:guint; cdecl;


    Function   gtk_button_new : PGtkWidget; cdecl;
    Function   gtk_button_new_with_label (thelabel:pgchar):PGtkWidget; cdecl;

    Procedure gtk_button_pressed(button:pGtkButton); cdecl;

    Procedure gtk_button_released(button:pGtkButton); cdecl;

    Procedure gtk_button_clicked(button:pGtkButton); cdecl;

    Procedure gtk_button_enter(button:pGtkButton); cdecl;

    Procedure gtk_button_leave(button:pGtkButton); cdecl;


  implementation


    function in_button(var a : TGtkButton) : guint;
      begin
         in_button:=(a.flag0 and bm_in_button) shr bp_in_button;
      end;

    procedure set_in_button(var a : TGtkButton; __in_button : guint);
      begin
         a.flag0:=a.flag0 or ((__in_button shl bp_in_button) and bm_in_button);
      end;

    function button_down(var a : TGtkButton) : guint;
      begin
         button_down:=(a.flag0 and bm_button_down) shr bp_button_down;
      end;

    procedure set_button_down(var a : TGtkButton; __button_down : guint);
      begin
         a.flag0:=a.flag0 or ((__button_down shl bp_button_down) and bm_button_down);
      end;

    function gtk_button_get_type:guint;CDECL; external;

    function  gtk_button_new : PGtkWidget;cdecl;external;

    function  gtk_button_new_with_label (thelabel:pgchar):PGtkWidget;cdecl;external;

    procedure gtk_button_pressed(button:pGtkButton);CDECL; external;

    procedure gtk_button_released(button:pGtkButton);CDECL; external;

    procedure gtk_button_clicked(button:pGtkButton);CDECL; external;

    procedure gtk_button_enter(button:pGtkButton);CDECL; external;

    procedure gtk_button_leave(button:pGtkButton);CDECL; external;


end.
