unit gtkcheckmenuitem;

  interface

uses gdk,glib,gdktypes,gtkmenuitem,gtkwidget;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_CHECK_MENU_ITEM(obj)        ((GtkCheckMenuItem ) obj)
    #define GTK_CHECK_MENU_ITEM_CLASS(obj)  ((GtkCheckMenuItemClass ) GTK_OBJECT_CLASS (obj))
    #define GTK_IS_CHECK_MENU_ITEM(obj)     (gtk_type_is_a (GTK_WIDGET_TYPE (obj), gtk_check_menu_item_get_type ()))
    }

    type

       PGtkCheckMenuItem = ^TGtkCheckMenuItem;
{$PACKRECORDS 4}
       TGtkCheckMenuItem = record
            menu_item : TGtkMenuItem;
            flag0 : word;
         end;

    const
       bm_active = 1;
       bp_active = 0;
       bm_always_show_toggle = 2;
       bp_always_show_toggle = 1;
    Function  active(var a : TGtkCheckMenuItem) : guint; 
    Procedure set_active(var a : TGtkCheckMenuItem; __active : guint);
    Function  always_show_toggle(var a : TGtkCheckMenuItem) : guint; 
    Procedure set_always_show_toggle(var a : TGtkCheckMenuItem; __always_show_toggle : guint);

    type
       PGtkCheckMenuItemClass = ^TGtkCheckMenuItemClass;
{$PACKRECORDS 4}
       TGtkCheckMenuItemClass = record
            parent_class : TGtkMenuItemClass;
            toggled : Procedure (check_menu_item:pGtkCheckMenuItem); cdecl;
            draw_indicator : Procedure (check_menu_item:pGtkCheckMenuItem; area:pGdkRectangle); cdecl;
         end;


    Function  gtk_check_menu_item_get_type:guint; cdecl;

    Procedure gtk_check_menu_item_set_state(check_menu_item:pGtkCheckMenuItem; state:gint); cdecl;

    Procedure gtk_check_menu_item_set_show_toggle(menu_item:pGtkCheckMenuItem; always:gboolean); cdecl;

    Procedure gtk_check_menu_item_toggled(check_menu_item:pGtkCheckMenuItem); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

    function active(var a : TGtkCheckMenuItem) : guint;
      begin
         active:=(a.flag0 and bm_active) shr bp_active;
      end;

    procedure set_active(var a : TGtkCheckMenuItem; __active : guint);
      begin
         a.flag0:=a.flag0 or ((__active shl bp_active) and bm_active);
      end;

    function always_show_toggle(var a : TGtkCheckMenuItem) : guint;
      begin
         always_show_toggle:=(a.flag0 and bm_always_show_toggle) shr bp_always_show_toggle;
      end;

    procedure set_always_show_toggle(var a : TGtkCheckMenuItem; __always_show_toggle : guint);
      begin
         a.flag0:=a.flag0 or ((__always_show_toggle shl bp_always_show_toggle) and bm_always_show_toggle);
      end;

    function gtk_check_menu_item_get_type:guint;CDECL; external;

    function gtk_check_menu_item_new: PGtkWidget;cdecl;external;
    function gtk_check_menu_item_new_with_label (thelabel:pgchar):PGtkWidget;cdecl;external;


    procedure gtk_check_menu_item_set_state(check_menu_item:pGtkCheckMenuItem; state:gint);CDECL; external;

    procedure gtk_check_menu_item_set_show_toggle(menu_item:pGtkCheckMenuItem; always:gboolean);CDECL; external;

    procedure gtk_check_menu_item_toggled(check_menu_item:pGtkCheckMenuItem);CDECL; external;


end.
