unit gtkclist;

interface

uses gdk,gdktypes,glib,gtkwidget,gtksignal,gtkalignment,gtklabel,gtkbutton,
     gtkhscrollbar,gtkvscrollbar,gtkcontainer,gtkenums,gtkobjects;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    type
       a =  Longint;
         Const
         CLIST_FROZEN = 1 shl 0;
         CLIST_IN_DRAG = 1 shl 1;
         CLIST_ROW_HEIGHT_SET = 1 shl 2;
         CLIST_SHOW_TITLES = 1 shl 3;

    type
       GtkCellType =  Longint;
         Const
         GTK_CELL_EMPTY = 0;
         GTK_CELL_TEXT = 1;
         GTK_CELL_PIXMAP = 2;
         GTK_CELL_PIXTEXT = 3;
         GTK_CELL_WIDGET = 4;
    {
    #define GTK_CLIST(obj)          GTK_CHECK_CAST (obj, gtk_clist_get_type (), GtkCList)
    #define GTK_CLIST_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_clist_get_type (), GtkCListClass)
    #define GTK_IS_CLIST(obj)       GTK_CHECK_TYPE (obj, gtk_clist_get_type ())
    }
   
    {
    #define GTK_CLIST_SET_FLAGS(clist,flag)    (GTK_CLIST_FLAGS (clist) |= (flag))
    #define GTK_CLIST_UNSET_FLAGS(clist,flag)  (GTK_CLIST_FLAGS (clist) &= ~(flag))
    }
   
    {
    #define GTK_CELL_TEXT(cell)     (((GtkCellText  ) &(cell)))
    #define GTK_CELL_PIXMAP(cell)   (((GtkCellPixmap  ) &(cell)))
    #define GTK_CELL_PIXTEXT(cell)  (((GtkCellPixText  ) &(cell)))
    #define GTK_CELL_WIDGET(cell)   (((GtkCellWidget  ) &(cell)))
    }
    type
       PGtkCList = ^TGtkCList;
       PGtkCListClass = ^TGtkCListClass;
       PGtkCListColumn = ^TGtkCListColumn;
       PGtkCListRow = ^TGtkCListRow;
       PGtkCellText = ^TGtkCellText;
       PGtkCellPixmap = ^TGtkCellPixmap;
       PGtkCellPixText = ^TGtkCellPixText;
       PGtkCellWidget = ^TGtkCellWidget;
       PGtkCell = ^TGtkCell;
{$PACKRECORDS 4}
       TGtkCList = record
            container : TGtkContainer;
            flags : guint8;
            row_mem_chunk : PGMemChunk;
            cell_mem_chunk : PGMemChunk;
            internal_allocation : GdkRectangle;
            rows : gint;
            row_center_offset : gint;
            row_height : gint;
            row_list : PGList;
            row_list_end : PGList;
            columns : gint;
            column_title_area : GdkRectangle;
            title_window : PGdkWindow;
            column : PGtkCListColumn;
            clist_window : PGdkWindow;
            clist_window_width : gint;
            clist_window_height : gint;
            hoffset : gint;
            voffset : gint;
            shadow_type : GtkShadowType;
            selection_mode : GtkSelectionMode;
            selection : PGList;
            vscrollbar : PGtkWidget;
            hscrollbar : PGtkWidget;
            vscrollbar_policy : guint8;
            hscrollbar_policy : guint8;
            xor_gc : PGdkGC;
            fg_gc : PGdkGC;
            bg_gc : PGdkGC;
            cursor_drag : PGdkCursor;
            x_drag : gint;
         end;
{$PACKRECORDS 4}
       TGtkCListClass = record
            parent_class : TGtkContainerClass;
            select_row : Procedure (clist:pGtkCList; row:gint; column:gint; event:pGdkEventButton); cdecl;
            unselect_row : Procedure (clist:pGtkCList; row:gint; column:gint; event:pGdkEventButton); cdecl;
            click_column : Procedure (clist:pGtkCList; column:gint); cdecl;
            scrollbar_spacing : gint;
         end;
{$PACKRECORDS 4}
       TGtkCListColumn = record
            title : Pgchar;
            area : GdkRectangle;
            button : PGtkWidget;
            window : PGdkWindow;
            width : gint;
            justification : GtkJustification;
            flag0 : word;
         end;
{$PACKRECORDS 4}
       TGtkCListRow = record
            cell : PGtkCell;
            state : GtkStateType;
            foreground : GdkColor;
            background : GdkColor;
            data : gpointer;
            destroy : GtkDestroyNotify;
            flag0 : word;
         end;
{$PACKRECORDS 4}
       TGtkCellText = record
            thetype : GtkCellType;
            vertical : gint;
            horizontal : gint;
            thetext : Pgchar;
         end;
{$PACKRECORDS 4}
       TGtkCellPixmap = record
            thetype : GtkCellType;
            vertical : gint;
            horizontal : gint;
            pixmap : PGdkPixmap;
            mask : PGdkBitmap;
         end;
{$PACKRECORDS 4}
       TGtkCellPixText = record
            thetype : GtkCellType;
            vertical : gint;
            horizontal : gint;
            thetext : Pgchar;
            spacing : guint8;
            pixmap : PGdkPixmap;
            mask : PGdkBitmap;
         end;
{$PACKRECORDS 4}
       TGtkCellWidget = record
            thetype : GtkCellType;
            vertical : gint;
            horizontal : gint;
            widget : PGtkWidget;
         end;
{$PACKRECORDS 4}
       TGtkCell = record
            thetype : GtkCellType;
            vertical : gint;
            horizontal : gint;
            u : record
                case longint of
                   0 : ( text : Pgchar );
                   1 : ( pm : record
                        pixmap : PGdkPixmap;
                        mask : PGdkBitmap;
                     end );
                   2 : ( pt : record
                        text : Pgchar;
                        spacing : guint8;
                        pixmap : PGdkPixmap;
                        mask : PGdkBitmap;
                     end );
                   3 : ( widget : PGtkWidget );
                end;
         end;
    const
       bm_fg_set = 1;
       bp_fg_set = 0;
       bm_bg_set = 2;
       bp_bg_set = 1;
       bm_width_set = 1;
       bp_width_set = 0;
    Function  width_set(var a : TGtkCListColumn) : gint; 
    Procedure set_width_set(var a : TGtkCListColumn; __width_set : gint);
    Function  fg_set(var a : TGtkCListRow) : gint; 
    Procedure set_fg_set(var a : TGtkCListRow; __fg_set : gint); 
    Function  bg_set(var a : TGtkCListRow) : gint; 
    Procedure set_bg_set(var a : TGtkCListRow; __bg_set : gint); 
    Function  gtk_clist_get_type:guint; cdecl;

    Function  GTK_CLIST_FLAGS(clist : pgtkclist) : longint; 
    Function  GTK_CLIST_FROZEN(clist : PGtkclist) : longint; 
    Function  GTK_CLIST_IN_DRAG(clist : PGtkclist) : longint; 
    Function  GTK_CLIST_ROW_HEIGHT_SET(clist : PGtkclist) : longint;
    Function  GTK_CLIST_SHOW_TITLES(clist : PGtkclist) : longint; 


    Procedure gtk_clist_construct(clist:pGtkCList; columns:gint; titles:ppgchar); cdecl;
    Function   gtk_clist_new (columns:gint):PGtkWidget; cdecl;
    Function   gtk_clist_new_with_titles (columns:gint; titles:ppgchar):PGtkWidget; cdecl;
    Procedure gtk_clist_set_border(clist:pGtkCList; border:GtkShadowType); cdecl;
    Procedure gtk_clist_set_selection_mode(clist:pGtkCList; mode:GtkSelectionMode); cdecl;
    Procedure gtk_clist_set_policy(clist:pGtkCList; vscrollbar_policy:GtkPolicyType; hscrollbar_policy:GtkPolicyType); cdecl;
    Procedure gtk_clist_freeze(clist:pGtkCList); cdecl;
    Procedure gtk_clist_thaw(clist:pGtkCList); cdecl;
    Procedure gtk_clist_column_titles_show(clist:pGtkCList); cdecl;
    Procedure gtk_clist_column_titles_hide(clist:pGtkCList); cdecl;
    Procedure gtk_clist_column_title_active(clist:pGtkCList; column:gint); cdecl;
    Procedure gtk_clist_column_title_passive(clist:pGtkCList; column:gint); cdecl;
    Procedure gtk_clist_column_titles_active(clist:pGtkCList); cdecl;
    Procedure gtk_clist_column_titles_passive(clist:pGtkCList); cdecl;
    Procedure gtk_clist_set_column_title(clist:pGtkCList; column:gint; title:pgchar); cdecl;
    Procedure gtk_clist_set_column_widget(clist:pGtkCList; column:gint; widget:pGtkWidget); cdecl;
    Procedure gtk_clist_set_column_justification(clist:pGtkCList; column:gint; justification:GtkJustification); cdecl;
    Procedure gtk_clist_set_column_width(clist:pGtkCList; column:gint; width:gint); cdecl;
    Procedure gtk_clist_set_row_height(clist:pGtkCList; height:gint); cdecl;
    Procedure gtk_clist_moveto(clist:pGtkCList; row:gint; column:gint; row_align:gfloat; col_align:gfloat); cdecl;
    Function  gtk_clist_row_is_visible(clist:pGtkCList; row:gint):GtkVisibility; cdecl;
    Function  gtk_clist_get_cell_type(clist:pGtkCList; row:gint; column:gint):GtkCellType; cdecl;
    Procedure gtk_clist_set_text(clist:pGtkCList; row:gint; column:gint; thetext:pgchar); cdecl;
    Function  gtk_clist_get_text(clist:pGtkCList; row:gint; column:gint; thetext:ppgchar):gint; cdecl;
    Procedure gtk_clist_set_pixmap(clist:pGtkCList; row:gint; column:gint; pixmap:pGdkPixmap; mask:pGdkBitmap); cdecl;
    Function  gtk_clist_get_pixmap(clist:pGtkCList; row:gint; column:gint; pixmap:ppGdkPixmap; mask:ppGdkBitmap):gint; cdecl;
    Procedure gtk_clist_set_pixtext(clist:pGtkCList; row:gint; column:gint; thetext:pgchar; spacing:guint8; 
                pixmap:pGdkPixmap; mask:pGdkBitmap); cdecl;
    Function  gtk_clist_get_pixtext(clist:pGtkCList; row:gint; column:gint; thetext:ppgchar; spacing:pguint8; 
               pixmap:ppGdkPixmap; mask:ppGdkBitmap):gint; cdecl;
    Procedure gtk_clist_set_foreground(clist:pGtkCList; row:gint; color:pGdkColor); cdecl;
    Procedure gtk_clist_set_background(clist:pGtkCList; row:gint; color:pGdkColor); cdecl;
    Procedure gtk_clist_set_shift(clist:pGtkCList; row:gint; column:gint; vertical:gint; horizontal:gint); cdecl;
    Function  gtk_clist_append(clist:pGtkCList; thetext:ppgchar):gint; cdecl;
    Procedure gtk_clist_insert(clist:pGtkCList; row:gint; thetext:ppgchar); cdecl;
    Procedure gtk_clist_remove(clist:pGtkCList; row:gint); cdecl;
    Procedure gtk_clist_set_row_data(clist:pGtkCList; row:gint; data:gpointer); cdecl;
    Procedure gtk_clist_set_row_data_full(clist:pGtkCList; row:gint; data:gpointer; destroy:GtkDestroyNotify); cdecl;
    Function  gtk_clist_get_row_data(clist:pGtkCList; row:gint):gpointer; cdecl;
    Function  gtk_clist_find_row_from_data(clist:pGtkCList; data:gpointer):gint; cdecl;
    Procedure gtk_clist_select_row(clist:pGtkCList; row:gint; column:gint); cdecl;
    Procedure gtk_clist_unselect_row(clist:pGtkCList; row:gint; column:gint); cdecl;
    Procedure gtk_clist_clear(clist:pGtkCList); cdecl;
    Function  gtk_clist_get_selection_info(clist:pGtkCList; x:gint; y:gint; row:pgint; column:pgint):gint; cdecl;

  implementation
const External_library='gtk';
   
    function GTK_CLIST_FLAGS(clist : PGtkclist) : longint;
   
      begin
         GTK_CLIST_FLAGS:=clist^.flags;
      end;
   
    function GTK_CLIST_FROZEN(clist : PGtkclist) : longint;
   
      begin
         GTK_CLIST_FROZEN:=(clist^.flags) and CLIST_FROZEN;
      end;
   
    function GTK_CLIST_IN_DRAG(clist : PGtkclist) : longint;
   
      begin
         GTK_CLIST_IN_DRAG:=(clist^.flags) and CLIST_IN_DRAG;
      end;
   
    function GTK_CLIST_ROW_HEIGHT_SET(clist : PGtkclist) : longint;
   
      begin
         GTK_CLIST_ROW_HEIGHT_SET:=(clist^.flags) and CLIST_ROW_HEIGHT_SET;
      end;
   
    function GTK_CLIST_SHOW_TITLES(clist : PGtkclist) : longint;
   
      begin
         GTK_CLIST_SHOW_TITLES:=(clist^.flags) and CLIST_SHOW_TITLES;
      end;
    function width_set(var a : TGtkCListColumn) : gint;
      begin
         width_set:=(a.flag0 and bm_width_set) shr bp_width_set;
      end;
    procedure set_width_set(var a : TGtkCListColumn; __width_set : gint);
      begin
         a.flag0:=a.flag0 or ((__width_set shl bp_width_set) and bm_width_set);
      end;
    function fg_set(var a : TGtkCListRow) : gint;
      begin
         fg_set:=(a.flag0 and bm_fg_set) shr bp_fg_set;
      end;
    procedure set_fg_set(var a : TGtkCListRow; __fg_set : gint);
      begin
         a.flag0:=a.flag0 or ((__fg_set shl bp_fg_set) and bm_fg_set);
      end;
    function bg_set(var a : TGtkCListRow) : gint;
      begin
         bg_set:=(a.flag0 and bm_bg_set) shr bp_bg_set;
      end;
    procedure set_bg_set(var a : TGtkCListRow; __bg_set : gint);
      begin
         a.flag0:=a.flag0 or ((__bg_set shl bp_bg_set) and bm_bg_set);
      end;
    function gtk_clist_get_type:guint;CDECL; external;
    procedure gtk_clist_construct(clist:pGtkCList; columns:gint; titles:ppgchar);CDECL; external;
    procedure gtk_clist_set_border(clist:pGtkCList; border:GtkShadowType);CDECL; external;
    procedure gtk_clist_set_selection_mode(clist:pGtkCList; mode:GtkSelectionMode);CDECL; external;
    procedure gtk_clist_set_policy(clist:pGtkCList; vscrollbar_policy:GtkPolicyType; hscrollbar_policy:GtkPolicyType);CDECL; external;
    procedure gtk_clist_freeze(clist:pGtkCList);CDECL; external;
    procedure gtk_clist_thaw(clist:pGtkCList);CDECL; external;
    procedure gtk_clist_column_titles_show(clist:pGtkCList);CDECL; external;
    procedure gtk_clist_column_titles_hide(clist:pGtkCList);CDECL; external;
    procedure gtk_clist_column_title_active(clist:pGtkCList; column:gint);CDECL; external;
    procedure gtk_clist_column_title_passive(clist:pGtkCList; column:gint);CDECL; external;
    procedure gtk_clist_column_titles_active(clist:pGtkCList);CDECL; external;
    procedure gtk_clist_column_titles_passive(clist:pGtkCList);CDECL; external;
    procedure gtk_clist_set_column_title(clist:pGtkCList; column:gint; title:pgchar);CDECL; external;
    procedure gtk_clist_set_column_widget(clist:pGtkCList; column:gint; widget:pGtkWidget);CDECL; external;
    procedure gtk_clist_set_column_justification(clist:pGtkCList; column:gint; justification:GtkJustification);CDECL; external;
    procedure gtk_clist_set_column_width(clist:pGtkCList; column:gint; width:gint);CDECL; external;
    procedure gtk_clist_set_row_height(clist:pGtkCList; height:gint);CDECL; external;
    procedure gtk_clist_moveto(clist:pGtkCList; row:gint; column:gint; row_align:gfloat; col_align:gfloat);CDECL; external;
    function gtk_clist_row_is_visible(clist:pGtkCList; row:gint):GtkVisibility;CDECL; external;
    function gtk_clist_get_cell_type(clist:pGtkCList; row:gint; column:gint):GtkCellType;CDECL; external;
    procedure gtk_clist_set_text(clist:pGtkCList; row:gint; column:gint; thetext:pgchar);CDECL; external;
    function gtk_clist_get_text(clist:pGtkCList; row:gint; column:gint; thetext:ppgchar):gint;CDECL; external;
    procedure gtk_clist_set_pixmap(clist:pGtkCList; row:gint; column:gint; pixmap:pGdkPixmap; mask:pGdkBitmap);CDECL; external;
    function gtk_clist_get_pixmap(clist:pGtkCList; row:gint; column:gint; pixmap:ppGdkPixmap; mask:ppGdkBitmap):gint;CDECL; external;
    procedure gtk_clist_set_pixtext(clist:pGtkCList; row:gint; column:gint; thetext:pgchar; spacing:guint8; 
                pixmap:pGdkPixmap; mask:pGdkBitmap);CDECL; external;
    function gtk_clist_get_pixtext(clist:pGtkCList; row:gint; column:gint; thetext:ppgchar; spacing:pguint8; 
               pixmap:ppGdkPixmap; mask:ppGdkBitmap):gint;CDECL; external;
    procedure gtk_clist_set_foreground(clist:pGtkCList; row:gint; color:pGdkColor);CDECL; external;
    procedure gtk_clist_set_background(clist:pGtkCList; row:gint; color:pGdkColor);CDECL; external;
    procedure gtk_clist_set_shift(clist:pGtkCList; row:gint; column:gint; vertical:gint; horizontal:gint);CDECL; external;
    function gtk_clist_append(clist:pGtkCList; thetext:ppgchar):gint;CDECL; external;
    procedure gtk_clist_insert(clist:pGtkCList; row:gint; thetext:ppgchar);CDECL; external;
    procedure gtk_clist_remove(clist:pGtkCList; row:gint);CDECL; external;
    procedure gtk_clist_set_row_data(clist:pGtkCList; row:gint; data:gpointer);CDECL; external;
    procedure gtk_clist_set_row_data_full(clist:pGtkCList; row:gint; data:gpointer; destroy:GtkDestroyNotify);CDECL; external;
    function gtk_clist_get_row_data(clist:pGtkCList; row:gint):gpointer;CDECL; external;
    function gtk_clist_find_row_from_data(clist:pGtkCList; data:gpointer):gint;CDECL; external;
    procedure gtk_clist_select_row(clist:pGtkCList; row:gint; column:gint);CDECL; external;
    procedure gtk_clist_unselect_row(clist:pGtkCList; row:gint; column:gint);CDECL; external;
    procedure gtk_clist_clear(clist:pGtkCList);CDECL; external;
    function gtk_clist_get_selection_info(clist:pGtkCList; x:gint; y:gint; row:pgint; column:pgint):gint;CDECL; external;
    function  gtk_clist_new (columns:gint):PGtkWidget;cdecl;external;
    function  gtk_clist_new_with_titles (columns:gint; titles:ppgchar):PGtkWidget;cdecl;external;

end.
