unit gtkcolorsel;

  interface


uses gdk,gdktypes,glib,gtkenums,gtkwidget,gtkvbox,gtkwindow;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_COLOR_SELECTION(obj)          GTK_CHECK_CAST (obj, gtk_color_selection_get_type (), GtkColorSelection)
    #define GTK_COLOR_SELECTION_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_color_selection_get_type (), GtkColorSelectionClass)
    #define GTK_IS_COLOR_SELECTION(obj)       GTK_CHECK_TYPE (obj, gtk_color_selection_get_type ())
    
    #define GTK_COLOR_SELECTION_DIALOG(obj)          GTK_CHECK_CAST (obj, gtk_color_selection_dialog_get_type (), GtkColorSelectionDialog)
    #define GTK_COLOR_SELECTION_DIALOG_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_color_selection_dialog_get_type (), GtkColorSelectionDialogClass)
    #define GTK_IS_COLOR_SELECTION_DIALOG(obj)       GTK_CHECK_TYPE (obj, gtk_color_selection_dialog_get_type ())
    }

    type

       PGtkColorSelection = ^TGtkColorSelection;
{$PACKRECORDS 4}
       TGtkColorSelection = record
            vbox : TGtkVBox;
            wheel_area : PGtkWidget;
            value_area : PGtkWidget;
            sample_area : PGtkWidget;
            sample_area_eb : PGtkWidget;
            scales : array[0..7] of PGtkWidget;
            entries : array[0..7] of PGtkWidget;
            opacity_label : PGtkWidget;
            wheel_gc : PGdkGC;
            value_gc : PGdkGC;
            sample_gc : PGdkGC;
            policy : GtkUpdateType;
            use_opacity : gint;
            timer_active : gint;
            timer_tag : gint;
            values : array[0..7] of gdouble;
            old_values : array[0..7] of gdouble;
            wheel_buf : PGuchar;
            value_buf : PGuchar;
            sample_buf : PGuchar;
         end;

       PGtkColorSelectionClass = ^TGtkColorSelectionClass;
{$PACKRECORDS 4}
       TGtkColorSelectionClass = record
            parent_class : TGtkVBoxClass;
            color_changed : Procedure (colorsel:pGtkColorSelection); cdecl;
         end;

       PGtkColorSelectionDialog = ^TGtkColorSelectionDialog;
{$PACKRECORDS 4}
       TGtkColorSelectionDialog = record
            window : TGtkWindow;
            colorsel : PGtkWidget;
            main_vbox : PGtkWidget;
            ok_button : PGtkWidget;
            reset_button : PGtkWidget;
            cancel_button : PGtkWidget;
            help_button : PGtkWidget;
         end;

       PGtkColorSelectionDialogClass = ^TGtkColorSelectionDialogClass;
{$PACKRECORDS 4}
       TGtkColorSelectionDialogClass = record
            parent_class : TGtkWindowClass;
         end;

    { ColorSelection }

    Function  gtk_color_selection_get_type:guint; cdecl;


    Function  gtk_color_selection_new : PGtkWidget; cdecl;

    Procedure gtk_color_selection_set_update_policy(colorsel:pGtkColorSelection; policy:GtkUpdateType); cdecl;

    Procedure gtk_color_selection_set_opacity(colorsel:pGtkColorSelection; use_opacity:gint); cdecl;

    Procedure gtk_color_selection_set_color(colorsel:pGtkColorSelection; color:pgdouble); cdecl;

    Procedure gtk_color_selection_get_color(colorsel:pGtkColorSelection; color:pgdouble); cdecl;

    { ColorSelectionDialog }
    Function  gtk_color_selection_dialog_get_type:guint; cdecl;

(* Const before type ignored *)

    Function  gtk_color_selection_dialog_new (title:pgchar):PGtkWidget; cdecl;

  implementation

    function gtk_color_selection_get_type:guint;CDECL; external;

    procedure gtk_color_selection_set_update_policy(colorsel:pGtkColorSelection; policy:GtkUpdateType);CDECL; external;

    procedure gtk_color_selection_set_opacity(colorsel:pGtkColorSelection; use_opacity:gint);CDECL; external;

    procedure gtk_color_selection_set_color(colorsel:pGtkColorSelection; color:pgdouble);CDECL; external;

    procedure gtk_color_selection_get_color(colorsel:pGtkColorSelection; color:pgdouble);CDECL; external;

    function gtk_color_selection_dialog_get_type:guint;CDECL; external;

    function gtk_color_selection_new : PGtkWidget;cdecl;external;
    function gtk_color_selection_dialog_new (title:pgchar):PGtkWidget;cdecl;external;


end.
