unit gtkcombo;

  interface

uses gdk,glib,gtkwidget,gtkhbox,gtkitem;

    { Pointers to basic pascal types, inserted by h2pas conversion program.}
    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;


  {
  #define GTK_COMBO(obj)			GTK_CHECK_CAST (obj, gtk_combo_get_type (), GtkCombo)
  #define GTK_COMBO_CLASS(klass)	GTK_CHECK_CLASS_CAST (klass, gtk_combo_get_type (), GtkComboClass)
  #define GTK_IS_COMBO(obj)       GTK_CHECK_TYPE (obj, gtk_combo_get_type ())
  }

  type
     PGtkCombo = ^TGtkCombo;
{$PACKRECORDS 4}
     TGtkCombo = record
          hbox : TGtkHBox;
          entry : PGtkWidget;
          button : PGtkWidget;
          popup : PGtkWidget;
          popwin : PGtkWidget;
          list : PGtkWidget;
          entry_change_id : guint;
          list_change_id : guint;
          flag0 : word;
          activate_id : guint;
       end;

  const
     bm_value_in_list = 1;
     bp_value_in_list = 0;
     bm_ok_if_empty = 2;
     bp_ok_if_empty = 1;
     bm_case_sensitive = 4;
     bp_case_sensitive = 2;
     bm_use_arrows = 8;
     bp_use_arrows = 3;
     bm_use_arrows_always = 16;
     bp_use_arrows_always = 4;
  Function  value_in_list(var a : TGtkCombo) : guint;
  Procedure set_value_in_list(var a : TGtkCombo; __value_in_list : guint);
  Function  ok_if_empty(var a : TGtkCombo) : guint;
  Procedure set_ok_if_empty(var a : TGtkCombo; __ok_if_empty : guint);
  Function  case_sensitive(var a : TGtkCombo) : guint;
  Procedure set_case_sensitive(var a : TGtkCombo; __case_sensitive : guint);
  Function  use_arrows(var a : TGtkCombo) : guint;
  Procedure set_use_arrows(var a : TGtkCombo; __use_arrows : guint);
  Function  use_arrows_always(var a : TGtkCombo) : guint;
  Procedure set_use_arrows_always(var a : TGtkCombo; __use_arrows_always : guint);

  type
     PGtkComboClass = ^TGtkComboClass;
{$PACKRECORDS 4}
     TGtkComboClass = record
          parent_class : TGtkHBoxClass;
       end;


  Function  gtk_combo_get_type:guint; cdecl;
  
  Function  gtk_combo_new : PGtkWidget; cdecl;

  Procedure gtk_combo_set_value_in_list(combo:pGtkCombo; val:gint; ok_if_empty:gint); cdecl;

  Procedure gtk_combo_set_use_arrows(combo:pGtkCombo; val:gint); cdecl;

  Procedure gtk_combo_set_use_arrows_always(combo:pGtkCombo; val:gint); cdecl;

  Procedure gtk_combo_set_case_sensitive(combo:pGtkCombo; val:gint); cdecl;

  Procedure gtk_combo_set_item_string(combo:pGtkCombo; item:pGtkItem; item_value:pgchar); cdecl;

  Procedure gtk_combo_set_popdown_strings(combo:pGtkCombo; strings:pGList); cdecl;

  Procedure gtk_combo_disable_activate(combo:pGtkCombo); cdecl;


  implementation


  function value_in_list(var a : TGtkCombo) : guint;
    begin
       value_in_list:=(a.flag0 and bm_value_in_list) shr bp_value_in_list;
    end;

  procedure set_value_in_list(var a : TGtkCombo; __value_in_list : guint);
    begin
       a.flag0:=a.flag0 or ((__value_in_list shl bp_value_in_list) and bm_value_in_list);
    end;

  function ok_if_empty(var a : TGtkCombo) : guint;
    begin
       ok_if_empty:=(a.flag0 and bm_ok_if_empty) shr bp_ok_if_empty;
    end;

  procedure set_ok_if_empty(var a : TGtkCombo; __ok_if_empty : guint);
    begin
       a.flag0:=a.flag0 or ((__ok_if_empty shl bp_ok_if_empty) and bm_ok_if_empty);
    end;

  function case_sensitive(var a : TGtkCombo) : guint;
    begin
       case_sensitive:=(a.flag0 and bm_case_sensitive) shr bp_case_sensitive;
    end;

  procedure set_case_sensitive(var a : TGtkCombo; __case_sensitive : guint);
    begin
       a.flag0:=a.flag0 or ((__case_sensitive shl bp_case_sensitive) and bm_case_sensitive);
    end;

  function use_arrows(var a : TGtkCombo) : guint;
    begin
       use_arrows:=(a.flag0 and bm_use_arrows) shr bp_use_arrows;
    end;

  procedure set_use_arrows(var a : TGtkCombo; __use_arrows : guint);
    begin
       a.flag0:=a.flag0 or ((__use_arrows shl bp_use_arrows) and bm_use_arrows);
    end;

  function use_arrows_always(var a : TGtkCombo) : guint;
    begin
       use_arrows_always:=(a.flag0 and bm_use_arrows_always) shr bp_use_arrows_always;
    end;

  procedure set_use_arrows_always(var a : TGtkCombo; __use_arrows_always : guint);
    begin
       a.flag0:=a.flag0 or ((__use_arrows_always shl bp_use_arrows_always) and bm_use_arrows_always);
    end;

  function gtk_combo_get_type:guint;CDECL; external;

  procedure gtk_combo_set_value_in_list(combo:pGtkCombo; val:gint; ok_if_empty:gint);CDECL; external;

  procedure gtk_combo_set_use_arrows(combo:pGtkCombo; val:gint);CDECL; external;

  procedure gtk_combo_set_use_arrows_always(combo:pGtkCombo; val:gint);CDECL; external;

  procedure gtk_combo_set_case_sensitive(combo:pGtkCombo; val:gint);CDECL; external;

  procedure gtk_combo_set_item_string(combo:pGtkCombo; item:pGtkItem; item_value:pgchar);CDECL; external;

  procedure gtk_combo_set_popdown_strings(combo:pGtkCombo; strings:pGList);CDECL; external;

  procedure gtk_combo_disable_activate(combo:pGtkCombo);CDECL; external;

  function gtk_combo_new : PGtkWidget;cdecl;external;

end.
