unit gtkcontainer;

  interface

uses gdk,gtkadjustment,gtkenums,gtkwidget,glib,gtkobjects;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;


    {
    #define GTK_CONTAINER(obj)	    (GTK_CHECK_CAST ((obj), gtk_container_get_type (), GtkContainer))
    #define GTK_CONTAINER_CLASS(klass)  (GTK_CHECK_CLASS_CAST ((klass), gtk_container_get_type (), GtkContainerClass))
    #define GTK_IS_CONTAINER(obj)	    (GTK_CHECK_TYPE ((obj), gtk_container_get_type ()))
    
    #define GTK_TYPE_CONTAINER	    (gtk_container_get_type ())
    }

    type

       PGtkContainer = ^TGtkContainer;
{$PACKRECORDS 4}
       TGtkContainer = record
            widget : TGtkWidget;
            focus_child : PGtkWidget;
            border_width : gint16;
            flag0 : word;
            resize_widgets : PGSList;
         end;

    const
       bm_auto_resize = 1;
       bp_auto_resize = 0;
       bm_need_resize = 2;
       bp_need_resize = 1;
       bm_block_resize = 4;
       bp_block_resize = 2;
       
    Function  auto_resize(var a : TGtkContainer) : guint; 
    Procedure set_auto_resize(var a : TGtkContainer; __auto_resize : guint); 
    Function  need_resize(var a : TGtkContainer) : guint; 
    Procedure set_need_resize(var a : TGtkContainer; __need_resize : guint); 
    Function  block_resize(var a : TGtkContainer) : guint; 
    Procedure set_block_resize(var a : TGtkContainer; __block_resize : guint); 

    type
       PGtkContainerClass = ^TGtkContainerClass;
{$PACKRECORDS 4}
       TGtkContainerClass = record
            parent_class : TGtkWidgetClass;
            add : Procedure (container:pGtkContainer; widget:pGtkWidget); cdecl;
            remove : Procedure (container:pGtkContainer; widget:pGtkWidget); cdecl;
            need_resize : Function  (container:pGtkContainer):gint; cdecl;
            foreach : Procedure (container:pGtkContainer; callback:TGtkCallback; callbabck_data:gpointer); cdecl;
            focus : Function  (container:pGtkContainer; direction:GtkDirectionType):gint; cdecl;
         end;


    Function  gtk_container_get_type:GtkType; cdecl;

    Procedure gtk_container_border_width(container:pGtkContainer; border_width:gint); cdecl;

    Procedure gtk_container_add(container:pGtkContainer; widget:pGtkWidget); cdecl;

    Procedure gtk_container_remove(container:pGtkContainer; widget:pGtkWidget); cdecl;

    Procedure gtk_container_disable_resize(container:pGtkContainer); cdecl;

    Procedure gtk_container_enable_resize(container:pGtkContainer); cdecl;

    Procedure gtk_container_block_resize(container:pGtkContainer); cdecl;

    Procedure gtk_container_unblock_resize(container:pGtkContainer); cdecl;

    Function  gtk_container_need_resize(container:pGtkContainer):gint; cdecl;

    Procedure gtk_container_foreach(container:pGtkContainer; callback:TGtkCallback; callback_data:gpointer); cdecl;

    Procedure gtk_container_foreach_interp(container:pGtkContainer; marshal:GtkCallbackMarshal; callback_data:gpointer; notify:GtkDestroyNotify); cdecl;

    Procedure gtk_container_foreach_full(container:pGtkContainer; callback:TGtkCallback; marshal:GtkCallbackMarshal; callback_data:gpointer; notify:GtkDestroyNotify); cdecl;


    Function  gtk_container_children (container:pGtkContainer):pGList; cdecl;

    Procedure gtk_container_register_toplevel(container:pGtkContainer); cdecl;

    Procedure gtk_container_unregister_toplevel(container:pGtkContainer); cdecl;

    Function  gtk_container_focus(container:pGtkContainer; direction:GtkDirectionType):gint; cdecl;

    Procedure gtk_container_set_focus_child(container:pGtkContainer; child:pGtkWidget); cdecl;

    Procedure gtk_container_set_focus_vadjustment(container:pGtkContainer; adjustment:pGtkAdjustment); cdecl;

    Procedure gtk_container_set_focus_hadjustment(container:pGtkContainer; adjustment:pGtkAdjustment); cdecl;


  implementation


    function auto_resize(var a : TGtkContainer) : guint;
      begin
         auto_resize:=(a.flag0 and bm_auto_resize) shr bp_auto_resize;
      end;

    procedure set_auto_resize(var a : TGtkContainer; __auto_resize : guint);
      begin
         a.flag0:=a.flag0 or ((__auto_resize shl bp_auto_resize) and bm_auto_resize);
      end;

    function need_resize(var a : TGtkContainer) : guint;
      begin
         need_resize:=(a.flag0 and bm_need_resize) shr bp_need_resize;
      end;

    procedure set_need_resize(var a : TGtkContainer; __need_resize : guint);
      begin
         a.flag0:=a.flag0 or ((__need_resize shl bp_need_resize) and bm_need_resize);
      end;

    function block_resize(var a : TGtkContainer) : guint;
      begin
         block_resize:=(a.flag0 and bm_block_resize) shr bp_block_resize;
      end;

    procedure set_block_resize(var a : TGtkContainer; __block_resize : guint);
      begin
         a.flag0:=a.flag0 or ((__block_resize shl bp_block_resize) and bm_block_resize);
      end;

    function gtk_container_get_type:GtkType;CDECL; external;

    procedure gtk_container_border_width(container:pGtkContainer; border_width:gint);CDECL; external;

    procedure gtk_container_add(container:pGtkContainer; widget:pGtkWidget);CDECL; external;

    procedure gtk_container_remove(container:pGtkContainer; widget:pGtkWidget);CDECL; external;

    procedure gtk_container_disable_resize(container:pGtkContainer);CDECL; external;

    procedure gtk_container_enable_resize(container:pGtkContainer);CDECL; external;

    procedure gtk_container_block_resize(container:pGtkContainer);CDECL; external;

    procedure gtk_container_unblock_resize(container:pGtkContainer);CDECL; external;

    function gtk_container_need_resize(container:pGtkContainer):gint;CDECL; external;

    procedure gtk_container_foreach(container:pGtkContainer; callback:TGtkCallback; callback_data:gpointer);CDECL; external;

    procedure gtk_container_foreach_interp(container:pGtkContainer; marshal:GtkCallbackMarshal; callback_data:gpointer; notify:GtkDestroyNotify);CDECL; external;

    procedure gtk_container_foreach_full(container:pGtkContainer; callback:TGtkCallback; marshal:GtkCallbackMarshal; callback_data:gpointer; notify:GtkDestroyNotify);CDECL; external;

    procedure gtk_container_register_toplevel(container:pGtkContainer);CDECL; external;

    procedure gtk_container_unregister_toplevel(container:pGtkContainer);CDECL; external;

    function gtk_container_focus(container:pGtkContainer; direction:GtkDirectionType):gint;CDECL; external;

    procedure gtk_container_set_focus_child(container:pGtkContainer; child:pGtkWidget);CDECL; external;

    procedure gtk_container_set_focus_vadjustment(container:pGtkContainer; adjustment:pGtkAdjustment);CDECL; external;

    procedure gtk_container_set_focus_hadjustment(container:pGtkContainer; adjustment:pGtkAdjustment);CDECL; external;

    Function gtk_container_children (container:pGtkContainer):pGList;cdecl;external;

end.
