unit gtkcurve;

  interface

uses gdk,glib,gdktypes,gtkdrawingarea,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_CURVE(obj)         (GTK_CHECK_CAST ((obj), gtk_curve_get_type (), GtkCurve))
  #define GTK_CURVE_CLASS(klass) (GTK_CHECK_CLASS_CAST ((klass), gtk_curve_get_type (), GtkCurveClass))
  #define GTK_IS_CURVE(obj)      (GTK_CHECK_TYPE ((obj), gtk_curve_get_type ()))
  }

  type

     GtkCurveType =  Longint;
       Const
       GTK_CURVE_TYPE_LINEAR = 0;
       GTK_CURVE_TYPE_SPLINE = 1;
       GTK_CURVE_TYPE_FREE = 2;
  type
     TGFloatarray = Array[0..1] of gfloat;
     PGFloatArray = ^TGFloatArray;
     
     PGtkCurve = ^TGtkCurve;
{$PACKRECORDS 4}
     TGtkCurve = record
          graph : TGtkDrawingArea;
          cursor_type : gint;
          min_x : gfloat;
          max_x : gfloat;
          min_y : gfloat;
          max_y : gfloat;
          pixmap : ^GdkPixmap;
          curve_type : GtkCurveType;
          height : gint;
          grab_point : gint;
          last : gint;
          num_points : gint;
          point : PGdkPoint;
          num_ctlpoints : gint;
          ctlpoint : PGFloatArray;
       end;

     PGtkCurveClass = ^TGtkCurveClass;
{$PACKRECORDS 4}
     TGtkCurveClass = record
          parent_class : TGtkDrawingAreaClass;
          curve_type_changed : Procedure (curve:pGtkCurve); cdecl;
       end;


  Function  gtk_curve_get_type:guint; cdecl;
  Function  gtk_curve_new : PGtkWidget; cdecl;

  Procedure gtk_curve_reset(curve:pGtkCurve); cdecl;

  Procedure gtk_curve_set_gamma(curve:pGtkCurve; gamma:gfloat); cdecl;

  Procedure gtk_curve_set_range(curve:pGtkCurve; min_x:gfloat; max_x:gfloat; min_y:gfloat; max_y:gfloat); cdecl;

  Procedure gtk_curve_get_vector(curve:pGtkCurve; veclen:longint; vector:pgfloat); cdecl;

  Procedure gtk_curve_set_vector(curve:pGtkCurve; veclen:longint; vector:pgfloat); cdecl;

  Procedure gtk_curve_set_curve_type(curve:pGtkCurve; thetype:GtkCurveType); cdecl;


  implementation

  function gtk_curve_get_type:guint;CDECL; external;
  function gtk_curve_new : PGtkWidget;cdecl;external;

  procedure gtk_curve_reset(curve:pGtkCurve);CDECL; external;

  procedure gtk_curve_set_gamma(curve:pGtkCurve; gamma:gfloat);CDECL; external;

  procedure gtk_curve_set_range(curve:pGtkCurve; min_x:gfloat; max_x:gfloat; min_y:gfloat; max_y:gfloat);CDECL; external;

  procedure gtk_curve_get_vector(curve:pGtkCurve; veclen:longint; vector:pgfloat);CDECL; external;

  procedure gtk_curve_set_vector(curve:pGtkCurve; veclen:longint; vector:pgfloat);CDECL; external;

  procedure gtk_curve_set_curve_type(curve:pGtkCurve; thetype:GtkCurveType);CDECL; external;


end.
