unit gtkeditable;

  interface

uses gdk,gdktypes,glib,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_EDITABLE(obj)          GTK_CHECK_CAST (obj, gtk_editable_get_type (), GtkEditable)
  #define GTK_EDITABLE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_editable_get_type (), GtkEditableClass)
  #define GTK_IS_EDITABLE(obj)       GTK_CHECK_TYPE (obj, gtk_editable_get_type ())
  }

  type

     PGtkEditable = ^TGtkEditable;
{$PACKRECORDS 4}
     TGtkEditable = record
          widget : TGtkWidget;
          current_pos : guint;
          selection_start_pos : guint;
          selection_end_pos : guint;
          flag0 : word;
          ic : GdkIC;
          clipboard_text : pgchar;
       end;
     TGtkTextFunction  = Procedure (editable:pGtkEditable; time:guint32); cdecl; cdecl;

  const
     bm_has_selection = 1;
     bp_has_selection = 0;
     bm_editable = 2;
     bp_editable = 1;
  Function  has_selection(var a : TGtkEditable) : guint; 
  Procedure set_has_selection(var a : TGtkEditable; __has_selection : guint); 
  Function  editable(var a : TGtkEditable) : guint;
  Procedure set_editable(var a : TGtkEditable; __editable : guint);

  type
     PGtkEditableClass = ^TGtkEditableClass;
{$PACKRECORDS 4}
     TGtkEditableClass = record
          parent_class : TGtkWidgetClass;
          insert_text : Procedure (editable:pGtkEditable; thetext:pgchar; length:gint; position:pgint); cdecl;
          delete_text : Procedure (editable:pGtkEditable; start_pos:gint; end_pos:gint); cdecl;
          update_text : Procedure (editable:pGtkEditable; start_pos:gint; end_pos:gint); cdecl;
          get_chars : Function  (editable:pGtkEditable; start_pos:gint; end_pos:gint):pgchar; cdecl;
          set_selection : Procedure (editable:pGtkEditable; start_pos:gint; end_pos:gint); cdecl;
          activate : Procedure (editable:pGtkEditable); cdecl;
          changed : Procedure (editable:pGtkEditable); cdecl;
       end;


  Function  gtk_editable_get_type:guint; cdecl;

  Procedure gtk_editable_select_region(editable:pGtkEditable; start:gint; theend:gint); cdecl;

  Procedure gtk_editable_insert_text(editable:pGtkEditable; new_text:pgchar; new_text_length:gint; position:pgint); cdecl;

  Procedure gtk_editable_delete_text(editable:pGtkEditable; start_pos:gint; end_pos:gint); cdecl;


  Function  gtk_editable_get_chars (editable:pGtkEditable; start_pos:gint; end_pos:gint):pgchar; cdecl;

  Procedure gtk_editable_cut_clipboard(editable:pGtkEditable; time:guint32); cdecl;

  Procedure gtk_editable_copy_clipboard(editable:pGtkEditable; time:guint32); cdecl;

  Procedure gtk_editable_paste_clipboard(editable:pGtkEditable; time:guint32); cdecl;

  Procedure gtk_editable_claim_selection(editable:pGtkEditable; claim:gboolean; time:guint32); cdecl;

  Procedure gtk_editable_delete_selection(editable:pGtkEditable); cdecl;

  Procedure gtk_editable_changed(editable:pGtkEditable); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function has_selection(var a : TGtkEditable) : guint;
    begin
       has_selection:=(a.flag0 and bm_has_selection) shr bp_has_selection;
    end;

  procedure set_has_selection(var a : TGtkEditable; __has_selection : guint);
    begin
       a.flag0:=a.flag0 or ((__has_selection shl bp_has_selection) and bm_has_selection);
    end;

  function editable(var a : TGtkEditable) : guint;
    begin
       editable:=(a.flag0 and bm_editable) shr bp_editable;
    end;

  procedure set_editable(var a : TGtkEditable; __editable : guint);
    begin
       a.flag0:=a.flag0 or ((__editable shl bp_editable) and bm_editable);
    end;

  function gtk_editable_get_type:guint;CDECL; external;

  procedure gtk_editable_select_region(editable:pGtkEditable; start:gint; theend:gint);CDECL; external;

  procedure gtk_editable_insert_text(editable:pGtkEditable; new_text:pgchar; new_text_length:gint; position:pgint);CDECL; external;

  procedure gtk_editable_delete_text(editable:pGtkEditable; start_pos:gint; end_pos:gint);CDECL; external;

  procedure gtk_editable_cut_clipboard(editable:pGtkEditable; time:guint32);CDECL; external;

  procedure gtk_editable_copy_clipboard(editable:pGtkEditable; time:guint32);CDECL; external;

  procedure gtk_editable_paste_clipboard(editable:pGtkEditable; time:guint32);CDECL; external;

  procedure gtk_editable_claim_selection(editable:pGtkEditable; claim:gboolean; time:guint32);CDECL; external;

  procedure gtk_editable_delete_selection(editable:pGtkEditable);CDECL; external;

  procedure gtk_editable_changed(editable:pGtkEditable);CDECL; external;

  function gtk_editable_get_chars (editable:pGtkEditable; start_pos:gint; end_pos:gint):pgchar;cdecl;external;

end.
