unit gtkentry;

  interface

uses gdk,gdktypes,glib,gtkeditable,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_ENTRY(obj)          GTK_CHECK_CAST (obj, gtk_entry_get_type (), GtkEntry)
  #define GTK_ENTRY_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_entry_get_type (), GtkEntryClass)
  #define GTK_IS_ENTRY(obj)       GTK_CHECK_TYPE (obj, gtk_entry_get_type ())
  }

  type
     PGtkEntry = ^TGtkEntry;
{$PACKRECORDS 4}
     TGtkEntry = record
          editable : TGtkEditable;
          text_area : PGdkWindow;
          backing_pixmap : PGdkPixmap;
          cursor : PGdkCursor;
          text : Pgchar;
          text_size : guint16;
          text_length : guint16;
          text_max_length : guint16;
          scroll_offset : gint;
          flag0 : word;
          timer : guint32;
          button : guint;
          nchars : guint;
          char_pos : pguint16;
          char_offset : pgint;
       end;

  const
     bm_visible = 1;
     bp_visible = 0;
  Function  visible(var a : TGtkEntry) : guint; 
  Procedure set_visible(var a : TGtkEntry; __visible : guint);

  type
     PGtkEntryClass = ^TGtkEntryClass;
{$PACKRECORDS 4}
     TGtkEntryClass = record
          parent_class : TGtkEditableClass;
       end;


  Function  gtk_entry_get_type:guint; cdecl;


  Function  gtk_entry_new :PGtkWidget; cdecl;
  Function  gtk_entry_new_with_max_length (max:guint16):PGtkWidget; cdecl;

  Procedure gtk_entry_set_text(entry:pGtkEntry; text:pgchar); cdecl;

  Procedure gtk_entry_append_text(entry:pGtkEntry; text:pgchar); cdecl;

  Procedure gtk_entry_prepend_text(entry:pGtkEntry; text:pgchar); cdecl;

  Procedure gtk_entry_set_position(entry:pGtkEntry; position:gint); cdecl;

  Function  gtk_entry_get_text (entry:pGtkEntry):pgchar; cdecl;

  Procedure gtk_entry_select_region(entry:pGtkEntry; start:gint; theend:gint); cdecl;

  Procedure gtk_entry_set_visibility(entry:pGtkEntry; visible:gboolean); cdecl;

  Procedure gtk_entry_set_editable(entry:pGtkEntry; editable:gboolean); cdecl;

  Procedure gtk_entry_set_max_length(entry:pGtkEntry; max:guint16); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function visible(var a : TGtkEntry) : guint;
    begin
       visible:=(a.flag0 and bm_visible) shr bp_visible;
    end;

  procedure set_visible(var a : TGtkEntry; __visible : guint);
    begin
       a.flag0:=a.flag0 or ((__visible shl bp_visible) and bm_visible);
    end;

  function gtk_entry_get_type:guint;CDECL; external;

  procedure gtk_entry_set_text(entry:pGtkEntry; text:pgchar);CDECL; external;

  procedure gtk_entry_append_text(entry:pGtkEntry; text:pgchar);CDECL; external;

  procedure gtk_entry_prepend_text(entry:pGtkEntry; text:pgchar);CDECL; external;

  procedure gtk_entry_set_position(entry:pGtkEntry; position:gint);CDECL; external;

  procedure gtk_entry_select_region(entry:pGtkEntry; start:gint; theend:gint);CDECL; external;

  procedure gtk_entry_set_visibility(entry:pGtkEntry; visible:gboolean);CDECL; external;

  procedure gtk_entry_set_editable(entry:pGtkEntry; editable:gboolean);CDECL; external;

  procedure gtk_entry_set_max_length(entry:pGtkEntry; max:guint16);CDECL; external;

  function gtk_entry_get_text (entry:pGtkEntry):pgchar;cdecl;external;
  function gtk_entry_new :PGtkWidget;cdecl;external;
  function gtk_entry_new_with_max_length (max:guint16):PGtkWidget;cdecl;external;


end.
