unit gtkhandlebox;

  interface

uses gdk,gdktypes,glib,gtkwidget,gtkbin;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_HANDLE_BOX(obj)          GTK_CHECK_CAST (obj, gtk_handle_box_get_type (), GtkHandleBox)
  #define GTK_HANDLE_BOX_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_handle_box_get_type (), GtkHandleBoxClass)
  #define GTK_IS_HANDLE_BOX(obj)       GTK_CHECK_TYPE (obj, gtk_handle_box_get_type ())
  }

  type
     PGtkHandleBox = ^TGtkHandleBox;
{$PACKRECORDS 4}
     TGtkHandleBox = record
          bin : TGtkBin;
          bin_window : PGdkWindow;
          float_window : PGdkWindow;
          flag0 : word;
          fleur_cursor : PGdkCursor;
          dragoff_x : gint;
          dragoff_y : gint;
       end;

  const
     bm_handle_position = 3;
     bp_handle_position = 0;
     bm_float_window_mapped = 4;
     bp_float_window_mapped = 2;
     bm_child_detached = 8;
     bp_child_detached = 3;
     bm_in_drag = 16;
     bp_in_drag = 4;
     bm_shrink_on_detach = 32;
     bp_shrink_on_detach = 5;
  Function  handle_position(var a : TGtkHandleBox) : guint;
  Procedure set_handle_position(var a : TGtkHandleBox; __handle_position : guint);
  Function  float_window_mapped(var a : TGtkHandleBox) : guint;
  Procedure set_float_window_mapped(var a : TGtkHandleBox; __float_window_mapped : guint);
  Function  child_detached(var a : TGtkHandleBox) : guint;
  Procedure set_child_detached(var a : TGtkHandleBox; __child_detached : guint);
  Function  in_drag(var a : TGtkHandleBox) : guint;
  Procedure set_in_drag(var a : TGtkHandleBox; __in_drag : guint);
  Function  shrink_on_detach(var a : TGtkHandleBox) : guint;
  Procedure set_shrink_on_detach(var a : TGtkHandleBox; __shrink_on_detach : guint);

  type
     PGtkHandleBoxClass = ^TGtkHandleBoxClass;
{$PACKRECORDS 4}
     TGtkHandleBoxClass = record
          parent_class : TGtkBinClass;
          child_attached : Procedure (handle_box:pGtkHandleBox; child:pGtkWidget); cdecl;
          child_detached : Procedure (handle_box:pGtkHandleBox; child:pGtkWidget); cdecl;
       end;


  Function  gtk_handle_box_get_type:guint; cdecl;
  Function  gtk_handle_box_new : PGtkWidget; cdecl;

  implementation

const External_library='gtk'; {Setup as you need!}

  function handle_position(var a : TGtkHandleBox) : guint;
    begin
       handle_position:=(a.flag0 and bm_handle_position) shr bp_handle_position;
    end;

  procedure set_handle_position(var a : TGtkHandleBox; __handle_position : guint);
    begin
       a.flag0:=a.flag0 or ((__handle_position shl bp_handle_position) and bm_handle_position);
    end;

  function float_window_mapped(var a : TGtkHandleBox) : guint;
    begin
       float_window_mapped:=(a.flag0 and bm_float_window_mapped) shr bp_float_window_mapped;
    end;

  procedure set_float_window_mapped(var a : TGtkHandleBox; __float_window_mapped : guint);
    begin
       a.flag0:=a.flag0 or ((__float_window_mapped shl bp_float_window_mapped) and bm_float_window_mapped);
    end;

  function child_detached(var a : TGtkHandleBox) : guint;
    begin
       child_detached:=(a.flag0 and bm_child_detached) shr bp_child_detached;
    end;

  procedure set_child_detached(var a : TGtkHandleBox; __child_detached : guint);
    begin
       a.flag0:=a.flag0 or ((__child_detached shl bp_child_detached) and bm_child_detached);
    end;

  function in_drag(var a : TGtkHandleBox) : guint;
    begin
       in_drag:=(a.flag0 and bm_in_drag) shr bp_in_drag;
    end;

  procedure set_in_drag(var a : TGtkHandleBox; __in_drag : guint);
    begin
       a.flag0:=a.flag0 or ((__in_drag shl bp_in_drag) and bm_in_drag);
    end;

  function shrink_on_detach(var a : TGtkHandleBox) : guint;
    begin
       shrink_on_detach:=(a.flag0 and bm_shrink_on_detach) shr bp_shrink_on_detach;
    end;

  procedure set_shrink_on_detach(var a : TGtkHandleBox; __shrink_on_detach : guint);
    begin
       a.flag0:=a.flag0 or ((__shrink_on_detach shl bp_shrink_on_detach) and bm_shrink_on_detach);
    end;

  function gtk_handle_box_get_type:guint;CDECL; external;
  function gtk_handle_box_new : PGtkWidget;cdecl;external;


end.
