unit gtklabel;

  interface

uses gdk,glib,gtkmisc,gtkwidget,gtkenums;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_LABEL(obj)          GTK_CHECK_CAST (obj, gtk_label_get_type (), GtkLabel)
    #define GTK_LABEL_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_label_get_type (), GtkLabelClass)
    #define GTK_IS_LABEL(obj)       GTK_CHECK_TYPE (obj, gtk_label_get_type ())
    }

    type

       PGtkLabel = ^TGtkLabel;
{$PACKRECORDS 4}
       TGtkLabel = record
            misc : TGtkMisc;
            thelabel : pchar;
            row : PGSList;
            flag0 : word;
         end;

    const
       bm_jtype = 3;
       bp_jtype = 0;
       bm_needs_clear = 4;
       bp_needs_clear = 2;
    Function  jtype(var a : TGtkLabel) : guint; 
    Procedure set_jtype(var a : TGtkLabel; __jtype : guint); 
    Function  needs_clear(var a : TGtkLabel) : gint; 
    Procedure set_needs_clear(var a : TGtkLabel; __needs_clear : gint); 

    type
       PGtkLabelClass = ^TGtkLabelClass;
{$PACKRECORDS 4}
       TGtkLabelClass = record
            parent_class : TGtkMiscClass;
         end;


    Function  gtk_label_get_type:guint; cdecl;

    Function  gtk_label_new (str:pchar):PGtkWidget; cdecl;

    Procedure gtk_label_set(thelabel:pGtkLabel; str:pchar); cdecl;

    Procedure gtk_label_set_justify(thelabel:pGtkLabel; jtype:GtkJustification); cdecl;

    Procedure gtk_label_get(thelabel:pGtkLabel; str:ppchar); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

    function jtype(var a : TGtkLabel) : guint;
      begin
         jtype:=(a.flag0 and bm_jtype) shr bp_jtype;
      end;

    procedure set_jtype(var a : TGtkLabel; __jtype : guint);
      begin
         a.flag0:=a.flag0 or ((__jtype shl bp_jtype) and bm_jtype);
      end;

    function needs_clear(var a : TGtkLabel) : gint;
      begin
         needs_clear:=(a.flag0 and bm_needs_clear) shr bp_needs_clear;
      end;

    procedure set_needs_clear(var a : TGtkLabel; __needs_clear : gint);
      begin
         a.flag0:=a.flag0 or ((__needs_clear shl bp_needs_clear) and bm_needs_clear);
      end;

    function gtk_label_get_type:guint;CDECL; external;

    procedure gtk_label_set(thelabel:pGtkLabel; str:pchar);CDECL; external;

    procedure gtk_label_set_justify(thelabel:pGtkLabel; jtype:GtkJustification);CDECL; external;

    procedure gtk_label_get(thelabel:pGtkLabel; str:ppchar);CDECL; external;
    function gtk_label_new (str:pchar):PGtkWidget;cdecl;external;


end.
