unit gtklist;

  interface

uses gdk,glib,gtkenums,gtkcontainer,gtkwidget,gtkobjects;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_LIST(obj)	       (GTK_CHECK_CAST (obj, gtk_list_get_type (), GtkList))
  #define GTK_LIST_CLASS(klass)  (GTK_CHECK_CLASS_CAST (klass, gtk_list_get_type (), GtkListClass))
  #define GTK_IS_LIST(obj)       (GTK_CHECK_TYPE (obj, gtk_list_get_type ()))
  }

  type
     PGtkList = ^TGtkList;
{$PACKRECORDS 4}
     TGtkList = record
          container : TGtkContainer;
          children : PGList;
          selection : PGList;
          timer : guint32;
          selection_start_pos : guint16;
          selection_end_pos : guint16;
          flag0 : word;
       end;

  const
     bm_selection_mode = 3;
     bp_selection_mode = 0;
     bm_scroll_direction = 4;
     bp_scroll_direction = 2;
     bm_have_grab = 8;
     bp_have_grab = 3;
  Function  selection_mode(var a : TGtkList) : guint; 
  Procedure set_selection_mode(var a : TGtkList; __selection_mode : guint);
  Function  scroll_direction(var a : TGtkList) : guint;
  Procedure set_scroll_direction(var a : TGtkList; __scroll_direction : guint);
  Function  have_grab(var a : TGtkList) : guint; 
  Procedure set_have_grab(var a : TGtkList; __have_grab : guint);

  type
     PGtkListClass = ^TGtkListClass;
{$PACKRECORDS 4}
     TGtkListClass = record
          parent_class : TGtkContainerClass;
          selection_changed : Procedure (list:pGtkList); cdecl;
          select_child : Procedure (list:pGtkList; child:pGtkWidget); cdecl;
          unselect_child : Procedure (list:pGtkList; child:pGtkWidget); cdecl;
       end;


  Function  gtk_list_get_type:GtkType; cdecl;

  Function  gtk_list_new:PGtkWidget; cdecl;

  Procedure gtk_list_insert_items(list:pGtkList; items:pGList; position:gint); cdecl;

  Procedure gtk_list_append_items(list:pGtkList; items:pGList); cdecl;

  Procedure gtk_list_prepend_items(list:pGtkList; items:pGList); cdecl;

  Procedure gtk_list_remove_items(list:pGtkList; items:pGList); cdecl;

  Procedure gtk_list_remove_items_no_unref(list:pGtkList; items:pGList); cdecl;

  Procedure gtk_list_clear_items(list:pGtkList; start:gint; theend:gint); cdecl;

  Procedure gtk_list_select_item(list:pGtkList; item:gint); cdecl;

  Procedure gtk_list_unselect_item(list:pGtkList; item:gint); cdecl;

  Procedure gtk_list_select_child(list:pGtkList; child:pGtkWidget); cdecl;

  Procedure gtk_list_unselect_child(list:pGtkList; child:pGtkWidget); cdecl;

  Function  gtk_list_child_position(list:pGtkList; child:pGtkWidget):gint; cdecl;

  Procedure gtk_list_set_selection_mode(list:pGtkList; mode:GtkSelectionMode); cdecl;


  implementation

  function selection_mode(var a : TGtkList) : guint;
    begin
       selection_mode:=(a.flag0 and bm_selection_mode) shr bp_selection_mode;
    end;

  procedure set_selection_mode(var a : TGtkList; __selection_mode : guint);
    begin
       a.flag0:=a.flag0 or ((__selection_mode shl bp_selection_mode) and bm_selection_mode);
    end;

  function scroll_direction(var a : TGtkList) : guint;
    begin
       scroll_direction:=(a.flag0 and bm_scroll_direction) shr bp_scroll_direction;
    end;

  procedure set_scroll_direction(var a : TGtkList; __scroll_direction : guint);
    begin
       a.flag0:=a.flag0 or ((__scroll_direction shl bp_scroll_direction) and bm_scroll_direction);
    end;

  function have_grab(var a : TGtkList) : guint;
    begin
       have_grab:=(a.flag0 and bm_have_grab) shr bp_have_grab;
    end;

  procedure set_have_grab(var a : TGtkList; __have_grab : guint);
    begin
       a.flag0:=a.flag0 or ((__have_grab shl bp_have_grab) and bm_have_grab);
    end;

  function gtk_list_get_type:GtkType;CDECL; external;

  function gtk_list_new:PGtkWidget;CDECL; external;

  procedure gtk_list_insert_items(list:pGtkList; items:pGList; position:gint);CDECL; external;

  procedure gtk_list_append_items(list:pGtkList; items:pGList);CDECL; external;

  procedure gtk_list_prepend_items(list:pGtkList; items:pGList);CDECL; external;

  procedure gtk_list_remove_items(list:pGtkList; items:pGList);CDECL; external;

  procedure gtk_list_remove_items_no_unref(list:pGtkList; items:pGList);CDECL; external;

  procedure gtk_list_clear_items(list:pGtkList; start:gint; theend:gint);CDECL; external;

  procedure gtk_list_select_item(list:pGtkList; item:gint);CDECL; external;

  procedure gtk_list_unselect_item(list:pGtkList; item:gint);CDECL; external;

  procedure gtk_list_select_child(list:pGtkList; child:pGtkWidget);CDECL; external;

  procedure gtk_list_unselect_child(list:pGtkList; child:pGtkWidget);CDECL; external;

  function gtk_list_child_position(list:pGtkList; child:pGtkWidget):gint;CDECL; external;

  procedure gtk_list_set_selection_mode(list:pGtkList; mode:GtkSelectionMode);CDECL; external;


end.
