unit gtkmain;

  interface

uses gdk,gdktypes,glib,gtkwidget,gtkenums,gtkobjects;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;
     PPPChar   = ^PPchar;

  const
     GTK_PRIORITY_HIGH = -(20);
     GTK_PRIORITY_INTERNAL = -(10);
     GTK_PRIORITY_DEFAULT = 0;
     GTK_PRIORITY_LOW = 10;

  type

     TGtkKeySnoopFunc = Function  (grab_widget:pGtkWidget;  cdecl;
                                  event:pGdkEventKey; 
                                  func_data:gpointer):gint;

    var
       gtk_major_version : guint; //!! external name 'gtk_major_version';
       gtk_minor_version : guint; //!! external name 'gtk_minor_version';
       gtk_micro_version : guint; //!! external name 'gtk_micro_version';

  Procedure gtk_init(argc:plongint; argv:pppchar); cdecl;

  Procedure gtk_exit(error_code:gint); cdecl;

  Function  gtk_set_locale:pgchar; cdecl;

  Function  gtk_events_pending:gint; cdecl;

  Procedure gtk_main; cdecl;

  Function  gtk_main_level:guint; cdecl;

  Procedure gtk_main_quit; cdecl;

  Function  gtk_main_iteration:gint; cdecl;

  Function  gtk_main_iteration_do(blocking:gboolean):gint; cdecl;

  Function  gtk_true:gint; cdecl;

  Function  gtk_false:gint; cdecl;

  Procedure gtk_grab_add(widget:pGtkWidget); cdecl;

  Function  gtk_grab_get_current:PGtkWidget; cdecl;

  Procedure gtk_grab_remove(widget:pGtkWidget); cdecl;

  Procedure gtk_init_add(theFunction :GtkFunction; data:gpointer); cdecl; cdecl;

  Procedure gtk_quit_add_destroy(main_level:guint; theobject:pGtkObject); cdecl;

  Function  gtk_quit_add(main_level:guint; thefunction:GtkFunction; data:gpointer):guint; cdecl;

  Function  gtk_quit_add_full(main_level:guint; thefunction:GtkFunction; marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint; cdecl;

  Procedure gtk_quit_remove(quit_handler_id:guint); cdecl;

  Procedure gtk_quit_remove_by_data(data:gpointer); cdecl;

  Function  gtk_timeout_add_full(interval:guint32; thefunction:GtkFunction; marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint; cdecl;

  Function  gtk_timeout_add(interval:guint32; thefunction:GtkFunction; data:gpointer):guint; cdecl;

  Function  gtk_timeout_add_interp(interval:guint32; thefunction:GtkCallbackMarshal; data:gpointer; notify:GtkDestroyNotify):guint; cdecl;

  Procedure gtk_timeout_remove(timeout_handler_id:guint); cdecl;

  Function  gtk_idle_add(thefunction:GtkFunction; data:gpointer):guint; cdecl;

  Function  gtk_idle_add_priority(priority:gint; thefunction:GtkFunction; data:gpointer):guint; cdecl;

  Function  gtk_idle_add_full(priority:gint; thefunction:GtkFunction; marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint; cdecl;

  Function  gtk_idle_add_interp(marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint; cdecl;

  Procedure gtk_idle_remove(idle_handler_id:guint); cdecl;

  Procedure gtk_idle_remove_by_data(data:gpointer); cdecl;

  Function  gtk_input_add_full(source:gint; condition:GdkInputCondition; thefunction:GdkInputFunction; marshal:GtkCallbackMarshal; data:gpointer; 
             destroy:GtkDestroyNotify):guint; cdecl;

  Procedure gtk_input_remove(input_handler_id:guint); cdecl;

  Function  gtk_key_snooper_install(snooper:TGtkKeySnoopFunc; func_data:gpointer):guint; cdecl;

  Procedure gtk_key_snooper_remove(snooper_handler_id:guint); cdecl;

  Function  gtk_get_current_event:PGdkEvent; cdecl;

  Function  gtk_get_event_widget(event:pGdkEvent):PGtkWidget; cdecl;

  implementation

const External_library='gtk'; {Setup as you need!}

  procedure gtk_init(argc:plongint; argv:pppchar);CDECL; external;

  procedure gtk_exit(error_code:gint);CDECL; external;

  function gtk_set_locale:pgchar;CDECL; external;

  function gtk_events_pending:gint;CDECL; external;

  procedure gtk_main;CDECL; external;

  function gtk_main_level:guint;CDECL; external;

  procedure gtk_main_quit;CDECL; external;

  function gtk_main_iteration:gint;CDECL; external;

  function gtk_main_iteration_do(blocking:gboolean):gint;CDECL; external;

  function gtk_true:gint;CDECL; external;

  function gtk_false:gint;CDECL; external;

  procedure gtk_grab_add(widget:pGtkWidget);CDECL; external;

  function gtk_grab_get_current:PGtkWidget;CDECL; external;

  procedure gtk_grab_remove(widget:pGtkWidget);CDECL; external;

  procedure gtk_init_add(thefunction:GtkFunction; data:gpointer);CDECL; external;

  procedure gtk_quit_add_destroy(main_level:guint; theobject:pGtkObject);CDECL; external;

  function gtk_quit_add(main_level:guint; thefunction:GtkFunction; data:gpointer):guint;CDECL; external;

  function gtk_quit_add_full(main_level:guint; thefunction:GtkFunction; marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint;CDECL; external;

  procedure gtk_quit_remove(quit_handler_id:guint);CDECL; external;

  procedure gtk_quit_remove_by_data(data:gpointer);CDECL; external;

  function gtk_timeout_add_full(interval:guint32; thefunction:GtkFunction; marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint;CDECL; external;

  function gtk_timeout_add(interval:guint32; thefunction:GtkFunction; data:gpointer):guint;CDECL; external;

  function gtk_timeout_add_interp(interval:guint32; thefunction:GtkCallbackMarshal; data:gpointer; notify:GtkDestroyNotify):guint;CDECL; external;

  procedure gtk_timeout_remove(timeout_handler_id:guint);CDECL; external;

  function gtk_idle_add(thefunction:GtkFunction; data:gpointer):guint;CDECL; external;

  function gtk_idle_add_priority(priority:gint; thefunction:GtkFunction; data:gpointer):guint;CDECL; external;

  function gtk_idle_add_full(priority:gint; thefunction:GtkFunction; marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint;CDECL; external;

  function gtk_idle_add_interp(marshal:GtkCallbackMarshal; data:gpointer; destroy:GtkDestroyNotify):guint;CDECL; external;

  procedure gtk_idle_remove(idle_handler_id:guint);CDECL; external;

  procedure gtk_idle_remove_by_data(data:gpointer);CDECL; external;

  function gtk_input_add_full(source:gint; condition:GdkInputCondition; thefunction:GdkInputFunction; marshal:GtkCallbackMarshal; data:gpointer; 
             destroy:GtkDestroyNotify):guint;CDECL; external;

  procedure gtk_input_remove(input_handler_id:guint);CDECL; external;

  function gtk_key_snooper_install(snooper:TGtkKeySnoopFunc; func_data:gpointer):guint;CDECL; external;

  procedure gtk_key_snooper_remove(snooper_handler_id:guint);CDECL; external;

  function gtk_get_current_event:PGdkEvent;CDECL; external;

  function gtk_get_event_widget(event:pGdkEvent):PGtkWidget;CDECL; external;


end.
