unit gtkmenu;


  interface

uses gdk,glib,gtkaccelerator,gtkmenushell,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_MENU(obj)          GTK_CHECK_CAST (obj, gtk_menu_get_type (), GtkMenu)
  #define GTK_MENU_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_menu_get_type (), GtkMenuClass)
  #define GTK_IS_MENU(obj)       GTK_CHECK_TYPE (obj, gtk_menu_get_type ())
  }

  type
     PGtkMenu = ^TGtkMenu;

     GtkMenuPositionFunc = Procedure (menu:pGtkMenu; x:pgint; y:pgint; user_data:gpointer); cdecl;
     GtkMenuDetachFunc = Procedure (attach_widget:pGtkWidget; menu:pGtkMenu); cdecl;

{$PACKRECORDS 4}
     TGtkMenu = record
          menu_shell : TGtkMenuShell;
          children : PGList;
          parent_menu_item : PGtkWidget;
          old_active_menu_item : PGtkWidget;
          accelerator_table : PGtkAcceleratorTable;
          position_func : GtkMenuPositionFunc;
          position_func_data : gpointer;
       end;

     PGtkMenuClass = ^TGtkMenuClass;
{$PACKRECORDS 4}
     TGtkMenuClass = record
          parent_class : TGtkMenuShellClass;
       end;



  Function  gtk_menu_get_type:guint; cdecl;

  Function  gtk_menu_new:PGtkWidget; cdecl;

  Procedure gtk_menu_append(menu:pGtkMenu; child:pGtkWidget); cdecl;

  Procedure gtk_menu_prepend(menu:pGtkMenu; child:pGtkWidget); cdecl;

  Procedure gtk_menu_insert(menu:pGtkMenu; child:pGtkWidget; position:gint); cdecl;

  Procedure gtk_menu_popup(menu:pGtkMenu; parent_menu_shell:pGtkWidget; parent_menu_item:pGtkWidget; func:GtkMenuPositionFunc; data:gpointer;
              button:guint; activate_time:guint32); cdecl;

  Procedure gtk_menu_popdown(menu:pGtkMenu); cdecl;

  Function  gtk_menu_get_active(menu:pGtkMenu):PGtkWidget; cdecl;

  Procedure gtk_menu_set_active(menu:pGtkMenu; index:guint); cdecl;

  Procedure gtk_menu_set_accelerator_table(menu:pGtkMenu; table:pGtkAcceleratorTable); cdecl;

  Procedure gtk_menu_attach_to_widget(menu:pGtkMenu; attach_widget:pGtkWidget; detacher:GtkMenuDetachFunc); cdecl;

  Function  gtk_menu_get_attach_widget(menu:pGtkMenu):PGtkWidget; cdecl;

  Procedure gtk_menu_detach(menu:pGtkMenu); cdecl;


  implementation

  function gtk_menu_get_type:guint;CDECL; external;

  function gtk_menu_new:PGtkWidget;CDECL; external;

  procedure gtk_menu_append(menu:pGtkMenu; child:pGtkWidget);CDECL; external;

  procedure gtk_menu_prepend(menu:pGtkMenu; child:pGtkWidget);CDECL; external;

  procedure gtk_menu_insert(menu:pGtkMenu; child:pGtkWidget; position:gint);CDECL; external;

  procedure gtk_menu_popup(menu:pGtkMenu; parent_menu_shell:pGtkWidget; parent_menu_item:pGtkWidget; func:GtkMenuPositionFunc; data:gpointer; 
              button:guint; activate_time:guint32);CDECL; external;

  procedure gtk_menu_popdown(menu:pGtkMenu);CDECL; external;

  function gtk_menu_get_active(menu:pGtkMenu):PGtkWidget;CDECL; external;

  procedure gtk_menu_set_active(menu:pGtkMenu; index:guint);CDECL; external;

  procedure gtk_menu_set_accelerator_table(menu:pGtkMenu; table:pGtkAcceleratorTable);CDECL; external;

  procedure gtk_menu_attach_to_widget(menu:pGtkMenu; attach_widget:pGtkWidget; detacher:GtkMenuDetachFunc);CDECL; external;

  function gtk_menu_get_attach_widget(menu:pGtkMenu):PGtkWidget;CDECL; external;

  procedure gtk_menu_detach(menu:pGtkMenu);CDECL; external;


end.
