unit gtkmenufactory;

  interface

uses gdk,glib,gtkwidget,gtkmenushell,gtkenums,gtkaccelerator;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;


  type

     GtkMenuCallback = Procedure (widget:pGtkWidget; user_data:gpointer); cdecl;

     PGtkMenuEntry = ^TGtkMenuEntry;
{$PACKRECORDS 4}
     TGtkMenuEntry = record
          path : pchar;
          accelerator : pchar;
          callback : GtkMenuCallback;
          callback_data : gpointer;
          widget : PGtkWidget;
       end;

     PGtkMenuPath = ^TGtkMenuPath;
{$PACKRECORDS 4}
     TGtkMenuPath = record
          path : pchar;
          widget : PGtkWidget;
       end;

     PGtkMenuFactory = ^TGtkMenuFactory;
{$PACKRECORDS 4}
     TGtkMenuFactory = record
          path : Pchar;
          thetype : GtkMenuFactoryType;
          table : PGtkAcceleratorTable;
          widget : PGtkWidget;
          subfactories : PGList;
       end;


  Function  gtk_menu_factory_new(thetype:GtkMenuFactoryType):PGtkMenuFactory; cdecl;

  Procedure gtk_menu_factory_destroy(factory:pGtkMenuFactory); cdecl;

  Procedure gtk_menu_factory_add_entries(factory:pGtkMenuFactory; entries:pGtkMenuEntry; nentries:longint); cdecl;

  Procedure gtk_menu_factory_add_subfactory(factory:pGtkMenuFactory; subfactory:pGtkMenuFactory; path:pchar); cdecl;

  Procedure gtk_menu_factory_remove_paths(factory:pGtkMenuFactory; paths:ppchar; npaths:longint); cdecl;

  Procedure gtk_menu_factory_remove_entries(factory:pGtkMenuFactory; entries:pGtkMenuEntry; nentries:longint); cdecl;

  Procedure gtk_menu_factory_remove_subfactory(factory:pGtkMenuFactory; subfactory:pGtkMenuFactory; path:pchar); cdecl;

  Function  gtk_menu_factory_find(factory:pGtkMenuFactory; path:pchar):PGtkMenuPath; cdecl;


  implementation

  function gtk_menu_factory_new(thetype:GtkMenuFactoryType):PGtkMenuFactory;CDECL; external;

  procedure gtk_menu_factory_destroy(factory:pGtkMenuFactory);CDECL; external;

  procedure gtk_menu_factory_add_entries(factory:pGtkMenuFactory; entries:pGtkMenuEntry; nentries:longint);CDECL; external;

  procedure gtk_menu_factory_add_subfactory(factory:pGtkMenuFactory; subfactory:pGtkMenuFactory; path:pchar);CDECL; external;

  procedure gtk_menu_factory_remove_paths(factory:pGtkMenuFactory; paths:ppchar; npaths:longint);CDECL; external;

  procedure gtk_menu_factory_remove_entries(factory:pGtkMenuFactory; entries:pGtkMenuEntry; nentries:longint);CDECL; external;

  procedure gtk_menu_factory_remove_subfactory(factory:pGtkMenuFactory; subfactory:pGtkMenuFactory; path:pchar);CDECL; external;

  function gtk_menu_factory_find(factory:pGtkMenuFactory; path:pchar):PGtkMenuPath;CDECL; external;

end.
