unit gtkmenuitem;


  interface

uses gdk,gtkitem,glib,gtkwidget,gtkenums;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_MENU_ITEM(obj)          GTK_CHECK_CAST (obj, gtk_menu_item_get_type (), GtkMenuItem)
    #define GTK_MENU_ITEM_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_menu_item_get_type (), GtkMenuItemClass)
    #define GTK_IS_MENU_ITEM(obj)       GTK_CHECK_TYPE (obj, gtk_menu_item_get_type ())
    }

    type

       PGtkMenuItem = ^TGtkMenuItem;
{$PACKRECORDS 4}
       TGtkMenuItem = record
            item : TGtkItem;
            submenu : PGtkWidget;
            accelerator_signal : guint;
            accelerator_key : gchar;
            accelerator_mods : guint8;
            accelerator_size : guint16;
            toggle_size : guint16;
            flag0 : word;
            timer : gint;
         end;

    const
       bm_show_toggle_indicator = 1;
       bp_show_toggle_indicator = 0;
       bm_show_submenu_indicator = 2;
       bp_show_submenu_indicator = 1;
       bm_submenu_placement = 4;
       bp_submenu_placement = 2;
       bm_submenu_direction = 8;
       bp_submenu_direction = 3;
       bm_right_justify = 16;
       bp_right_justify = 4;
    Function  show_toggle_indicator(var a : TGtkMenuItem) : guint;
    Procedure set_show_toggle_indicator(var a : TGtkMenuItem; __show_toggle_indicator : guint);
    Function  show_submenu_indicator(var a : TGtkMenuItem) : guint;
    Procedure set_show_submenu_indicator(var a : TGtkMenuItem; __show_submenu_indicator : guint);
    Function  submenu_placement(var a : TGtkMenuItem) : guint;
    Procedure set_submenu_placement(var a : TGtkMenuItem; __submenu_placement : guint);
    Function  submenu_direction(var a : TGtkMenuItem) : guint;
    Procedure set_submenu_direction(var a : TGtkMenuItem; __submenu_direction : guint);
    Function  right_justify(var a : TGtkMenuItem) : guint;
    Procedure set_right_justify(var a : TGtkMenuItem; __right_justify : guint);

    type
       PGtkMenuItemClass = ^TGtkMenuItemClass;
{$PACKRECORDS 4}
       TGtkMenuItemClass = record
            parent_class : TGtkItemClass;
            toggle_size : gint;
            shift_text : pgchar;
            control_text : pgchar;
            alt_text : pgchar;
            separator_text : pgchar;
            activate : Procedure (menu_item:pGtkMenuItem); cdecl;
         end;


    Function  gtk_menu_item_get_type:guint; cdecl;

    Function  gtk_menu_item_new : PGtkWidget; cdecl;
    Function  gtk_menu_item_new_with_label (thelabel:pgchar):PGtkWidget; cdecl;

    Procedure gtk_menu_item_set_submenu(menu_item:pGtkMenuItem; submenu:pGtkWidget); cdecl;

    Procedure gtk_menu_item_remove_submenu(menu_item:pGtkMenuItem); cdecl;

    Procedure gtk_menu_item_set_placement(menu_item:pGtkMenuItem; placement:GtkSubmenuPlacement); cdecl;

    Procedure gtk_menu_item_accelerator_size(menu_item:pGtkMenuItem); cdecl;

    Procedure gtk_menu_item_accelerator_text(menu_item:pGtkMenuItem; buffer:pgchar); cdecl;

    Procedure gtk_menu_item_configure(menu_item:pGtkMenuItem; show_toggle_indicator:gint; show_submenu_indicator:gint); cdecl;

    Procedure gtk_menu_item_select(menu_item:pGtkMenuItem); cdecl;

    Procedure gtk_menu_item_deselect(menu_item:pGtkMenuItem); cdecl;

    Procedure gtk_menu_item_activate(menu_item:pGtkMenuItem); cdecl;

    Procedure gtk_menu_item_right_justify(menu_item:pGtkMenuItem); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

    function show_toggle_indicator(var a : TGtkMenuItem) : guint;
      begin
         show_toggle_indicator:=(a.flag0 and bm_show_toggle_indicator) shr bp_show_toggle_indicator;
      end;

    procedure set_show_toggle_indicator(var a : TGtkMenuItem; __show_toggle_indicator : guint);
      begin
         a.flag0:=a.flag0 or ((__show_toggle_indicator shl bp_show_toggle_indicator) and bm_show_toggle_indicator);
      end;

    function show_submenu_indicator(var a : TGtkMenuItem) : guint;
      begin
         show_submenu_indicator:=(a.flag0 and bm_show_submenu_indicator) shr bp_show_submenu_indicator;
      end;

    procedure set_show_submenu_indicator(var a : TGtkMenuItem; __show_submenu_indicator : guint);
      begin
         a.flag0:=a.flag0 or ((__show_submenu_indicator shl bp_show_submenu_indicator) and bm_show_submenu_indicator);
      end;

    function submenu_placement(var a : TGtkMenuItem) : guint;
      begin
         submenu_placement:=(a.flag0 and bm_submenu_placement) shr bp_submenu_placement;
      end;

    procedure set_submenu_placement(var a : TGtkMenuItem; __submenu_placement : guint);
      begin
         a.flag0:=a.flag0 or ((__submenu_placement shl bp_submenu_placement) and bm_submenu_placement);
      end;

    function submenu_direction(var a : TGtkMenuItem) : guint;
      begin
         submenu_direction:=(a.flag0 and bm_submenu_direction) shr bp_submenu_direction;
      end;

    procedure set_submenu_direction(var a : TGtkMenuItem; __submenu_direction : guint);
      begin
         a.flag0:=a.flag0 or ((__submenu_direction shl bp_submenu_direction) and bm_submenu_direction);
      end;

    function right_justify(var a : TGtkMenuItem) : guint;
      begin
         right_justify:=(a.flag0 and bm_right_justify) shr bp_right_justify;
      end;

    procedure set_right_justify(var a : TGtkMenuItem; __right_justify : guint);
      begin
         a.flag0:=a.flag0 or ((__right_justify shl bp_right_justify) and bm_right_justify);
      end;

    function gtk_menu_item_get_type:guint;CDECL; external;

    function gtk_menu_item_new : PGtkWidget;cdecl;external;
    function gtk_menu_item_new_with_label (thelabel: pgchar): PGtkWidget; cdecl; external;

    procedure gtk_menu_item_set_submenu(menu_item:pGtkMenuItem; submenu:pGtkWidget);CDECL; external;

    procedure gtk_menu_item_remove_submenu(menu_item:pGtkMenuItem);CDECL; external;

    procedure gtk_menu_item_set_placement(menu_item:pGtkMenuItem; placement:GtkSubmenuPlacement);CDECL; external;

    procedure gtk_menu_item_accelerator_size(menu_item:pGtkMenuItem);CDECL; external;

    procedure gtk_menu_item_accelerator_text(menu_item:pGtkMenuItem; buffer:pgchar);CDECL; external;

    procedure gtk_menu_item_configure(menu_item:pGtkMenuItem; show_toggle_indicator:gint; show_submenu_indicator:gint);CDECL; external;

    procedure gtk_menu_item_select(menu_item:pGtkMenuItem);CDECL; external;

    procedure gtk_menu_item_deselect(menu_item:pGtkMenuItem);CDECL; external;

    procedure gtk_menu_item_activate(menu_item:pGtkMenuItem);CDECL; external;

    procedure gtk_menu_item_right_justify(menu_item:pGtkMenuItem);CDECL; external;


end.
