unit gtkmenushell;

  interface

uses gdk,glib,gtkcontainer,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_MENU_SHELL(obj)          GTK_CHECK_CAST (obj, gtk_menu_shell_get_type (), GtkMenuShell)
  #define GTK_MENU_SHELL_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_menu_shell_get_type (), GtkMenuShellClass)
  #define GTK_IS_MENU_SHELL(obj)       GTK_CHECK_TYPE (obj, gtk_menu_shell_get_type ())
  }

  type
     PGtkMenuShell = ^TGtkMenuShell;
{$PACKRECORDS 4}
     TGtkMenuShell = record
          container : TGtkContainer;
          children : PGList;
          active_menu_item : PGtkWidget;
          parent_menu_shell : PGtkWidget;
          flag0 : word;
          activate_time : guint32;
       end;

  const
     bm_active = 1;
     bp_active = 0;
     bm_have_grab = 2;
     bp_have_grab = 1;
     bm_have_xgrab = 4;
     bp_have_xgrab = 2;
     bm_button = 24;
     bp_button = 3;
     bm_ignore_leave = 32;
     bp_ignore_leave = 5;
     bm_menu_flag = 64;
     bp_menu_flag = 6;
  Function  active(var a : TGtkMenuShell) : guint;
  Procedure set_active(var a : TGtkMenuShell; __active : guint);
  Function  have_grab(var a : TGtkMenuShell) : guint;
  Procedure set_have_grab(var a : TGtkMenuShell; __have_grab : guint);
  Function  have_xgrab(var a : TGtkMenuShell) : guint;
  Procedure set_have_xgrab(var a : TGtkMenuShell; __have_xgrab : guint);
  Function  button(var a : TGtkMenuShell) : guint;
  Procedure set_button(var a : TGtkMenuShell; __button : guint);
  Function  ignore_leave(var a : TGtkMenuShell) : guint;
  Procedure set_ignore_leave(var a : TGtkMenuShell; __ignore_leave : guint);
  Function  menu_flag(var a : TGtkMenuShell) : guint;
  Procedure set_menu_flag(var a : TGtkMenuShell; __menu_flag : guint);

  type
     PGtkMenuShellClass = ^TGtkMenuShellClass;
{$PACKRECORDS 4}
     TGtkMenuShellClass = record
          parent_class : TGtkContainerClass;
          flag0 : word;
          deactivate : Procedure (menu_shell:pGtkMenuShell); cdecl;
       end;

  const
     bm_submenu_placement = 1;
     bp_submenu_placement = 0;
  Function  submenu_placement(var a : TGtkMenuShellClass) : guint;
  Procedure set_submenu_placement(var a : TGtkMenuShellClass; __submenu_placement : guint);

  Function  gtk_menu_shell_get_type:guint; cdecl;

  Procedure gtk_menu_shell_append(menu_shell:pGtkMenuShell; child:pGtkWidget); cdecl;

  Procedure gtk_menu_shell_prepend(menu_shell:pGtkMenuShell; child:pGtkWidget); cdecl;

  Procedure gtk_menu_shell_insert(menu_shell:pGtkMenuShell; child:pGtkWidget; position:gint); cdecl;

  Procedure gtk_menu_shell_deactivate(menu_shell:pGtkMenuShell); cdecl;


  implementation

  function active(var a : TGtkMenuShell) : guint;
    begin
       active:=(a.flag0 and bm_active) shr bp_active;
    end;

  procedure set_active(var a : TGtkMenuShell; __active : guint);
    begin
       a.flag0:=a.flag0 or ((__active shl bp_active) and bm_active);
    end;

  function have_grab(var a : TGtkMenuShell) : guint;
    begin
       have_grab:=(a.flag0 and bm_have_grab) shr bp_have_grab;
    end;

  procedure set_have_grab(var a : TGtkMenuShell; __have_grab : guint);
    begin
       a.flag0:=a.flag0 or ((__have_grab shl bp_have_grab) and bm_have_grab);
    end;

  function have_xgrab(var a : TGtkMenuShell) : guint;
    begin
       have_xgrab:=(a.flag0 and bm_have_xgrab) shr bp_have_xgrab;
    end;

  procedure set_have_xgrab(var a : TGtkMenuShell; __have_xgrab : guint);
    begin
       a.flag0:=a.flag0 or ((__have_xgrab shl bp_have_xgrab) and bm_have_xgrab);
    end;

  function button(var a : TGtkMenuShell) : guint;
    begin
       button:=(a.flag0 and bm_button) shr bp_button;
    end;

  procedure set_button(var a : TGtkMenuShell; __button : guint);
    begin
       a.flag0:=a.flag0 or ((__button shl bp_button) and bm_button);
    end;

  function ignore_leave(var a : TGtkMenuShell) : guint;
    begin
       ignore_leave:=(a.flag0 and bm_ignore_leave) shr bp_ignore_leave;
    end;

  procedure set_ignore_leave(var a : TGtkMenuShell; __ignore_leave : guint);
    begin
       a.flag0:=a.flag0 or ((__ignore_leave shl bp_ignore_leave) and bm_ignore_leave);
    end;

  function menu_flag(var a : TGtkMenuShell) : guint;
    begin
       menu_flag:=(a.flag0 and bm_menu_flag) shr bp_menu_flag;
    end;

  procedure set_menu_flag(var a : TGtkMenuShell; __menu_flag : guint);
    begin
       a.flag0:=a.flag0 or ((__menu_flag shl bp_menu_flag) and bm_menu_flag);
    end;

  function submenu_placement(var a : TGtkMenuShellClass) : guint;
    begin
       submenu_placement:=(a.flag0 and bm_submenu_placement) shr bp_submenu_placement;
    end;

  procedure set_submenu_placement(var a : TGtkMenuShellClass; __submenu_placement : guint);
    begin
       a.flag0:=a.flag0 or ((__submenu_placement shl bp_submenu_placement) and bm_submenu_placement);
    end;

  function gtk_menu_shell_get_type:guint;CDECL; external;

  procedure gtk_menu_shell_append(menu_shell:pGtkMenuShell; child:pGtkWidget);CDECL; external;

  procedure gtk_menu_shell_prepend(menu_shell:pGtkMenuShell; child:pGtkWidget);CDECL; external;

  procedure gtk_menu_shell_insert(menu_shell:pGtkMenuShell; child:pGtkWidget; position:gint);CDECL; external;

  procedure gtk_menu_shell_deactivate(menu_shell:pGtkMenuShell);CDECL; external;


end.
