unit gtknotebook;

  interface

uses gdk,gdktypes,gtkwidget,glib,gtkcontainer,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_NOTEBOOK(obj)          GTK_CHECK_CAST (obj, gtk_notebook_get_type (), GtkNotebook)
  #define GTK_NOTEBOOK_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_notebook_get_type (), GtkNotebookClass)
  #define GTK_IS_NOTEBOOK(obj)       GTK_CHECK_TYPE (obj, gtk_notebook_get_type ())
  }

  type
     PGtkNotebook = ^TGtkNotebook;
     PGtkNotebookClass = ^TGtkNotebookClass;
     PGtkNotebookPage = ^TGtkNotebookPage;

{$PACKRECORDS 4}
     TGtkNotebook = record
          container : TGtkContainer;
          cur_page : PGtkNotebookPage;
          children : PGList;
          first_tab : PGList;
          focus_tab : PGList;
          menu : PGtkWidget;
          panel : PGdkWindow;
          timer : guint32;
          tab_border : gint16;
          flag0 : word;
       end;
{$PACKRECORDS 4}
     TGtkNotebookClass = record
          parent_class : TGtkContainerClass;
          switch_page : Procedure (notebook:pGtkNotebook; page:pGtkNotebookPage); cdecl;
       end;

{$PACKRECORDS 2}
     TGtkNotebookPage = record
          child : PGtkWidget;
          tab_label : PGtkWidget;
          menu_label : PGtkWidget;
          flag0 : word;
          requisition : TGtkRequisition;
          allocation : TGtkAllocation;
	  pad1 : gint16;
       end;

  const
     bm_show_tabs = 1;
     bp_show_tabs = 0;
     bm_show_border = 2;
     bp_show_border = 1;
     bm_tab_pos = 12;
     bp_tab_pos = 2;
     bm_scrollable = 16;
     bp_scrollable = 4;
     bm_in_child = 96;
     bp_in_child = 5;
     bm_click_child = 384;
     bp_click_child = 7;
     bm_button = 1536;
     bp_button = 9;
     bm_need_timer = 2048;
     bp_need_timer = 11;
  Function  show_tabs(var a : TGtkNotebook) : guint;
  Procedure set_show_tabs(var a : TGtkNotebook; __show_tabs : guint);
  Function  show_border(var a : TGtkNotebook) : guint;
  Procedure set_show_border(var a : TGtkNotebook; __show_border : guint);
  Function  tab_pos(var a : TGtkNotebook) : guint;
  Procedure set_tab_pos(var a : TGtkNotebook; __tab_pos : guint);
  Function  scrollable(var a : TGtkNotebook) : guint;
  Procedure set_scrollable(var a : TGtkNotebook; __scrollable : guint);
  Function  in_child(var a : TGtkNotebook) : guint;
  Procedure set_in_child(var a : TGtkNotebook; __in_child : guint);
  Function  click_child(var a : TGtkNotebook) : guint;
  Procedure set_click_child(var a : TGtkNotebook; __click_child : guint);
  Function  button(var a : TGtkNotebook) : guint;
  Procedure set_button(var a : TGtkNotebook; __button : guint);
  Function  need_timer(var a : TGtkNotebook) : guint;
  Procedure set_need_timer(var a : TGtkNotebook; __need_timer : guint);

  const
     bm_default_menu = 1;
     bp_default_menu = 0;
     bm_default_tab = 2;
     bp_default_tab = 1;
  Function  default_menu(var a : TGtkNotebookPage) : guint; 
  Procedure set_default_menu(var a : TGtkNotebookPage; __default_menu : guint); 
  Function  default_tab(var a : TGtkNotebookPage) : guint; 
  Procedure set_default_tab(var a : TGtkNotebookPage; __default_tab : guint);

  Function  gtk_notebook_get_type:guint; cdecl;

  Function  gtk_notebook_new:PGtkWidget; cdecl;

  Procedure gtk_notebook_append_page(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget); cdecl;

  Procedure gtk_notebook_append_page_menu(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; menu_label:pGtkWidget); cdecl;

  Procedure gtk_notebook_prepend_page(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget); cdecl;

  Procedure gtk_notebook_prepend_page_menu(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; menu_label:pGtkWidget); cdecl;

  Procedure gtk_notebook_insert_page(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; position:gint); cdecl;

  Procedure gtk_notebook_insert_page_menu(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; menu_label:pGtkWidget; position:gint); cdecl;

  Procedure gtk_notebook_remove_page(notebook:pGtkNotebook; page_num:gint); cdecl;

  Function  gtk_notebook_current_page(notebook:pGtkNotebook):gint; cdecl;

  Procedure gtk_notebook_set_page(notebook:pGtkNotebook; page_num:gint); cdecl;

  Procedure gtk_notebook_next_page(notebook:pGtkNotebook); cdecl;

  Procedure gtk_notebook_prev_page(notebook:pGtkNotebook); cdecl;

  Procedure gtk_notebook_set_tab_pos(notebook:pGtkNotebook; pos:GtkPositionType); cdecl;

  Procedure gtk_notebook_set_show_tabs(notebook:pGtkNotebook; show_tabs:gint); cdecl;

  Procedure gtk_notebook_set_show_border(notebook:pGtkNotebook; show_border:gint); cdecl;

  Procedure gtk_notebook_set_scrollable(notebook:pGtkNotebook; scrollable:gint); cdecl;

  Procedure gtk_notebook_set_tab_border(notebook:pGtkNotebook; border_width:gint); cdecl;

  Procedure gtk_notebook_popup_enable(notebook:pGtkNotebook); cdecl;

  Procedure gtk_notebook_popup_disable(notebook:pGtkNotebook); cdecl;


  implementation

  function show_tabs(var a : TGtkNotebook) : guint;
    begin
       show_tabs:=(a.flag0 and bm_show_tabs) shr bp_show_tabs;
    end;

  procedure set_show_tabs(var a : TGtkNotebook; __show_tabs : guint);
    begin
       a.flag0:=a.flag0 or ((__show_tabs shl bp_show_tabs) and bm_show_tabs);
    end;

  function show_border(var a : TGtkNotebook) : guint;
    begin
       show_border:=(a.flag0 and bm_show_border) shr bp_show_border;
    end;

  procedure set_show_border(var a : TGtkNotebook; __show_border : guint);
    begin
       a.flag0:=a.flag0 or ((__show_border shl bp_show_border) and bm_show_border);
    end;

  function tab_pos(var a : TGtkNotebook) : guint;
    begin
       tab_pos:=(a.flag0 and bm_tab_pos) shr bp_tab_pos;
    end;

  procedure set_tab_pos(var a : TGtkNotebook; __tab_pos : guint);
    begin
       a.flag0:=a.flag0 or ((__tab_pos shl bp_tab_pos) and bm_tab_pos);
    end;

  function scrollable(var a : TGtkNotebook) : guint;
    begin
       scrollable:=(a.flag0 and bm_scrollable) shr bp_scrollable;
    end;

  procedure set_scrollable(var a : TGtkNotebook; __scrollable : guint);
    begin
       a.flag0:=a.flag0 or ((__scrollable shl bp_scrollable) and bm_scrollable);
    end;

  function in_child(var a : TGtkNotebook) : guint;
    begin
       in_child:=(a.flag0 and bm_in_child) shr bp_in_child;
    end;

  procedure set_in_child(var a : TGtkNotebook; __in_child : guint);
    begin
       a.flag0:=a.flag0 or ((__in_child shl bp_in_child) and bm_in_child);
    end;

  function click_child(var a : TGtkNotebook) : guint;
    begin
       click_child:=(a.flag0 and bm_click_child) shr bp_click_child;
    end;

  procedure set_click_child(var a : TGtkNotebook; __click_child : guint);
    begin
       a.flag0:=a.flag0 or ((__click_child shl bp_click_child) and bm_click_child);
    end;

  function button(var a : TGtkNotebook) : guint;
    begin
       button:=(a.flag0 and bm_button) shr bp_button;
    end;

  procedure set_button(var a : TGtkNotebook; __button : guint);
    begin
       a.flag0:=a.flag0 or ((__button shl bp_button) and bm_button);
    end;

  function need_timer(var a : TGtkNotebook) : guint;
    begin
       need_timer:=(a.flag0 and bm_need_timer) shr bp_need_timer;
    end;

  procedure set_need_timer(var a : TGtkNotebook; __need_timer : guint);
    begin
       a.flag0:=a.flag0 or ((__need_timer shl bp_need_timer) and bm_need_timer);
    end;

  function default_menu(var a : TGtkNotebookPage) : guint;
    begin
       default_menu:=(a.flag0 and bm_default_menu) shr bp_default_menu;
    end;

  procedure set_default_menu(var a : TGtkNotebookPage; __default_menu : guint);
    begin
       a.flag0:=a.flag0 or ((__default_menu shl bp_default_menu) and bm_default_menu);
    end;

  function default_tab(var a : TGtkNotebookPage) : guint;
    begin
       default_tab:=(a.flag0 and bm_default_tab) shr bp_default_tab;
    end;

  procedure set_default_tab(var a : TGtkNotebookPage; __default_tab : guint);
    begin
       a.flag0:=a.flag0 or ((__default_tab shl bp_default_tab) and bm_default_tab);
    end;

  function gtk_notebook_get_type:guint;CDECL; external;

  function gtk_notebook_new:PGtkWidget;CDECL; external;

  procedure gtk_notebook_append_page(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget);CDECL; external;

  procedure gtk_notebook_append_page_menu(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; menu_label:pGtkWidget);CDECL; external;

  procedure gtk_notebook_prepend_page(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget);CDECL; external;

  procedure gtk_notebook_prepend_page_menu(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; menu_label:pGtkWidget);CDECL; external;

  procedure gtk_notebook_insert_page(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; position:gint);CDECL; external;

  procedure gtk_notebook_insert_page_menu(notebook:pGtkNotebook; child:pGtkWidget; tab_label:pGtkWidget; menu_label:pGtkWidget; position:gint);CDECL; external;

  procedure gtk_notebook_remove_page(notebook:pGtkNotebook; page_num:gint);CDECL; external;

  function gtk_notebook_current_page(notebook:pGtkNotebook):gint;CDECL; external;

  procedure gtk_notebook_set_page(notebook:pGtkNotebook; page_num:gint);CDECL; external;

  procedure gtk_notebook_next_page(notebook:pGtkNotebook);CDECL; external;

  procedure gtk_notebook_prev_page(notebook:pGtkNotebook);CDECL; external;

  procedure gtk_notebook_set_tab_pos(notebook:pGtkNotebook; pos:GtkPositionType);CDECL; external;

  procedure gtk_notebook_set_show_tabs(notebook:pGtkNotebook; show_tabs:gint);CDECL; external;

  procedure gtk_notebook_set_show_border(notebook:pGtkNotebook; show_border:gint);CDECL; external;

  procedure gtk_notebook_set_scrollable(notebook:pGtkNotebook; scrollable:gint);CDECL; external;

  procedure gtk_notebook_set_tab_border(notebook:pGtkNotebook; border_width:gint);CDECL; external;

  procedure gtk_notebook_popup_enable(notebook:pGtkNotebook);CDECL; external;

  procedure gtk_notebook_popup_disable(notebook:pGtkNotebook);CDECL; external;

end.
