unit gtkpaned;

  interface

uses gdk,gdktypes,glib,gtkwidget,gtkcontainer;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_PANED(obj)          GTK_CHECK_CAST (obj, gtk_paned_get_type (), GtkPaned)
  #define GTK_PANED_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_paned_get_type (), GtkPanedClass)
  #define GTK_IS_PANED(obj)       GTK_CHECK_TYPE (obj, gtk_paned_get_type ())
  }

  type
     PGtkPaned = ^TGtkPaned;
{$PACKRECORDS 4}
     TGtkPaned = record
          container : TGtkContainer;
          child1 : PGtkWidget;
          child2 : PGtkWidget;
          handle : PGdkWindow;
          cursor : PGdkCursor;
          groove_rectangle : GdkRectangle;
          xor_gc : PGdkGC;
          handle_size : guint16;
          gutter_size : guint16;
          child1_size : gint;
          flag0 : word;
          handle_xpos : gint16;
          handle_ypos : gint16;
       end;

  const
     bm_position_set = 1;
     bp_position_set = 0;
     bm_in_drag = 2;
     bp_in_drag = 1;
  Function  position_set(var a : TGtkPaned) : guint;
  Procedure set_position_set(var a : TGtkPaned; __position_set : guint);
  Function  in_drag(var a : TGtkPaned) : guint;
  Procedure set_in_drag(var a : TGtkPaned; __in_drag : guint);

  type
     PGtkPanedClass = ^TGtkPanedClass;
{$PACKRECORDS 4}
     TGtkPanedClass = record
          parent_class : TGtkContainerClass;
       end;


  Function  gtk_paned_get_type:guint; cdecl;

  Procedure gtk_paned_add1(paned:pGtkPaned; child:pGtkWidget); cdecl;

  Procedure gtk_paned_add2(paned:pGtkPaned; child:pGtkWidget); cdecl;

  Procedure gtk_paned_handle_size(paned:pGtkPaned; size:guint16); cdecl;

  Procedure gtk_paned_gutter_size(paned:pGtkPaned; size:guint16); cdecl;


  implementation


  function position_set(var a : TGtkPaned) : guint;
    begin
       position_set:=(a.flag0 and bm_position_set) shr bp_position_set;
    end;

  procedure set_position_set(var a : TGtkPaned; __position_set : guint);
    begin
       a.flag0:=a.flag0 or ((__position_set shl bp_position_set) and bm_position_set);
    end;

  function in_drag(var a : TGtkPaned) : guint;
    begin
       in_drag:=(a.flag0 and bm_in_drag) shr bp_in_drag;
    end;

  procedure set_in_drag(var a : TGtkPaned; __in_drag : guint);
    begin
       a.flag0:=a.flag0 or ((__in_drag shl bp_in_drag) and bm_in_drag);
    end;

  function gtk_paned_get_type:guint;CDECL; external;

  procedure gtk_paned_add1(paned:pGtkPaned; child:pGtkWidget);CDECL; external;

  procedure gtk_paned_add2(paned:pGtkPaned; child:pGtkWidget);CDECL; external;

  procedure gtk_paned_handle_size(paned:pGtkPaned; size:guint16);CDECL; external;

  procedure gtk_paned_gutter_size(paned:pGtkPaned; size:guint16);CDECL; external;


end.
