unit gtkpreview;

  interface

uses gdk,gdktypes,glib,gtkwidget,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_PREVIEW(obj)          GTK_CHECK_CAST (obj, gtk_preview_get_type (), GtkPreview)
  #define GTK_PREVIEW_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_preview_get_type (), GtkPreviewClass)
  #define GTK_IS_PREVIEW(obj)       GTK_CHECK_TYPE (obj, gtk_preview_get_type ())
  }

  type
     PGtkPreview = ^TGtkPreview;
{$PACKRECORDS 4}
     TGtkPreview = record
          widget : TGtkWidget;
          buffer : pguchar;
          buffer_width : guint16;
          buffer_height : guint16;
          flag0 : word;
       end;

  const
     bm_type = 1;
     bp_type = 0;
     bm_expand = 2;
     bp_expand = 1;
  Function  thetype(var a : TGtkPreview) : guint;
  Procedure set_type(var a : TGtkPreview; __type : guint); 
  Function  expand(var a : TGtkPreview) : guint; 
  Procedure set_expand(var a : TGtkPreview; __expand : guint); 

  type
     PGtkPreviewInfo = ^TGtkPreviewInfo;
     PGtkDitherInfo = ^TGtkDitherInfo;
{$PACKRECORDS 4}
     TGtkPreviewInfo = record
          visual : PGdkVisual;
          cmap : PGdkColormap;
          color_pixels : pgulong;
          gray_pixels : pgulong;
          reserved_pixels : pgulong;
          lookup_red : pgulong;
          lookup_green : pgulong;
          lookup_blue : pgulong;
          dither_red : PGtkDitherInfo;
          dither_green : PGtkDitherInfo;
          dither_blue : PGtkDitherInfo;
          dither_gray : PGtkDitherInfo;
          dither_matrix : ^ppguchar;
          nred_shades : guint;
          ngreen_shades : guint;
          nblue_shades : guint;
          ngray_shades : guint;
          nreserved : guint;
          bpp : guint;
          cmap_alloced : gint;
          gamma : gdouble;
       end;

{$PACKRECORDS 2}
     TGtkDitherInfo = record
         case longint of
            0 : ( s : array[0..1] of gushort );
            1 : ( c : array[0..3] of guchar );
         end;

     P_GtkPreviewClass = ^T_GtkPreviewClass;
{$PACKRECORDS 4}
     T_GtkPreviewClass = record
          parent_class : TGtkWidgetClass;
          info : TGtkPreviewInfo;
          image : PGdkImage;
       end;


  Function  gtk_preview_get_type:guint; cdecl;

  Procedure gtk_preview_uninit; cdecl;

  Function  gtk_preview_new(thetype:GtkPreviewType):PGtkWidget; cdecl;

  Procedure gtk_preview_size(preview:pGtkPreview; width:gint; height:gint); cdecl;

  Procedure gtk_preview_put(preview:pGtkPreview; window:pGdkWindow; gc:pGdkGC; srcx:gint; srcy:gint;
              destx:gint; desty:gint; width:gint; height:gint); cdecl;

  Procedure gtk_preview_put_row(preview:pGtkPreview; src:pguchar; dest:pguchar; x:gint; y:gint;
              w:gint); cdecl;

  Procedure gtk_preview_draw_row(preview:pGtkPreview; data:pguchar; x:gint; y:gint; w:gint); cdecl;

  Procedure gtk_preview_set_expand(preview:pGtkPreview; expand:gint); cdecl;

  Procedure gtk_preview_set_gamma(gamma:double); cdecl;

  Procedure gtk_preview_set_color_cube(nred_shades:guint; ngreen_shades:guint; nblue_shades:guint; ngray_shades:guint); cdecl;

  Procedure gtk_preview_set_install_cmap(install_cmap:gint); cdecl;

  Procedure gtk_preview_set_reserved(nreserved:gint); cdecl;

  Function  gtk_preview_get_visual:PGdkVisual; cdecl;

  Function  gtk_preview_get_cmap:PGdkColormap; cdecl;

  Function  gtk_preview_get_info:PGtkPreviewInfo; cdecl;

  Procedure gtk_preview_reset; cdecl;


  implementation

  function thetype(var a : TGtkPreview) : guint;
    begin
       thetype:=(a.flag0 and bm_type) shr bp_type;
    end;

  procedure set_type(var a : TGtkPreview; __type : guint);
    begin
       a.flag0:=a.flag0 or ((__type shl bp_type) and bm_type);
    end;

  function expand(var a : TGtkPreview) : guint;
    begin
       expand:=(a.flag0 and bm_expand) shr bp_expand;
    end;

  procedure set_expand(var a : TGtkPreview; __expand : guint);
    begin
       a.flag0:=a.flag0 or ((__expand shl bp_expand) and bm_expand);
    end;

  function gtk_preview_get_type:guint;CDECL; external;

  procedure gtk_preview_uninit;CDECL; external;

  function gtk_preview_new(thetype:GtkPreviewType):PGtkWidget;CDECL; external;

  procedure gtk_preview_size(preview:pGtkPreview; width:gint; height:gint);CDECL; external;

  procedure gtk_preview_put(preview:pGtkPreview; window:pGdkWindow; gc:pGdkGC; srcx:gint; srcy:gint; 
              destx:gint; desty:gint; width:gint; height:gint);CDECL; external;

  procedure gtk_preview_put_row(preview:pGtkPreview; src:pguchar; dest:pguchar; x:gint; y:gint; 
              w:gint);CDECL; external;

  procedure gtk_preview_draw_row(preview:pGtkPreview; data:pguchar; x:gint; y:gint; w:gint);CDECL; external;

  procedure gtk_preview_set_expand(preview:pGtkPreview; expand:gint);CDECL; external;

  procedure gtk_preview_set_gamma(gamma:double);CDECL; external;

  procedure gtk_preview_set_color_cube(nred_shades:guint; ngreen_shades:guint; nblue_shades:guint; ngray_shades:guint);CDECL; external;

  procedure gtk_preview_set_install_cmap(install_cmap:gint);CDECL; external;

  procedure gtk_preview_set_reserved(nreserved:gint);CDECL; external;

  function gtk_preview_get_visual:PGdkVisual;CDECL; external;

  function gtk_preview_get_cmap:PGdkColormap;CDECL; external;

  function gtk_preview_get_info:PGtkPreviewInfo;CDECL; external;

  procedure gtk_preview_reset;CDECL; external;


end.
