unit gtkrange;

  interface

uses gdk,gdktypes,glib,gtkadjustment,gtkwidget,gtkenums;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_RANGE(obj)          GTK_CHECK_CAST (obj, gtk_range_get_type (), GtkRange)
    #define GTK_RANGE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_range_get_type (), GtkRangeClass)
    #define GTK_IS_RANGE(obj)       GTK_CHECK_TYPE (obj, gtk_range_get_type ())
    }

    type

       PGtkRange = ^TGtkRange;
{$PACKRECORDS 4}
       TGtkRange = record
            widget : TGtkWidget;
            trough : PGdkWindow;
            slider : PGdkWindow;
            step_forw : PGdkWindow;
            step_back : PGdkWindow;
            x_click_point : gint16;
            y_click_point : gint16;
            button : guint8;
            digits : gint8;
            flag0 : word;
            timer : guint32;
            old_value : gfloat;
            old_lower : gfloat;
            old_upper : gfloat;
            old_page_size : gfloat;
            adjustment : PGtkAdjustment;
         end;

    const
       bm_policy = 3;
       bp_policy = 0;
       bm_scroll_type = 28;
       bp_scroll_type = 2;
       bm_in_child = 224;
       bp_in_child = 5;
       bm_click_child = 1792;
       bp_click_child = 8;
       bm_need_timer = 2048;
       bp_need_timer = 11;
    Function  policy(var a : TGtkRange) : guint;
    Procedure set_policy(var a : TGtkRange; __policy : guint);
    Function  scroll_type(var a : TGtkRange) : guint;
    Procedure set_scroll_type(var a : TGtkRange; __scroll_type : guint);
    Function  in_child(var a : TGtkRange) : guint;
    Procedure set_in_child(var a : TGtkRange; __in_child : guint);
    Function  click_child(var a : TGtkRange) : guint;
    Procedure set_click_child(var a : TGtkRange; __click_child : guint);
    Function  need_timer(var a : TGtkRange) : guint;
    Procedure set_need_timer(var a : TGtkRange; __need_timer : guint);

    type
       PGtkRangeClass = ^TGtkRangeClass;
{$PACKRECORDS 4}
       TGtkRangeClass = record
            parent_class : TGtkWidgetClass;
            slider_width : gint;
            stepper_size : gint;
            stepper_slider_spacing : gint;
            min_slider_size : gint;
            trough : guint8;
            slider : guint8;
            step_forw : guint8;
            step_back : guint8;
            draw_background : Procedure (range:pGtkRange); cdecl;
            draw_trough : Procedure (range:pGtkRange); cdecl;
            draw_slider : Procedure (range:pGtkRange); cdecl;
            draw_step_forw : Procedure (range:pGtkRange); cdecl;
            draw_step_back : Procedure (range:pGtkRange); cdecl;
            slider_update : Procedure (range:pGtkRange); cdecl;
            trough_click : Function  (range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint; cdecl;
            trough_keys : Function  (range:pGtkRange; key:pGdkEventKey; scroll:pGtkScrollType; trough:pGtkTroughType):gint; cdecl;
            motion : Procedure (range:pGtkRange; xdelta:gint; ydelta:gint); cdecl;
            timer : Function  (range:pGtkRange):gint; cdecl;
         end;


    Function  gtk_range_get_type:guint; cdecl;


    Function  gtk_range_get_adjustment (range:pGtkRange):PGtkAdjustment; cdecl;

    Procedure gtk_range_set_update_policy(range:pGtkRange; policy:GtkUpdateType); cdecl;

    Procedure gtk_range_set_adjustment(range:pGtkRange; adjustment:pGtkAdjustment); cdecl;

    Procedure gtk_range_draw_background(range:pGtkRange); cdecl;

    Procedure gtk_range_draw_trough(range:pGtkRange); cdecl;

    Procedure gtk_range_draw_slider(range:pGtkRange); cdecl;

    Procedure gtk_range_draw_step_forw(range:pGtkRange); cdecl;

    Procedure gtk_range_draw_step_back(range:pGtkRange); cdecl;

    Procedure gtk_range_slider_update(range:pGtkRange); cdecl;

    Function  gtk_range_trough_click(range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint; cdecl;

    Procedure gtk_range_default_hslider_update(range:pGtkRange); cdecl;

    Procedure gtk_range_default_vslider_update(range:pGtkRange); cdecl;

    Function  gtk_range_default_htrough_click(range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint; cdecl;

    Function  gtk_range_default_vtrough_click(range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint; cdecl;

    Procedure gtk_range_default_hmotion(range:pGtkRange; xdelta:gint; ydelta:gint); cdecl;

    Procedure gtk_range_default_vmotion(range:pGtkRange; xdelta:gint; ydelta:gint); cdecl;


  implementation

    function policy(var a : TGtkRange) : guint;
      begin
         policy:=(a.flag0 and bm_policy) shr bp_policy;
      end;

    procedure set_policy(var a : TGtkRange; __policy : guint);
      begin
         a.flag0:=a.flag0 or ((__policy shl bp_policy) and bm_policy);
      end;

    function scroll_type(var a : TGtkRange) : guint;
      begin
         scroll_type:=(a.flag0 and bm_scroll_type) shr bp_scroll_type;
      end;

    procedure set_scroll_type(var a : TGtkRange; __scroll_type : guint);
      begin
         a.flag0:=a.flag0 or ((__scroll_type shl bp_scroll_type) and bm_scroll_type);
      end;

    function in_child(var a : TGtkRange) : guint;
      begin
         in_child:=(a.flag0 and bm_in_child) shr bp_in_child;
      end;

    procedure set_in_child(var a : TGtkRange; __in_child : guint);
      begin
         a.flag0:=a.flag0 or ((__in_child shl bp_in_child) and bm_in_child);
      end;

    function click_child(var a : TGtkRange) : guint;
      begin
         click_child:=(a.flag0 and bm_click_child) shr bp_click_child;
      end;

    procedure set_click_child(var a : TGtkRange; __click_child : guint);
      begin
         a.flag0:=a.flag0 or ((__click_child shl bp_click_child) and bm_click_child);
      end;

    function need_timer(var a : TGtkRange) : guint;
      begin
         need_timer:=(a.flag0 and bm_need_timer) shr bp_need_timer;
      end;

    procedure set_need_timer(var a : TGtkRange; __need_timer : guint);
      begin
         a.flag0:=a.flag0 or ((__need_timer shl bp_need_timer) and bm_need_timer);
      end;

    function gtk_range_get_type:guint;CDECL; external;

    procedure gtk_range_set_update_policy(range:pGtkRange; policy:GtkUpdateType);CDECL; external;

    procedure gtk_range_set_adjustment(range:pGtkRange; adjustment:pGtkAdjustment);CDECL; external;

    procedure gtk_range_draw_background(range:pGtkRange);CDECL; external;

    procedure gtk_range_draw_trough(range:pGtkRange);CDECL; external;

    procedure gtk_range_draw_slider(range:pGtkRange);CDECL; external;

    procedure gtk_range_draw_step_forw(range:pGtkRange);CDECL; external;

    procedure gtk_range_draw_step_back(range:pGtkRange);CDECL; external;

    procedure gtk_range_slider_update(range:pGtkRange);CDECL; external;

    function gtk_range_trough_click(range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint;CDECL; external;

    procedure gtk_range_default_hslider_update(range:pGtkRange);CDECL; external;

    procedure gtk_range_default_vslider_update(range:pGtkRange);CDECL; external;

    function gtk_range_default_htrough_click(range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint;CDECL; external;

    function gtk_range_default_vtrough_click(range:pGtkRange; x:gint; y:gint; jump_perc:pgfloat):gint;CDECL; external;

    procedure gtk_range_default_hmotion(range:pGtkRange; xdelta:gint; ydelta:gint);CDECL; external;

    procedure gtk_range_default_vmotion(range:pGtkRange; xdelta:gint; ydelta:gint);CDECL; external;

    function gtk_range_get_adjustment (range:pGtkRange):PGtkAdjustment;cdecl;external;


end.
