unit gtkruler;


  interface

uses gdk,glib,gdktypes,gtkwidget,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_RULER(obj)          GTK_CHECK_CAST (obj, gtk_ruler_get_type (), GtkRuler)
  #define GTK_RULER_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_ruler_get_type (), GtkRulerClass)
  #define GTK_IS_RULER(obj)       GTK_CHECK_TYPE (obj, gtk_ruler_get_type ())
  }

  type
     PGtkRulerMetric = ^TGtkRulerMetric;

     PGtkRuler = ^TGtkRuler;
{$PACKRECORDS 4}
     TGtkRuler = record
          widget : TGtkWidget;
          backing_store : PGdkPixmap;
          non_gr_exp_gc : PGdkGC;
          metric : PGtkRulerMetric;
          xsrc : gint;
          ysrc : gint;
          slider_size : gint;
          lower : gfloat;
          upper : gfloat;
          position : gfloat;
          max_size : gfloat;
       end;

     PGtkRulerClass = ^TGtkRulerClass;
{$PACKRECORDS 4}
     TGtkRulerClass = record
          parent_class : TGtkWidgetClass;
          draw_ticks : Procedure (ruler:pGtkRuler); cdecl;
          draw_pos : Procedure (ruler:pGtkRuler); cdecl;
       end;

{$PACKRECORDS 4}
     TGtkRulerMetric = record
          metric_name : ^gchar;
          abbrev : ^gchar;
          pixels_per_unit : gfloat;
          ruler_scale : array[0..9] of gfloat;
          subdivide : array[0..4] of gint;
       end;


  Function  gtk_ruler_get_type:guint; cdecl;

  Procedure gtk_ruler_set_metric(ruler:pGtkRuler; metric:GtkMetricType); cdecl;

  Procedure gtk_ruler_set_range(ruler:pGtkRuler; lower:gfloat; upper:gfloat; position:gfloat; max_size:gfloat); cdecl;

  Procedure gtk_ruler_draw_ticks(ruler:pGtkRuler); cdecl;

  Procedure gtk_ruler_draw_pos(ruler:pGtkRuler); cdecl;


  implementation


  function gtk_ruler_get_type:guint;CDECL; external;

  procedure gtk_ruler_set_metric(ruler:pGtkRuler; metric:GtkMetricType);CDECL; external;

  procedure gtk_ruler_set_range(ruler:pGtkRuler; lower:gfloat; upper:gfloat; position:gfloat; max_size:gfloat);CDECL; external;

  procedure gtk_ruler_draw_ticks(ruler:pGtkRuler);CDECL; external;

  procedure gtk_ruler_draw_pos(ruler:pGtkRuler);CDECL; external;


end.
