unit gtkscale;

  interface

uses gdk,gtkrange, gtkwidget,glib,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_SCALE(obj)          GTK_CHECK_CAST (obj, gtk_scale_get_type (), GtkScale)
  #define GTK_SCALE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_scale_get_type (), GtkScaleClass)
  #define GTK_IS_SCALE(obj)       GTK_CHECK_TYPE (obj, gtk_scale_get_type ())
  }

  type
     PGtkScale = ^TGtkScale;
{$PACKRECORDS 4}
     TGtkScale = record
          range : TGtkRange;
          flag0 : word;
       end;

  const
     bm_draw_value = 1;
     bp_draw_value = 0;
     bm_value_pos = 6;
     bp_value_pos = 1;
  Function  draw_value(var a : TGtkScale) : guint; 
  Procedure set_draw_value(var a : TGtkScale; __draw_value : guint); 
  Function  value_pos(var a : TGtkScale) : guint;
  Procedure set_value_pos(var a : TGtkScale; __value_pos : guint);

  type
     PGtkScaleClass = ^TGtkScaleClass;
{$PACKRECORDS 4}
     TGtkScaleClass = record
          parent_class : TGtkRangeClass;
          slider_length : gint;
          value_spacing : gint;
          draw_value : Procedure (scale:pGtkScale); cdecl;
       end;


  Function  gtk_scale_get_type:guint; cdecl;

  Procedure gtk_scale_set_digits(scale:pGtkScale; digits:gint); cdecl;

  Procedure gtk_scale_set_draw_value(scale:pGtkScale; draw_value:gint); cdecl;

  Procedure gtk_scale_set_value_pos(scale:pGtkScale; pos:GtkPositionType); cdecl;

  Function  gtk_scale_value_width(scale:pGtkScale):gint; cdecl;

  Procedure gtk_scale_draw_value(scale:pGtkScale); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function draw_value(var a : TGtkScale) : guint;
    begin
       draw_value:=(a.flag0 and bm_draw_value) shr bp_draw_value;
    end;

  procedure set_draw_value(var a : TGtkScale; __draw_value : guint);
    begin
       a.flag0:=a.flag0 or ((__draw_value shl bp_draw_value) and bm_draw_value);
    end;

  function value_pos(var a : TGtkScale) : guint;
    begin
       value_pos:=(a.flag0 and bm_value_pos) shr bp_value_pos;
    end;

  procedure set_value_pos(var a : TGtkScale; __value_pos : guint);
    begin
       a.flag0:=a.flag0 or ((__value_pos shl bp_value_pos) and bm_value_pos);
    end;

  function gtk_scale_get_type:guint;CDECL; external;

  procedure gtk_scale_set_digits(scale:pGtkScale; digits:gint);CDECL; external;

  procedure gtk_scale_set_draw_value(scale:pGtkScale; draw_value:gint);CDECL; external;

  procedure gtk_scale_set_value_pos(scale:pGtkScale; pos:GtkPositionType);CDECL; external;

  function gtk_scale_value_width(scale:pGtkScale):gint;CDECL; external;

  procedure gtk_scale_draw_value(scale:pGtkScale);CDECL; external;


end.
