unit gtkscrolledwindow;

  interface

uses gdk,glib,gtkhscrollbar,gtkvscrollbar,gtkviewport,gtkwidget,
     gtkadjustment,gtkcontainer,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_SCROLLED_WINDOW(obj)          GTK_CHECK_CAST (obj, gtk_scrolled_window_get_type (), GtkScrolledWindow)
  #define GTK_SCROLLED_WINDOW_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_scrolled_window_get_type (), GtkScrolledWindowClass)
  #define GTK_IS_SCROLLED_WINDOW(obj)       GTK_CHECK_TYPE (obj, gtk_scrolled_window_get_type ())
  }

  type
     PGtkScrolledWindow = ^TGtkScrolledWindow;
{$PACKRECORDS 4}
     TGtkScrolledWindow = record
          container : TGtkContainer;
          viewport : PGtkWidget;
          hscrollbar : PGtkWidget;
          vscrollbar : PGtkWidget;
          hscrollbar_policy : guint8;
          vscrollbar_policy : guint8;
          flag0 : word;
       end;

  const
     bm_hscrollbar_visible = 1;
     bp_hscrollbar_visible = 0;
     bm_vscrollbar_visible = 2;
     bp_vscrollbar_visible = 1;
  Function  hscrollbar_visible(var a : TGtkScrolledWindow) : gint;
  Procedure set_hscrollbar_visible(var a : TGtkScrolledWindow; __hscrollbar_visible : gint);
  Function  vscrollbar_visible(var a : TGtkScrolledWindow) : gint;
  Procedure set_vscrollbar_visible(var a : TGtkScrolledWindow; __vscrollbar_visible : gint);

  type
     PGtkScrolledWindowClass = ^TGtkScrolledWindowClass;
{$PACKRECORDS 4}
     TGtkScrolledWindowClass = record
          parent_class : TGtkContainerClass;
          scrollbar_spacing : gint;
       end;


  Function  gtk_scrolled_window_get_type:guint; cdecl;

  Function  gtk_scrolled_window_new(hadjustment:pGtkAdjustment; vadjustment:pGtkAdjustment):PGtkWidget; cdecl;

  Procedure gtk_scrolled_window_construct(scrolled_window:pGtkScrolledWindow; hadjustment:pGtkAdjustment; vadjustment:pGtkAdjustment); cdecl;

  Function  gtk_scrolled_window_get_hadjustment(scrolled_window:pGtkScrolledWindow):PGtkAdjustment; cdecl;

  Function  gtk_scrolled_window_get_vadjustment(scrolled_window:pGtkScrolledWindow):PGtkAdjustment; cdecl;

  Procedure gtk_scrolled_window_set_policy(scrolled_window:pGtkScrolledWindow; hscrollbar_policy:GtkPolicyType; vscrollbar_policy:GtkPolicyType); cdecl;


  implementation


  function hscrollbar_visible(var a : TGtkScrolledWindow) : gint;
    begin
       hscrollbar_visible:=(a.flag0 and bm_hscrollbar_visible) shr bp_hscrollbar_visible;
    end;

  procedure set_hscrollbar_visible(var a : TGtkScrolledWindow; __hscrollbar_visible : gint);
    begin
       a.flag0:=a.flag0 or ((__hscrollbar_visible shl bp_hscrollbar_visible) and bm_hscrollbar_visible);
    end;

  function vscrollbar_visible(var a : TGtkScrolledWindow) : gint;
    begin
       vscrollbar_visible:=(a.flag0 and bm_vscrollbar_visible) shr bp_vscrollbar_visible;
    end;

  procedure set_vscrollbar_visible(var a : TGtkScrolledWindow; __vscrollbar_visible : gint);
    begin
       a.flag0:=a.flag0 or ((__vscrollbar_visible shl bp_vscrollbar_visible) and bm_vscrollbar_visible);
    end;

  function gtk_scrolled_window_get_type:guint;CDECL; external;

  function gtk_scrolled_window_new(hadjustment:pGtkAdjustment; vadjustment:pGtkAdjustment):PGtkWidget;CDECL; external;

  procedure gtk_scrolled_window_construct(scrolled_window:pGtkScrolledWindow; hadjustment:pGtkAdjustment; vadjustment:pGtkAdjustment);CDECL; external;

  function gtk_scrolled_window_get_hadjustment(scrolled_window:pGtkScrolledWindow):PGtkAdjustment;CDECL; external;

  function gtk_scrolled_window_get_vadjustment(scrolled_window:pGtkScrolledWindow):PGtkAdjustment;CDECL; external;

  procedure gtk_scrolled_window_set_policy(scrolled_window:pGtkScrolledWindow; hscrollbar_policy:GtkPolicyType; vscrollbar_policy:GtkPolicyType);CDECL; external;


end.
