unit gtkspinbutton;

  interface

uses gdk,gdktypes,glib,gtkentry,gtkadjustment,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {  
  #define GTK_SPIN_BUTTON(obj)	      GTK_CHECK_CAST (obj, gtk_spin_button_get_type (), GtkSpinButton)
  #define GTK_SPIN_BUTTON_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_spin_button_get_type (), GtkSpinButtonClass)
  #define GTK_IS_SPIN_BUTTON(obj)	      GTK_CHECK_TYPE (obj, gtk_spin_button_get_type ())
  }

  type

     GtkSpinButtonUpdatePolicy =  Longint;
       Const
       GTK_UPDATE_ALWAYS = 1 shl 0;
       GTK_UPDATE_IF_VALID = 1 shl 1;
       GTK_UPDATE_SNAP_TO_TICKS = 1 shl 2;

  type
     PGtkSpinButton = ^TGtkSpinButton;
{$PACKRECORDS 4}
     TGtkSpinButton = record
          entry : TGtkEntry;
          adjustment : PGtkAdjustment;
          panel : PGdkWindow;
          timer : guint32;
          climb_rate : gfloat;
          timer_step : gfloat;
          update_policy : guint8;
          flag0 : word;
       end;

  const
     bm_in_child = 3;
     bp_in_child = 0;
     bm_click_child = 12;
     bp_click_child = 2;
     bm_button = 48;
     bp_button = 4;
     bm_need_timer = 64;
     bp_need_timer = 6;
     bm_timer_calls = 896;
     bp_timer_calls = 7;
     bm_digits = 7168;
     bp_digits = 10;
     bm_numeric = 8192;
     bp_numeric = 13;
     bm_wrap = 16384;
     bp_wrap = 14;
  Function  in_child(var a : TGtkSpinButton) : guint;
  Procedure set_in_child(var a : TGtkSpinButton; __in_child : guint);
  Function  click_child(var a : TGtkSpinButton) : guint;
  Procedure set_click_child(var a : TGtkSpinButton; __click_child : guint);
  Function  button(var a : TGtkSpinButton) : guint;
  Procedure set_button(var a : TGtkSpinButton; __button : guint);
  Function  need_timer(var a : TGtkSpinButton) : guint;
  Procedure set_need_timer(var a : TGtkSpinButton; __need_timer : guint);
  Function  timer_calls(var a : TGtkSpinButton) : guint;
  Procedure set_timer_calls(var a : TGtkSpinButton; __timer_calls : guint);
  Function  digits(var a : TGtkSpinButton) : guint;
  Procedure set_digits(var a : TGtkSpinButton; __digits : guint);
  Function  numeric(var a : TGtkSpinButton) : guint;
  Procedure set_numeric(var a : TGtkSpinButton; __numeric : guint);
  Function  wrap(var a : TGtkSpinButton) : guint;
  Procedure set_wrap(var a : TGtkSpinButton; __wrap : guint);

  type
     PGtkSpinButtonClass = ^TGtkSpinButtonClass;
{$PACKRECORDS 4}
     TGtkSpinButtonClass = record
          parent_class : TGtkEntryClass;
       end;


  Function  gtk_spin_button_get_type:guint; cdecl;

  Procedure gtk_spin_button_construct(spin_button:pGtkSpinButton; adjustment:pGtkAdjustment; climb_rate:gfloat; digits:gint); cdecl;

  Function  gtk_spin_button_new(adjustment:pGtkAdjustment; climb_rate:gfloat; digits:gint):pGtkWidget; cdecl;

  Procedure gtk_spin_button_set_adjustment(spin_button:pGtkSpinButton; adjustment:pGtkAdjustment); cdecl;

  Function  gtk_spin_button_get_adjustment(spin_button:pGtkSpinButton):PGtkAdjustment; cdecl;

  Procedure gtk_spin_button_set_digits(spin_button:pGtkSpinButton; digits:gint); cdecl;

  Function  gtk_spin_button_get_value_as_float(spin_button:pGtkSpinButton):gfloat; cdecl;

  Function  gtk_spin_button_get_value_as_int(spin_button:pGtkSpinButton):gint; cdecl;

  Procedure gtk_spin_button_set_value(spin_button:pGtkSpinButton; value:gfloat); cdecl;

  Procedure gtk_spin_button_set_update_policy(spin_button:pGtkSpinButton; policy:GtkSpinButtonUpdatePolicy); cdecl;

  Procedure gtk_spin_button_set_numeric(spin_button:pGtkSpinButton; numeric:gint); cdecl;

  Procedure gtk_spin_button_spin(spin_button:pGtkSpinButton; direction:guint; step:gfloat); cdecl;

  Procedure gtk_spin_button_set_wrap(spin_button:pGtkSpinButton; wrap:gint); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function in_child(var a : TGtkSpinButton) : guint;
    begin
       in_child:=(a.flag0 and bm_in_child) shr bp_in_child;
    end;

  procedure set_in_child(var a : TGtkSpinButton; __in_child : guint);
    begin
       a.flag0:=a.flag0 or ((__in_child shl bp_in_child) and bm_in_child);
    end;

  function click_child(var a : TGtkSpinButton) : guint;
    begin
       click_child:=(a.flag0 and bm_click_child) shr bp_click_child;
    end;

  procedure set_click_child(var a : TGtkSpinButton; __click_child : guint);
    begin
       a.flag0:=a.flag0 or ((__click_child shl bp_click_child) and bm_click_child);
    end;

  function button(var a : TGtkSpinButton) : guint;
    begin
       button:=(a.flag0 and bm_button) shr bp_button;
    end;

  procedure set_button(var a : TGtkSpinButton; __button : guint);
    begin
       a.flag0:=a.flag0 or ((__button shl bp_button) and bm_button);
    end;

  function need_timer(var a : TGtkSpinButton) : guint;
    begin
       need_timer:=(a.flag0 and bm_need_timer) shr bp_need_timer;
    end;

  procedure set_need_timer(var a : TGtkSpinButton; __need_timer : guint);
    begin
       a.flag0:=a.flag0 or ((__need_timer shl bp_need_timer) and bm_need_timer);
    end;

  function timer_calls(var a : TGtkSpinButton) : guint;
    begin
       timer_calls:=(a.flag0 and bm_timer_calls) shr bp_timer_calls;
    end;

  procedure set_timer_calls(var a : TGtkSpinButton; __timer_calls : guint);
    begin
       a.flag0:=a.flag0 or ((__timer_calls shl bp_timer_calls) and bm_timer_calls);
    end;

  function digits(var a : TGtkSpinButton) : guint;
    begin
       digits:=(a.flag0 and bm_digits) shr bp_digits;
    end;

  procedure set_digits(var a : TGtkSpinButton; __digits : guint);
    begin
       a.flag0:=a.flag0 or ((__digits shl bp_digits) and bm_digits);
    end;

  function numeric(var a : TGtkSpinButton) : guint;
    begin
       numeric:=(a.flag0 and bm_numeric) shr bp_numeric;
    end;

  procedure set_numeric(var a : TGtkSpinButton; __numeric : guint);
    begin
       a.flag0:=a.flag0 or ((__numeric shl bp_numeric) and bm_numeric);
    end;

  function wrap(var a : TGtkSpinButton) : guint;
    begin
       wrap:=(a.flag0 and bm_wrap) shr bp_wrap;
    end;

  procedure set_wrap(var a : TGtkSpinButton; __wrap : guint);
    begin
       a.flag0:=a.flag0 or ((__wrap shl bp_wrap) and bm_wrap);
    end;

  function gtk_spin_button_get_type:guint;CDECL; external;

  procedure gtk_spin_button_construct(spin_button:pGtkSpinButton; adjustment:pGtkAdjustment; climb_rate:gfloat; digits:gint);CDECL; external;

  function gtk_spin_button_new(adjustment:pGtkAdjustment; climb_rate:gfloat; digits:gint):pGtkWidget;CDECL; external;

  procedure gtk_spin_button_set_adjustment(spin_button:pGtkSpinButton; adjustment:pGtkAdjustment);CDECL; external;

  function gtk_spin_button_get_adjustment(spin_button:pGtkSpinButton):PGtkAdjustment;CDECL; external;

  procedure gtk_spin_button_set_digits(spin_button:pGtkSpinButton; digits:gint);CDECL; external;

  function gtk_spin_button_get_value_as_float(spin_button:pGtkSpinButton):gfloat;CDECL; external;

  function gtk_spin_button_get_value_as_int(spin_button:pGtkSpinButton):gint;CDECL; external;

  procedure gtk_spin_button_set_value(spin_button:pGtkSpinButton; value:gfloat);CDECL; external;

  procedure gtk_spin_button_set_update_policy(spin_button:pGtkSpinButton; policy:GtkSpinButtonUpdatePolicy);CDECL; external;

  procedure gtk_spin_button_set_numeric(spin_button:pGtkSpinButton; numeric:gint);CDECL; external;

  procedure gtk_spin_button_spin(spin_button:pGtkSpinButton; direction:guint; step:gfloat);CDECL; external;

  procedure gtk_spin_button_set_wrap(spin_button:pGtkSpinButton; wrap:gint);CDECL; external;


end.
