unit gtkstatusbar;

  interface

uses gdk,glib,gtkwidget,gtkhbox;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_STATUSBAR(obj)          GTK_CHECK_CAST (obj, gtk_statusbar_get_type (), GtkStatusbar)
  #define GTK_STATUSBAR_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_statusbar_get_type (), GtkStatusbarClass)
  #define GTK_IS_STATUSBAR(obj)       GTK_CHECK_TYPE (obj, gtk_statusbar_get_type ())
  }

  type
     PGtkStatusbar = ^TGtkStatusbar;
{$PACKRECORDS 4}
     TGtkStatusbar = record
          parent_widget : TGtkHBox;
          frame : PGtkWidget;
          thelabel : PGtkWidget;
          messages : PGSList;
          keys : PGSList;
          seq_context_id : guint;
          seq_message_id : guint;
       end;

     PGtkStatusbarClass = ^TGtkStatusbarClass;
{$PACKRECORDS 4}
     TGtkStatusbarClass = record
          parent_class : TGtkHBoxClass;
          messages_mem_chunk : PGMemChunk;
          text_pushed : Procedure (statusbar:pGtkStatusbar; context_id:guint; thetext:pgchar); cdecl;
          text_popped : Procedure (statusbar:pGtkStatusbar; context_id:guint; thetext:pgchar); cdecl;
       end;

     PGtkStatusbarMsg = ^TGtkStatusbarMsg;
{$PACKRECORDS 4}
     TGtkStatusbarMsg = record
          thetext : pgchar;
          context_id : guint;
          message_id : guint;
       end;


  Function  gtk_statusbar_get_type:guint; cdecl;

  Function  gtk_statusbar_new:PGtkWidget; cdecl;

  Function  gtk_statusbar_get_context_id(statusbar:pGtkStatusbar; context_description:pgchar):guint; cdecl;

  Function  gtk_statusbar_push(statusbar:pGtkStatusbar; context_id:guint; thetext:pgchar):guint; cdecl;

  Procedure gtk_statusbar_pop(statusbar:pGtkStatusbar; context_id:guint); cdecl;

  Procedure gtk_statusbar_remove(statusbar:pGtkStatusbar; context_id:guint; message_id:guint); cdecl;


  implementation


  function gtk_statusbar_get_type:guint;CDECL; external;

  function gtk_statusbar_new:PGtkWidget;CDECL; external;

  function gtk_statusbar_get_context_id(statusbar:pGtkStatusbar; context_description:pgchar):guint;CDECL; external;

  function gtk_statusbar_push(statusbar:pGtkStatusbar; context_id:guint; thetext:pgchar):guint;CDECL; external;

  procedure gtk_statusbar_pop(statusbar:pGtkStatusbar; context_id:guint);CDECL; external;

  procedure gtk_statusbar_remove(statusbar:pGtkStatusbar; context_id:guint; message_id:guint);CDECL; external;


end.
