unit gtkstyle;

  interface

uses gdk,gtkenums,gdktypes,glib;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;


    const
       GTK_STYLE_NUM_STYLECOLORS = 35;

    type
       PGtkStyleClass = ^TGtkStyleClass;
       PGtkStyle = ^TGtkStyle;
{$PACKRECORDS 4}
       TGtkStyle = record
            fg : array[0..4] of GdkColor;
            bg : array[0..4] of GdkColor;
            light : array[0..4] of GdkColor;
            dark : array[0..4] of GdkColor;
            mid : array[0..4] of GdkColor;
            text : array[0..4] of GdkColor;
            base : array[0..4] of GdkColor;
            black : GdkColor;
            white : GdkColor;
            font : PGdkFont;
            fg_gc : array[0..4] of PGdkGC;
            bg_gc : array[0..4] of PGdkGC;
            light_gc : array[0..4] of PGdkGC;
            dark_gc : array[0..4] of PGdkGC;
            mid_gc : array[0..4] of PGdkGC;
            text_gc : array[0..4] of PGdkGC;
            base_gc : array[0..4] of PGdkGC;
            black_gc : PGdkGC;
            white_gc : PGdkGC;
            bg_pixmap : array[0..4] of PGdkPixmap;
            ref_count : gint;
            attach_count : gint;
            depth : gint;
            colormap : PGdkColormap;
            klass : PGtkStyleClass;
         end;

{$PACKRECORDS 4}
       TGtkStyleClass = record
            xthickness : gint;
            ythickness : gint;
            draw_hline : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; x1:gint; x2:gint;  cdecl;
                          y:gint);
            draw_vline : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; y1:gint; y2:gint;  cdecl;
                          x:gint);
            draw_shadow : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint;  cdecl;
                          y:gint; width:gint; height:gint);
            draw_polygon : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; point:pGdkPoint;  cdecl;
                          npoints:gint; fill:gint);
            draw_arrow : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; arrow_type:GtkArrowType;  cdecl;
                          fill:gint; x:gint; y:gint; width:gint; height:gint);
            draw_diamond : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint;  cdecl;
                          y:gint; width:gint; height:gint);
            draw_oval : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint;  cdecl;
                          y:gint; width:gint; height:gint);
            draw_string : Procedure (style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; x:gint; y:gint;  cdecl;
                          thestring:pgchar);
         end;


    Function      gtk_style_new : PGtkStyle; cdecl;
    Function      gtk_style_copy (style:pGtkStyle):PGtkStyle; cdecl;
    Function      gtk_style_attach (style:pGtkStyle; window:pGdkWindow):PGtkStyle; cdecl;

    Procedure gtk_style_detach(style:pGtkStyle); cdecl;


    Function      gtk_style_ref (style:pGtkStyle):PGtkStyle; cdecl;

    Procedure gtk_style_unref(style:pGtkStyle); cdecl;

    Procedure gtk_style_set_background(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType); cdecl;

    Procedure gtk_draw_hline(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; x1:gint; x2:gint;  y:gint); cdecl;

    Procedure gtk_draw_vline(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; y1:gint; y2:gint;  x:gint); cdecl;

    Procedure gtk_draw_shadow(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint; y:gint; width:gint; height:gint);cdecl;

    Procedure gtk_draw_polygon(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; points:pGdkPoint; npoints:gint; fill:gint); cdecl;

    Procedure gtk_draw_arrow(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; arrow_type:GtkArrowType; fill:gint; x:gint; y:gint; width:gint; height:gint); cdecl;

    Procedure gtk_draw_diamond(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint; y:gint; width:gint; height:gint); cdecl;

    Procedure gtk_draw_oval(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint; y:gint; width:gint; height:gint); cdecl;

(* Const before type ignored *)
    Procedure gtk_draw_string(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; x:gint; y:gint; thestring:pgchar);cdecl;

    Function  GTK_STYLE_ATTACHED(style : pgtkstyle) : boolean;


  implementation

    function GTK_STYLE_ATTACHED(style : pgtkstyle) : boolean;
      begin
         GTK_STYLE_ATTACHED:=(style^.attach_count) > 0;
      end;

    procedure gtk_style_detach(style:pGtkStyle);CDECL; external;

    procedure gtk_style_unref(style:pGtkStyle);CDECL; external;

    procedure gtk_style_set_background(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType);CDECL; external;

    procedure gtk_draw_hline(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; x1:gint; x2:gint; 
                y:gint);CDECL; external;

    procedure gtk_draw_vline(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; y1:gint; y2:gint; 
                x:gint);CDECL; external;

    procedure gtk_draw_shadow(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint; 
                y:gint; width:gint; height:gint);CDECL; external;

    procedure gtk_draw_polygon(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; points:pGdkPoint; 
                npoints:gint; fill:gint);CDECL; external;

    procedure gtk_draw_arrow(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; arrow_type:GtkArrowType; 
                fill:gint; x:gint; y:gint; width:gint; height:gint);CDECL; external;

    procedure gtk_draw_diamond(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint; 
                y:gint; width:gint; height:gint);CDECL; external;

    procedure gtk_draw_oval(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; shadow_type:GtkShadowType; x:gint; 
                y:gint; width:gint; height:gint);CDECL; external;

    procedure gtk_draw_string(style:pGtkStyle; window:pGdkWindow; state_type:GtkStateType; x:gint; y:gint; 
                thestring:pgchar);CDECL; external;

    function     gtk_style_new : PGtkStyle;cdecl;external;
    function     gtk_style_copy (style:pGtkStyle):PGtkStyle;cdecl;external;
    function     gtk_style_attach (style:pGtkStyle; window:pGdkWindow):PGtkStyle;cdecl;external;
    function     gtk_style_ref (style:pGtkStyle):PGtkStyle;cdecl;external;


end.
