unit gtktext;

  interface

uses gdk,gdktypes,glib,gtkadjustment,gtkeditable,gtkwidget;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_TEXT(obj)          GTK_CHECK_CAST (obj, gtk_text_get_type (), GtkText)
  #define GTK_TEXT_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_text_get_type (), GtkTextClass)
  #define GTK_IS_TEXT(obj)       GTK_CHECK_TYPE (obj, gtk_text_get_type ())
  }

  type
     PGtkPropertyMark = ^TGtkPropertyMark;
{$PACKRECORDS 4}
     TGtkPropertyMark = record
          theproperty : PGList;
          theoffset : guint;
          theindex : guint;
       end;

     PGtkText = ^TGtkText;
{$PACKRECORDS 4}
     TGtkText = record
          editable : TGtkEditable;
          text_area : PGdkWindow;
          hadj : PGtkAdjustment;
          vadj : PGtkAdjustment;
          gc : PGdkGC;
          line_wrap_bitmap : PGdkPixmap;
          line_arrow_bitmap : PGdkPixmap;
          thetext : pguchar;
          text_len : guint;
          gap_position : guint;
          gap_size : guint;
          text_end : guint;
          line_start_cache : PGList;
          first_line_start_index : guint;
          first_cut_pixels : guint;
          first_onscreen_hor_pixel : guint;
          first_onscreen_ver_pixel : guint;
          flag0 : word;
          text_properties : PGList;
          text_properties_end : PGList;
          point : TGtkPropertyMark;
          scratch_buffer : Pguchar;
          scratch_buffer_len : guint;
          last_ver_value : gint;
          cursor_pos_x : gint;
          cursor_pos_y : gint;
          cursor_mark : TGtkPropertyMark;
          cursor_char : gchar;
          cursor_char_offset : gchar;
          cursor_virtual_x : gint;
          cursor_drawn_level : gint;
          current_line : PGList;
          tab_stops : PGList;
          default_tab_width : gint;
          timer : gint;
          button : guint;
       end;

  const
     bm_has_cursor = 1;
     bp_has_cursor = 0;
     bm_line_wrap = 2;
     bp_line_wrap = 1;
     bm_freeze = 4;
     bp_freeze = 2;
     bm_word_wrap = 8;
     bp_word_wrap = 3;
  Function  has_cursor(var a : TGtkText) : guint;
  Procedure set_has_cursor(var a : TGtkText; __has_cursor : guint);
  Function  line_wrap(var a : TGtkText) : guint;
  Procedure set_line_wrap(var a : TGtkText; __line_wrap : guint);
  Function  freeze(var a : TGtkText) : guint;
  Procedure set_freeze(var a : TGtkText; __freeze : guint);
  Function  word_wrap(var a : TGtkText) : guint;
  Procedure set_word_wrap(var a : TGtkText; __word_wrap : guint);

  type
     PGtkTextClass = ^TGtkTextClass;
{$PACKRECORDS 4}
     TGtkTextClass = record
          parent_class : TGtkEditableClass;
       end;


  Function  gtk_text_get_type:guint; cdecl;

  Function  gtk_text_new(hadj:pGtkAdjustment; vadj:pGtkAdjustment):PGtkWidget; cdecl;

  Procedure gtk_text_set_editable(thetext:pGtkText; editable:gint); cdecl;

  Procedure gtk_text_set_word_wrap(thetext:pGtkText; word_wrap:gint); cdecl;

  Procedure gtk_text_set_adjustments(thetext:pGtkText; hadj:pGtkAdjustment; vadj:pGtkAdjustment); cdecl;

  Procedure gtk_text_set_point(thetext:pGtkText; index:guint); cdecl;

  Function  gtk_text_get_point(thetext:pGtkText):guint; cdecl;

  Function  gtk_text_get_length(thetext:pGtkText):guint; cdecl;

  Procedure gtk_text_freeze(thetext:pGtkText); cdecl;

  Procedure gtk_text_thaw(thetext:pGtkText); cdecl;

  Procedure gtk_text_insert(thetext:pGtkText; font:pGdkFont; fore:pGdkColor; back:pGdkColor; chars:pchar; 
              length:gint); cdecl;

  Function  gtk_text_backward_delete(thetext:pGtkText; nchars:guint):gint; cdecl;

  Function  gtk_text_forward_delete(thetext:pGtkText; nchars:guint):gint; cdecl;

  implementation


  function has_cursor(var a : TGtkText) : guint;
    begin
       has_cursor:=(a.flag0 and bm_has_cursor) shr bp_has_cursor;
    end;

  procedure set_has_cursor(var a : TGtkText; __has_cursor : guint);
    begin
       a.flag0:=a.flag0 or ((__has_cursor shl bp_has_cursor) and bm_has_cursor);
    end;

  function line_wrap(var a : TGtkText) : guint;
    begin
       line_wrap:=(a.flag0 and bm_line_wrap) shr bp_line_wrap;
    end;

  procedure set_line_wrap(var a : TGtkText; __line_wrap : guint);
    begin
       a.flag0:=a.flag0 or ((__line_wrap shl bp_line_wrap) and bm_line_wrap);
    end;

  function freeze(var a : TGtkText) : guint;
    begin
       freeze:=(a.flag0 and bm_freeze) shr bp_freeze;
    end;

  procedure set_freeze(var a : TGtkText; __freeze : guint);
    begin
       a.flag0:=a.flag0 or ((__freeze shl bp_freeze) and bm_freeze);
    end;

  function word_wrap(var a : TGtkText) : guint;
    begin
       word_wrap:=(a.flag0 and bm_word_wrap) shr bp_word_wrap;
    end;

  procedure set_word_wrap(var a : TGtkText; __word_wrap : guint);
    begin
       a.flag0:=a.flag0 or ((__word_wrap shl bp_word_wrap) and bm_word_wrap);
    end;

  function gtk_text_get_type:guint;CDECL; external;

  function gtk_text_new(hadj:pGtkAdjustment; vadj:pGtkAdjustment):PGtkWidget;CDECL; external;

  procedure gtk_text_set_editable(thetext:pGtkText; editable:gint);CDECL; external;

  procedure gtk_text_set_word_wrap(thetext:pGtkText; word_wrap:gint);CDECL; external;

  procedure gtk_text_set_adjustments(thetext:pGtkText; hadj:pGtkAdjustment; vadj:pGtkAdjustment);CDECL; external;

  procedure gtk_text_set_point(thetext:pGtkText; index:guint);CDECL; external;

  function gtk_text_get_point(thetext:pGtkText):guint;CDECL; external;

  function gtk_text_get_length(thetext:pGtkText):guint;CDECL; external;

  procedure gtk_text_freeze(thetext:pGtkText);CDECL; external;

  procedure gtk_text_thaw(thetext:pGtkText);CDECL; external;

  procedure gtk_text_insert(thetext:pGtkText; font:pGdkFont; fore:pGdkColor; back:pGdkColor; chars:pchar; 
              length:gint);CDECL; external;

  function gtk_text_backward_delete(thetext:pGtkText; nchars:guint):gint;CDECL; external;

  function gtk_text_forward_delete(thetext:pGtkText; nchars:guint):gint;CDECL; external;


end.
