unit gtktogglebutton;

  interface

uses gdk,glib,gtkbutton,gtkwidget;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_TOGGLE_BUTTON(obj)          GTK_CHECK_CAST (obj, gtk_toggle_button_get_type (), GtkToggleButton)
    #define GTK_TOGGLE_BUTTON_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_toggle_button_get_type (), GtkToggleButtonClass)
    #define GTK_IS_TOGGLE_BUTTON(obj)       GTK_CHECK_TYPE (obj, gtk_toggle_button_get_type ())
    }

    type

       PGtkToggleButton = ^TGtkToggleButton;
{$PACKRECORDS 4}
       TGtkToggleButton = record
            button : TGtkButton;
            flag0 : word;
         end;

    const
       bm_active = 1;
       bp_active = 0;
       bm_draw_indicator = 2;
       bp_draw_indicator = 1;
    Function  active(var a : TGtkToggleButton) : guint; 
    Procedure set_active(var a : TGtkToggleButton; __active : guint);
    Function  draw_indicator(var a : TGtkToggleButton) : guint;
    Procedure set_draw_indicator(var a : TGtkToggleButton; __draw_indicator : guint); 

    type
       PGtkToggleButtonClass = ^TGtkToggleButtonClass;
{$PACKRECORDS 4}
       TGtkToggleButtonClass = record
            parent_class : TGtkButtonClass;
            toggled : Procedure (toggle_button:pGtkToggleButton); cdecl;
         end;


    Function  gtk_toggle_button_get_type:guint; cdecl;

    Function  gtk_toggle_button_new : PGtkWidget; cdecl;
    Function  gtk_toggle_button_new_with_label (thelabel:pgchar):PGtkWidget; cdecl;


    Procedure gtk_toggle_button_set_mode(toggle_button:pGtkToggleButton; draw_indicator:gint); cdecl;

    Procedure gtk_toggle_button_set_state(toggle_button:pGtkToggleButton; state:gint); cdecl;

    Procedure gtk_toggle_button_toggled(toggle_button:pGtkToggleButton); cdecl;


  implementation


    function active(var a : TGtkToggleButton) : guint;
      begin
         active:=(a.flag0 and bm_active) shr bp_active;
      end;

    procedure set_active(var a : TGtkToggleButton; __active : guint);
      begin
         a.flag0:=a.flag0 or ((__active shl bp_active) and bm_active);
      end;

    function draw_indicator(var a : TGtkToggleButton) : guint;
      begin
         draw_indicator:=(a.flag0 and bm_draw_indicator) shr bp_draw_indicator;
      end;

    procedure set_draw_indicator(var a : TGtkToggleButton; __draw_indicator : guint);
      begin
         a.flag0:=a.flag0 or ((__draw_indicator shl bp_draw_indicator) and bm_draw_indicator);
      end;



    function gtk_toggle_button_get_type:guint;CDECL; external;

    function gtk_toggle_button_new : PGtkWidget;cdecl;external;
    function gtk_toggle_button_new_with_label (thelabel:pgchar):PGtkWidget;cdecl;external;

    procedure gtk_toggle_button_set_mode(toggle_button:pGtkToggleButton; draw_indicator:gint);CDECL; external;

    procedure gtk_toggle_button_set_state(toggle_button:pGtkToggleButton; state:gint);CDECL; external;

    procedure gtk_toggle_button_toggled(toggle_button:pGtkToggleButton);CDECL; external;


end.
