unit gtktoolbar;

  interface

uses gdk,gdktypes,glib,gtkcontainer,gtkenums,gtkpixmap,gtksignal,gtkwidget,
 gtktooltips,gtkobjects;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_TOOLBAR(obj)	 GTK_CHECK_CAST (obj, gtk_toolbar_get_type (), GtkToolbar)
  #define GTK_TOOLBAR_CLASS(klass) GTK_CHECK_CLASS_CAST (klass, gtk_toolbar_get_type (), GtkToolbarClass)
  #define GTK_IS_TOOLBAR(obj)      GTK_CHECK_TYPE (obj, gtk_toolbar_get_type ())
  }

  type
     GtkToolbarChildType =  Longint;
       Const
       GTK_TOOLBAR_CHILD_SPACE = 0;
       GTK_TOOLBAR_CHILD_BUTTON = 1;
       GTK_TOOLBAR_CHILD_TOGGLEBUTTON = 2;
       GTK_TOOLBAR_CHILD_RADIOBUTTON = 3;
       GTK_TOOLBAR_CHILD_WIDGET = 4;


  type
     PGtkToolbarChild = ^TGtkToolbarChild;
{$PACKRECORDS 4}
     TGtkToolbarChild = record
          thetype : GtkToolbarChildType;
          widget : PGtkWidget;
          icon : PGtkWidget;
          thelabel : PGtkWidget;
       end;

     PGtkToolbar = ^TGtkToolbar;
{$PACKRECORDS 4}
     TGtkToolbar = record
          container : TGtkContainer;
          num_children : gint;
          children : PGList;
          orientation : GtkOrientation;
          style : GtkToolbarStyle;
          space_size : gint;
          tooltips : PGtkTooltips;
          button_maxw : gint;
          button_maxh : gint;
       end;

     PGtkToolbarClass = ^TGtkToolbarClass;
{$PACKRECORDS 4}
     TGtkToolbarClass = record
          parent_class : TGtkContainerClass;
          orientation_changed : Procedure (toolbar:pGtkToolbar; orientation:GtkOrientation); cdecl;
          style_changed : Procedure (toolbar:pGtkToolbar; style:GtkToolbarStyle); cdecl;
       end;


  Function  gtk_toolbar_get_type:guint; cdecl;

  Function  gtk_toolbar_new(orientation:GtkOrientation; style:GtkToolbarStyle):PGtkWidget; cdecl;

  Function  gtk_toolbar_append_item(toolbar:pGtkToolbar; thetext:pchar; tooltip_text:pchar; tooltip_private_text:pchar; icon:pGtkWidget; 
             callback:GtkSignalFunc; user_data:gpointer):PGtkWidget; cdecl;

  Function  gtk_toolbar_prepend_item(toolbar:pGtkToolbar; thetext:pchar; tooltip_text:pchar; tooltip_private_text:pchar; icon:pGtkWidget; 
             callback:GtkSignalFunc; user_data:gpointer):PGtkWidget; cdecl;

  Function  gtk_toolbar_insert_item(toolbar:pGtkToolbar; thetext:pchar; tooltip_text:pchar; tooltip_private_text:pchar; icon:pGtkWidget; 
             callback:GtkSignalFunc; user_data:gpointer; position:gint):PGtkWidget; cdecl;

  Procedure gtk_toolbar_append_space(toolbar:pGtkToolbar); cdecl;

  Procedure gtk_toolbar_prepend_space(toolbar:pGtkToolbar); cdecl;

  Procedure gtk_toolbar_insert_space(toolbar:pGtkToolbar; position:gint); cdecl;

  Function  gtk_toolbar_append_element(toolbar:pGtkToolbar; thetype:GtkToolbarChildType; widget:pGtkWidget; thetext:pchar; tooltip_text:pchar; 
             tooltip_private_text:pchar; icon:pGtkWidget; callback:GtkSignalFunc; user_data:gpointer):PGtkWidget; cdecl;

  Function  gtk_toolbar_prepend_element(toolbar:pGtkToolbar; thetype:GtkToolbarChildType; widget:pGtkWidget; thetext:pchar; tooltip_text:pchar; 
             tooltip_private_text:pchar; icon:pGtkWidget; callback:GtkSignalFunc; user_data:gpointer):PGtkWidget; cdecl;

  Function  gtk_toolbar_insert_element(toolbar:pGtkToolbar; thetype:GtkToolbarChildType; widget:pGtkWidget; thetext:pchar; tooltip_text:pchar;
             tooltip_private_text:pchar; icon:pGtkWidget; callback:GtkSignalFunc; user_data:gpointer; position:gint):PGtkWidget; cdecl;

  Procedure gtk_toolbar_append_widget(toolbar:pGtkToolbar; widget:pGtkWidget; tooltip_text:pchar; tooltip_private_text:pchar); cdecl;

  Procedure gtk_toolbar_prepend_widget(toolbar:pGtkToolbar; widget:pGtkWidget; tooltip_text:pchar; tooltip_private_text:pchar); cdecl;

  Procedure gtk_toolbar_insert_widget(toolbar:pGtkToolbar; widget:pGtkWidget; tooltip_text:pchar; tooltip_private_text:pchar; position:gint); cdecl;

  Procedure gtk_toolbar_set_orientation(toolbar:pGtkToolbar; orientation:GtkOrientation); cdecl;

  Procedure gtk_toolbar_set_style(toolbar:pGtkToolbar; style:GtkToolbarStyle); cdecl;

  Procedure gtk_toolbar_set_space_size(toolbar:pGtkToolbar; space_size:gint); cdecl;

  Procedure gtk_toolbar_set_tooltips(toolbar:pGtkToolbar; enable:gint); cdecl;


  implementation

  function gtk_toolbar_get_type:guint;CDECL; external;

  function gtk_toolbar_new(orientation:GtkOrientation; style:GtkToolbarStyle):PGtkWidget;CDECL; external;

  function gtk_toolbar_append_item(toolbar:pGtkToolbar; thetext:pchar; tooltip_text:pchar; tooltip_private_text:pchar; icon:pGtkWidget; 
             callback:GtkSignalFunc; user_data:gpointer):PGtkWidget;CDECL; external;

  function gtk_toolbar_prepend_item(toolbar:pGtkToolbar; thetext:pchar; tooltip_text:pchar; tooltip_private_text:pchar; icon:pGtkWidget; 
             callback:GtkSignalFunc; user_data:gpointer):PGtkWidget;CDECL; external;

  function gtk_toolbar_insert_item(toolbar:pGtkToolbar; thetext:pchar; tooltip_text:pchar; tooltip_private_text:pchar; icon:pGtkWidget; 
             callback:GtkSignalFunc; user_data:gpointer; position:gint):PGtkWidget;CDECL; external;

  procedure gtk_toolbar_append_space(toolbar:pGtkToolbar);CDECL; external;

  procedure gtk_toolbar_prepend_space(toolbar:pGtkToolbar);CDECL; external;

  procedure gtk_toolbar_insert_space(toolbar:pGtkToolbar; position:gint);CDECL; external;

  function gtk_toolbar_append_element(toolbar:pGtkToolbar; thetype:GtkToolbarChildType; widget:pGtkWidget; thetext:pchar; tooltip_text:pchar; 
             tooltip_private_text:pchar; icon:pGtkWidget; callback:GtkSignalFunc; user_data:gpointer):PGtkWidget;CDECL; external;

  function gtk_toolbar_prepend_element(toolbar:pGtkToolbar; thetype:GtkToolbarChildType; widget:pGtkWidget; thetext:pchar; tooltip_text:pchar; 
             tooltip_private_text:pchar; icon:pGtkWidget; callback:GtkSignalFunc; user_data:gpointer):PGtkWidget;CDECL; external;

  function gtk_toolbar_insert_element(toolbar:pGtkToolbar; thetype:GtkToolbarChildType; widget:pGtkWidget; thetext:pchar; tooltip_text:pchar; 
             tooltip_private_text:pchar; icon:pGtkWidget; callback:GtkSignalFunc; user_data:gpointer; position:gint):PGtkWidget;CDECL; external;

  procedure gtk_toolbar_append_widget(toolbar:pGtkToolbar; widget:pGtkWidget; tooltip_text:pchar; tooltip_private_text:pchar);CDECL; external;

  procedure gtk_toolbar_prepend_widget(toolbar:pGtkToolbar; widget:pGtkWidget; tooltip_text:pchar; tooltip_private_text:pchar);CDECL; external;

  procedure gtk_toolbar_insert_widget(toolbar:pGtkToolbar; widget:pGtkWidget; tooltip_text:pchar; tooltip_private_text:pchar; position:gint);CDECL; external;

  procedure gtk_toolbar_set_orientation(toolbar:pGtkToolbar; orientation:GtkOrientation);CDECL; external;

  procedure gtk_toolbar_set_style(toolbar:pGtkToolbar; style:GtkToolbarStyle);CDECL; external;

  procedure gtk_toolbar_set_space_size(toolbar:pGtkToolbar; space_size:gint);CDECL; external;

  procedure gtk_toolbar_set_tooltips(toolbar:pGtkToolbar; enable:gint);CDECL; external;


end.
