unit gtktooltips;

  interface

uses gdk,gdktypes,glib,gtkdata,gtkwidget,gtkobjects;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_TOOLTIPS(obj)	   GTK_CHECK_CAST (obj, gtk_tooltips_get_type (), GtkTooltips)
  #define GTK_TOOLTIPS_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_tooltips_get_type (), GtkTooltipsClass)
  #define GTK_IS_TOOLTIPS(obj)	   GTK_CHECK_TYPE (obj, gtk_tooltips_get_type ())
  }

  type
     PGtkTooltipsData = ^TGtkTooltipsData;
     PGtkTooltips = ^TGtkTooltips;
{$PACKRECORDS 4}
     TGtkTooltipsData = record
          tooltips : PGtkTooltips;
          widget : PGtkWidget;
          tip_text : pgchar;
          tip_private : pgchar;
          font : PGdkFont;
          width : gint;
          row : PGList;
       end;

{$PACKRECORDS 4}
     TGtkTooltips = record
          data : TGtkData;
          tip_window : PGtkWidget;
          active_tips_data : PGtkTooltipsData;
          tips_data_list : PGList;
          gc : PGdkGC;
          foreground : PGdkColor;
          background : PGdkColor;
          flag0 : longint;
          timer_tag : gint;
       end;

  const
     bm_delay = 1073741823;
     bp_delay = 0;
     bm_enabled = 1073741824;
     bp_enabled = 30;
  Function  delay(var a : TGtkTooltips) : guint;
  Procedure set_delay(var a : TGtkTooltips; __delay : guint);
  Function  enabled(var a : TGtkTooltips) : guint; 
  Procedure set_enabled(var a : TGtkTooltips; __enabled : guint);

  type
     PGtkTooltipsClass = ^TGtkTooltipsClass;
{$PACKRECORDS 4}
     TGtkTooltipsClass = record
          parent_class : TGtkDataClass;
       end;


  Function  gtk_tooltips_get_type:GtkType; cdecl;

  Function  gtk_tooltips_new:PGtkTooltips; cdecl;

  Procedure gtk_tooltips_enable(tooltips:pGtkTooltips); cdecl;

  Procedure gtk_tooltips_disable(tooltips:pGtkTooltips); cdecl;

  Procedure gtk_tooltips_set_delay(tooltips:pGtkTooltips; delay:guint); cdecl;

(* Const before type ignored *)
(* Const before type ignored *)
  Procedure gtk_tooltips_set_tip(tooltips:pGtkTooltips; widget:pGtkWidget; tip_text:pgchar; tip_private:pgchar); cdecl;

  Procedure gtk_tooltips_set_colors(tooltips:pGtkTooltips; background:pGdkColor; foreground:pGdkColor); cdecl;

  Function  gtk_tooltips_data_get(widget:pGtkWidget):PGtkTooltipsData; cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function delay(var a : TGtkTooltips) : guint;
    begin
       delay:=(a.flag0 and bm_delay) shr bp_delay;
    end;

  procedure set_delay(var a : TGtkTooltips; __delay : guint);
    begin
       a.flag0:=a.flag0 or ((__delay shl bp_delay) and bm_delay);
    end;

  function enabled(var a : TGtkTooltips) : guint;
    begin
       enabled:=(a.flag0 and bm_enabled) shr bp_enabled;
    end;

  procedure set_enabled(var a : TGtkTooltips; __enabled : guint);
    begin
       a.flag0:=a.flag0 or ((__enabled shl bp_enabled) and bm_enabled);
    end;

  function gtk_tooltips_get_type:GtkType;CDECL; external;

  function gtk_tooltips_new:PGtkTooltips;CDECL; external;

  procedure gtk_tooltips_enable(tooltips:pGtkTooltips);CDECL; external;

  procedure gtk_tooltips_disable(tooltips:pGtkTooltips);CDECL; external;

  procedure gtk_tooltips_set_delay(tooltips:pGtkTooltips; delay:guint);CDECL; external;

  procedure gtk_tooltips_set_tip(tooltips:pGtkTooltips; widget:pGtkWidget; tip_text:pgchar; tip_private:pgchar);CDECL; external;

  procedure gtk_tooltips_set_colors(tooltips:pGtkTooltips; background:pGdkColor; foreground:pGdkColor);CDECL; external;

  function gtk_tooltips_data_get(widget:pGtkWidget):PGtkTooltipsData;CDECL; external;


end.
