unit gtktree;

  interface

uses gdk,gdktypes,glib,gtkwidget,gtkcontainer,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_TREE(obj)          GTK_CHECK_CAST (obj, gtk_tree_get_type (), GtkTree)
  #define GTK_TREE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_tree_get_type (), GtkTreeClass)
  #define GTK_IS_TREE(obj)       GTK_CHECK_TYPE (obj, gtk_tree_get_type ())
  
  #define GTK_IS_ROOT_TREE(obj)   ((GtkObject ) GTK_TREE(obj)->root_tree == (GtkObject )obj)
  #define GTK_TREE_ROOT_TREE(obj) (GTK_TREE(obj)->root_tree ? GTK_TREE(obj)->root_tree : GTK_TREE(obj))
  #define GTK_TREE_SELECTION(obj) (GTK_TREE_ROOT_TREE(obj)->selection)
  }

  type

     GtkTreeViewMode =  Longint;
       Const
       GTK_TREE_VIEW_LINE = 0;
       GTK_TREE_VIEW_ITEM = 1;

  type
     PGtkTree = ^TGtkTree;
{$PACKRECORDS 4}
     TGtkTree = record
          container : TGtkContainer;
          children : PGList;
          root_tree : PGtkTree;
          tree_owner : PGtkWidget;
          selection : PGList;
          level : guint;
          indent_value : guint;
          current_indent : guint;
          flag0 : word;
       end;

  const
     bm_selection_mode = 3;
     bp_selection_mode = 0;
     bm_view_mode = 4;
     bp_view_mode = 2;
     bm_view_line = 8;
     bp_view_line = 3;
  Function  selection_mode(var a : TGtkTree) : guint;
  Procedure set_selection_mode(var a : TGtkTree; __selection_mode : guint);
  Function  view_mode(var a : TGtkTree) : guint;
  Procedure set_view_mode(var a : TGtkTree; __view_mode : guint);
  Function  view_line(var a : TGtkTree) : guint;
  Procedure set_view_line(var a : TGtkTree; __view_line : guint);

  type
     PGtkTreeClass = ^TGtkTreeClass;
{$PACKRECORDS 4}
     TGtkTreeClass = record
          parent_class : TGtkContainerClass;
          selection_changed : Procedure (tree:pGtkTree); cdecl;
          select_child : Procedure (tree:pGtkTree; child:pGtkWidget); cdecl;
          unselect_child : Procedure (tree:pGtkTree; child:pGtkWidget); cdecl;
       end;


  Function  gtk_tree_get_type:guint; cdecl;

  Function  gtk_tree_new:PGtkWidget; cdecl;

  Procedure gtk_tree_append(tree:pGtkTree; tree_item:pGtkWidget); cdecl;

  Procedure gtk_tree_prepend(tree:pGtkTree; tree_item:pGtkWidget); cdecl;

  Procedure gtk_tree_insert(tree:pGtkTree; tree_item:pGtkWidget; position:gint); cdecl;

  Procedure gtk_tree_remove_items(tree:pGtkTree; items:pGList); cdecl;

  Procedure gtk_tree_clear_items(tree:pGtkTree; start:gint; theend:gint); cdecl;

  Procedure gtk_tree_select_item(tree:pGtkTree; item:gint); cdecl;

  Procedure gtk_tree_unselect_item(tree:pGtkTree; item:gint); cdecl;

  Procedure gtk_tree_select_child(tree:pGtkTree; tree_item:pGtkWidget); cdecl;

  Procedure gtk_tree_unselect_child(tree:pGtkTree; tree_item:pGtkWidget); cdecl;

  Function  gtk_tree_child_position(tree:pGtkTree; child:pGtkWidget):gint; cdecl;

  Procedure gtk_tree_set_selection_mode(tree:pGtkTree; mode:GtkSelectionMode); cdecl;

  Procedure gtk_tree_set_view_mode(tree:pGtkTree; mode:GtkTreeViewMode); cdecl;

  Procedure gtk_tree_set_view_lines(tree:pGtkTree; flag:guint); cdecl;

  Procedure gtk_tree_remove_item(tree:pGtkTree; child:pGtkWidget); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function selection_mode(var a : TGtkTree) : guint;
    begin
       selection_mode:=(a.flag0 and bm_selection_mode) shr bp_selection_mode;
    end;

  procedure set_selection_mode(var a : TGtkTree; __selection_mode : guint);
    begin
       a.flag0:=a.flag0 or ((__selection_mode shl bp_selection_mode) and bm_selection_mode);
    end;

  function view_mode(var a : TGtkTree) : guint;
    begin
       view_mode:=(a.flag0 and bm_view_mode) shr bp_view_mode;
    end;

  procedure set_view_mode(var a : TGtkTree; __view_mode : guint);
    begin
       a.flag0:=a.flag0 or ((__view_mode shl bp_view_mode) and bm_view_mode);
    end;

  function view_line(var a : TGtkTree) : guint;
    begin
       view_line:=(a.flag0 and bm_view_line) shr bp_view_line;
    end;

  procedure set_view_line(var a : TGtkTree; __view_line : guint);
    begin
       a.flag0:=a.flag0 or ((__view_line shl bp_view_line) and bm_view_line);
    end;

  function gtk_tree_get_type:guint;CDECL; external;

  function gtk_tree_new:PGtkWidget;CDECL; external;

  procedure gtk_tree_append(tree:pGtkTree; tree_item:pGtkWidget);CDECL; external;

  procedure gtk_tree_prepend(tree:pGtkTree; tree_item:pGtkWidget);CDECL; external;

  procedure gtk_tree_insert(tree:pGtkTree; tree_item:pGtkWidget; position:gint);CDECL; external;

  procedure gtk_tree_remove_items(tree:pGtkTree; items:pGList);CDECL; external;

  procedure gtk_tree_clear_items(tree:pGtkTree; start:gint; theend:gint);CDECL; external;

  procedure gtk_tree_select_item(tree:pGtkTree; item:gint);CDECL; external;

  procedure gtk_tree_unselect_item(tree:pGtkTree; item:gint);CDECL; external;

  procedure gtk_tree_select_child(tree:pGtkTree; tree_item:pGtkWidget);CDECL; external;

  procedure gtk_tree_unselect_child(tree:pGtkTree; tree_item:pGtkWidget);CDECL; external;

  function gtk_tree_child_position(tree:pGtkTree; child:pGtkWidget):gint;CDECL; external;

  procedure gtk_tree_set_selection_mode(tree:pGtkTree; mode:GtkSelectionMode);CDECL; external;

  procedure gtk_tree_set_view_mode(tree:pGtkTree; mode:GtkTreeViewMode);CDECL; external;

  procedure gtk_tree_set_view_lines(tree:pGtkTree; flag:guint);CDECL; external;

  procedure gtk_tree_remove_item(tree:pGtkTree; child:pGtkWidget);CDECL; external;


end.
