unit gtktreeitem;

  interface

uses gdk,gdktypes,glib,gtkwidget,gtkitem;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_TREE_ITEM(obj)          GTK_CHECK_CAST (obj, gtk_tree_item_get_type (), GtkTreeItem)
  #define GTK_TREE_ITEM_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_tree_item_get_type (), GtkTreeItemClass)
  #define GTK_IS_TREE_ITEM(obj)       GTK_CHECK_TYPE (obj, gtk_tree_item_get_type ())
  }



  type
     PGtkTreeItem = ^TGtkTreeItem;
{$PACKRECORDS 4}
     TGtkTreeItem = record
          item : TGtkItem;
          subtree : PGtkWidget;
          pixmaps_box : PGtkWidget;
          plus_pix_widget : PGtkWidget;
          minus_pix_widget : PGtkWidget;
          pixmaps : PGList;
          flag0 : word;
       end;

  Function  GTK_TREE_ITEM_SUBTREE(obj : pgtktreeitem) : PGTkWidget;

  const
     bm_expanded = 1;
     bp_expanded = 0;
  Function  expanded(var a : TGtkTreeItem) : guint;
  Procedure set_expanded(var a : TGtkTreeItem; __expanded : guint);

  type
     PGtkTreeItemClass = ^TGtkTreeItemClass;
{$PACKRECORDS 4}
     TGtkTreeItemClass = record
          parent_class : TGtkItemClass;
          expand : Procedure (tree_item:pGtkTreeItem); cdecl;
          collapse : Procedure (tree_item:pGtkTreeItem); cdecl;
       end;


  Function  gtk_tree_item_get_type:guint; cdecl;

  Function  gtk_tree_item_new:PGtkWidget; cdecl;

  Function  gtk_tree_item_new_with_label(thelabel:pgchar):PGtkWidget; cdecl;

  Procedure gtk_tree_item_set_subtree(tree_item:pGtkTreeItem; subtree:pGtkWidget); cdecl;

  Procedure gtk_tree_item_remove_subtree(tree_item:pGtkTreeItem); cdecl;

  Procedure gtk_tree_item_select(tree_item:pGtkTreeItem); cdecl;

  Procedure gtk_tree_item_deselect(tree_item:pGtkTreeItem); cdecl;

  Procedure gtk_tree_item_expand(tree_item:pGtkTreeItem); cdecl;

  Procedure gtk_tree_item_collapse(tree_item:pGtkTreeItem); cdecl;


  implementation


  function GTK_TREE_ITEM_SUBTREE(obj : pgtktreeitem) : pgtkwidget;
    begin
       GTK_TREE_ITEM_SUBTREE:=obj^.subtree;
    end;

  function expanded(var a : TGtkTreeItem) : guint;
    begin
       expanded:=(a.flag0 and bm_expanded) shr bp_expanded;
    end;

  procedure set_expanded(var a : TGtkTreeItem; __expanded : guint);
    begin
       a.flag0:=a.flag0 or ((__expanded shl bp_expanded) and bm_expanded);
    end;

  function gtk_tree_item_get_type:guint;CDECL; external;

  function gtk_tree_item_new:PGtkWidget;CDECL; external;

  function gtk_tree_item_new_with_label(thelabel:pgchar):PGtkWidget;CDECL; external;

  procedure gtk_tree_item_set_subtree(tree_item:pGtkTreeItem; subtree:pGtkWidget);CDECL; external;

  procedure gtk_tree_item_remove_subtree(tree_item:pGtkTreeItem);CDECL; external;

  procedure gtk_tree_item_select(tree_item:pGtkTreeItem);CDECL; external;

  procedure gtk_tree_item_deselect(tree_item:pGtkTreeItem);CDECL; external;

  procedure gtk_tree_item_expand(tree_item:pGtkTreeItem);CDECL; external;

  procedure gtk_tree_item_collapse(tree_item:pGtkTreeItem);CDECL; external;


end.
