unit gtkviewport;

  interface

uses gdk,gdktypes,glib,gtkbin,gtkwidget,gtkadjustment,gtkenums;

  Type
     PLongint  = ^Longint;
     PByte     = ^Byte;
     PWord     = ^Word;
     PInteger  = ^Integer;
     PCardinal = ^Cardinal;
     PReal     = ^Real;
     PDouble   = ^Double;

  {
  #define GTK_VIEWPORT(obj)          GTK_CHECK_CAST (obj, gtk_viewport_get_type (), GtkViewport)
  #define GTK_VIEWPORT_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_viewport_get_type (), GtkViewportClass)
  #define GTK_IS_VIEWPORT(obj)       GTK_CHECK_TYPE (obj, gtk_viewport_get_type ())
  }

  type
     PGtkViewport = ^TGtkViewport;
{$PACKRECORDS 4}
     TGtkViewport = record
          bin : TGtkBin;
          shadow_type : gint;
          view_window : PGdkWindow;
          bin_window : PGdkWindow;
          hadjustment : PGtkAdjustment;
          vadjustment : PGtkAdjustment;
       end;

     PGtkViewportClass = ^TGtkViewportClass;
{$PACKRECORDS 4}
     TGtkViewportClass = record
          parent_class : TGtkBinClass;
       end;


  Function  gtk_viewport_get_type:guint; cdecl;

  Function  gtk_viewport_new(hadjustment:pGtkAdjustment; vadjustment:pGtkAdjustment):PGtkWidget; cdecl;

  Function  gtk_viewport_get_hadjustment(viewport:pGtkViewport):PGtkAdjustment; cdecl;

  Function  gtk_viewport_get_vadjustment(viewport:pGtkViewport):PGtkAdjustment; cdecl;

  Procedure gtk_viewport_set_hadjustment(viewport:pGtkViewport; adjustment:pGtkAdjustment); cdecl;

  Procedure gtk_viewport_set_vadjustment(viewport:pGtkViewport; adjustment:pGtkAdjustment); cdecl;

  Procedure gtk_viewport_set_shadow_type(viewport:pGtkViewport; thetype:GtkShadowType); cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

  function gtk_viewport_get_type:guint;CDECL; external;

  function gtk_viewport_new(hadjustment:pGtkAdjustment; vadjustment:pGtkAdjustment):PGtkWidget;CDECL; external;

  function gtk_viewport_get_hadjustment(viewport:pGtkViewport):PGtkAdjustment;CDECL; external;

  function gtk_viewport_get_vadjustment(viewport:pGtkViewport):PGtkAdjustment;CDECL; external;

  procedure gtk_viewport_set_hadjustment(viewport:pGtkViewport; adjustment:pGtkAdjustment);CDECL; external;

  procedure gtk_viewport_set_vadjustment(viewport:pGtkViewport; adjustment:pGtkAdjustment);CDECL; external;

  procedure gtk_viewport_set_shadow_type(viewport:pGtkViewport; thetype:GtkShadowType);CDECL; external;


end.
