unit gtkwidget;

  interface

uses gdk,gdktypes,gtkobjects,glib,gtkstyle,gtkaccelerator,gtkenums;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;


    type
       misc =  Longint;
         Const
         GTK_TOPLEVEL = 1 shl 4;
         GTK_NO_WINDOW = 1 shl 5;
         GTK_REALIZED = 1 shl 6;
         GTK_MAPPED = 1 shl 7;
         GTK_VISIBLE = 1 shl 8;
         GTK_SENSITIVE = 1 shl 9;
         GTK_PARENT_SENSITIVE = 1 shl 10;
         GTK_CAN_FOCUS = 1 shl 11;
         GTK_HAS_FOCUS = 1 shl 12;
         GTK_CAN_DEFAULT = 1 shl 13;
         GTK_HAS_DEFAULT = 1 shl 14;
         GTK_HAS_GRAB = 1 shl 15;
         GTK_BASIC = 1 shl 16;
         GTK_RESERVED_3 = 1 shl 17;
         GTK_RC_STYLE = 1 shl 18;
    {
    #define GTK_WIDGET(wid)			  GTK_CHECK_CAST ((wid), gtk_widget_get_type (), GtkWidget)
    #define GTK_WIDGET_CLASS(klass)		  GTK_CHECK_CLASS_CAST ((klass), gtk_widget_get_type (), GtkWidgetClass)
    #define GTK_WIDGET_TYPE(wid)		  (GTK_OBJECT_TYPE (wid))
    }
   
    {
    #define GTK_WIDGET_SET_FLAGS(wid,flag)	  G_STMT_STARTG_STMT_END
    #define GTK_WIDGET_UNSET_FLAGS(wid,flag)  G_STMT_STARTG_STMT_END
    }
    {
    #define GTK_IS_WIDGET(wid)		  GTK_CHECK_TYPE ((wid), GTK_TYPE_WIDGET)
    #define GTK_TYPE_WIDGET			  (gtk_widget_get_type ())
    }
    type


       PGtkRequisition = ^TGtkRequisition;
{$PACKRECORDS 2}
       TGtkRequisition = record
            width : guint16;
            height : guint16;
         end;
       PGtkAllocation = ^TGtkAllocation;
{$PACKRECORDS 2}
       TGtkAllocation = record
            x : gint16;
            y : gint16;
            width : guint16;
            height : guint16;
         end;
       PGtkSelectionData = ^TGtkSelectionData;
{$PACKRECORDS 4}
       TGtkSelectionData = record
            selection : GdkAtom;
            target : GdkAtom;
            thetype : GdkAtom;
            format : gint;
            data : pguchar;
            length : gint;
         end;
       PGtkWidget = ^TGtkWidget;
       PPgtkWidget = ^PGTKWidget;
{$PACKRECORDS 4}
       TGtkWidget = record
            theobject : GtkObject;
            private_flags : guint16;
            state : guint8;
            saved_state : guint8;
            name : pgchar;
            thestyle : pGtkStyle;
            requisition : TGtkRequisition;
            allocation : TGtkAllocation;
            window : pGdkWindow;
            parent : pGtkWidget;
         end;

       PGtkWidgetClass = ^TGtkWidgetClass;
{$PACKRECORDS 4}
       TGtkWidgetClass = record
            parent_class : GtkObjectClass;
            activate_signal : guint;
            show : Procedure (widget:pGtkWidget); cdecl;
            hide : Procedure (widget:pGtkWidget); cdecl;
            show_all : Procedure (widget:pGtkWidget); cdecl;
            hide_all : Procedure (widget:pGtkWidget); cdecl;
            map : Procedure (widget:pGtkWidget); cdecl;
            unmap : Procedure (widget:pGtkWidget); cdecl;
            realize : Procedure (widget:pGtkWidget); cdecl;
            unrealize : Procedure (widget:pGtkWidget); cdecl;
            draw : Procedure (widget:pGtkWidget; area:pGdkRectangle); cdecl;
            draw_focus : Procedure (widget:pGtkWidget); cdecl;
            draw_default : Procedure (widget:pGtkWidget); cdecl;
            size_request : Procedure (widget:pGtkWidget; requisition:pGtkRequisition); cdecl;
            size_allocate : Procedure (widget:pGtkWidget; allocation:pGtkAllocation); cdecl;
            state_changed : Procedure (widget:pGtkWidget; previous_state:guint); cdecl;
            parent_set : Procedure (widget:pGtkWidget; previous_parent:pGtkWidget); cdecl;
            style_set : Procedure (widget:pGtkWidget; previous_style:pGtkStyle); cdecl;
            install_accelerator : Function  (widget:pGtkWidget; signal_name:pgchar; key:gchar; modifiers:guint8):gint; cdecl;
            remove_accelerator : Procedure (widget:pGtkWidget; signal_name:pgchar); cdecl;
            event : Function  (widget:pGtkWidget; event:pGdkEvent):gint; cdecl;
            button_press_event : Function  (widget:pGtkWidget; event:pGdkEventButton):gint; cdecl;
            button_release_event : Function  (widget:pGtkWidget; event:pGdkEventButton):gint; cdecl;
            motion_notify_event : Function  (widget:pGtkWidget; event:pGdkEventMotion):gint; cdecl;
            delete_event : Function  (widget:pGtkWidget; event:pGdkEventAny):gint; cdecl;
            destroy_event : Function  (widget:pGtkWidget; event:pGdkEventAny):gint; cdecl;
            expose_event : Function  (widget:pGtkWidget; event:pGdkEventExpose):gint; cdecl;
            key_press_event : Function  (widget:pGtkWidget; event:pGdkEventKey):gint; cdecl;
            key_release_event : Function  (widget:pGtkWidget; event:pGdkEventKey):gint; cdecl;
            enter_notify_event : Function  (widget:pGtkWidget; event:pGdkEventCrossing):gint; cdecl;
            leave_notify_event : Function  (widget:pGtkWidget; event:pGdkEventCrossing):gint; cdecl;
            configure_event : Function  (widget:pGtkWidget; event:pGdkEventConfigure):gint; cdecl;
            focus_in_event : Function  (widget:pGtkWidget; event:pGdkEventFocus):gint; cdecl;
            focus_out_event : Function  (widget:pGtkWidget; event:pGdkEventFocus):gint; cdecl;
            map_event : Function  (widget:pGtkWidget; event:pGdkEventAny):gint; cdecl;
            unmap_event : Function  (widget:pGtkWidget; event:pGdkEventAny):gint; cdecl;
            property_notify_event : Function  (widget:pGtkWidget; event:pGdkEventProperty):gint; cdecl;
            selection_clear_event : Function  (widget:pGtkWidget; event:pGdkEventSelection):gint; cdecl;
            selection_request_event : Function  (widget:pGtkWidget; event:pGdkEventSelection):gint; cdecl;
            selection_notify_event : Function  (widget:pGtkWidget; event:pGdkEventSelection):gint; cdecl;
            proximity_in_event : Function  (widget:pGtkWidget; event:pGdkEventProximity):gint; cdecl;
            proximity_out_event : Function  (widget:pGtkWidget; event:pGdkEventProximity):gint; cdecl;
            drag_begin_event : Function  (widget:pGtkWidget; event:pGdkEventDragBegin):gint; cdecl;
            drag_request_event : Function  (widget:pGtkWidget; event:pGdkEventDragRequest):gint; cdecl;
            drag_end_event : Function  (widget:pGtkWidget; event:pGdkEvent):gint; cdecl;
            drop_enter_event : Function  (widget:pGtkWidget; event:pGdkEventDropEnter):gint; cdecl;
            drop_leave_event : Function  (widget:pGtkWidget; event:pGdkEventDropLeave):gint; cdecl;
            drop_data_available_event : Function  (widget:pGtkWidget; event:pGdkEventDropDataAvailable):gint; cdecl;
            other_event : Function  (widget:pGtkWidget; event:pGdkEventOther):gint; cdecl;
            selection_received : Procedure (widget:pGtkWidget; selection_data:pGtkSelectionData); cdecl;
            client_event : Function  (widget:pGtkWidget; event:pGdkEventClient):gint; cdecl;
            no_expose_event : Function  (widget:pGtkWidget; event:pGdkEventAny):gint; cdecl;
         end;
       PGtkWidgetAuxInfo = ^TGtkWidgetAuxInfo;
{$PACKRECORDS 2}
       TGtkWidgetAuxInfo = record
            x : gint16;
            y : gint16;
            width : guint16;
            height : guint16;
         end;
       PGtkWidgetShapeInfo = ^TGtkWidgetShapeInfo;
{$PACKRECORDS 4}
       TGtkWidgetShapeInfo = record
            offset_x : gint16;
            offset_y : gint16;
            shape_mask : ^GdkBitmap;
         end;

       TGTKCallBack = Procedure (Widget : PGTKwidget; data : gpointer); cdecl;


    Function  GTK_WIDGET_STATE(wid : pgtkwidget) : longint;
    Function  GTK_WIDGET_SAVED_STATE(wid : pgtkwidget) : longint;
    Function  GTK_WIDGET_FLAGS(wid : pgtkwidget) : longint;
    Function  GTK_WIDGET_TOPLEVEL(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_NO_WINDOW(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_REALIZED(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_MAPPED(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_VISIBLE(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_DRAWABLE(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_SENSITIVE(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_PARENT_SENSITIVE(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_IS_SENSITIVE(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_CAN_FOCUS(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_HAS_FOCUS(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_CAN_DEFAULT(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_HAS_DEFAULT(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_HAS_GRAB(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_IS_BASIC(wid : pgtkwidget) : boolean;
    Function  GTK_WIDGET_RC_STYLE(wid : pgtkwidget) : boolean;


    Function  gtk_widget_get_type:GtkType; cdecl;
    {
    Function  gtk_widget_new (type:guint; ...):GtkWidget;export name 'gtk_widget_new'; cdecl;
    }
    Function   gtk_widget_newv (thetype:guint; nargs:guint; args:pGtkArg):PGtkWidget; cdecl;
    Procedure gtk_widget_ref(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_unref(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_destroy(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_destroyed(widget:pGtkWidget; widget_pointer:ppGtkWidget); cdecl;
    Procedure gtk_widget_get(widget:pGtkWidget; arg:pGtkArg); cdecl;
    Procedure gtk_widget_getv(widget:pGtkWidget; nargs:guint; args:pGtkArg); cdecl;
    {
    Procedure gtk_widget_set(widget:pGtkWidget; ...); cdecl;
    }
    Procedure gtk_widget_setv(widget:pGtkWidget; nargs:guint; args:pGtkArg); cdecl;
    Procedure gtk_widget_unparent(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_show(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_show_now(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_hide(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_show_all(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_hide_all(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_map(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_unmap(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_realize(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_unrealize(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_queue_draw(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_queue_resize(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_draw(widget:pGtkWidget; area:pGdkRectangle); cdecl;
    Procedure gtk_widget_draw_focus(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_draw_default(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_draw_children(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_size_request(widget:pGtkWidget; requisition:pGtkRequisition); cdecl;
    Procedure gtk_widget_size_allocate(widget:pGtkWidget; allocation:pGtkAllocation); cdecl;
    Procedure gtk_widget_install_accelerator(widget:pGtkWidget; table:pGtkAcceleratorTable; signal_name:pgchar; key:gchar; modifiers:guint8); cdecl;
    Procedure gtk_widget_remove_accelerator(widget:pGtkWidget; table:pGtkAcceleratorTable; signal_name:pgchar); cdecl;
    Function  gtk_widget_event(widget:pGtkWidget; event:pGdkEvent):gint; cdecl;
    Procedure gtk_widget_activate(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_reparent(widget:pGtkWidget; new_parent:pGtkWidget); cdecl;
    Procedure gtk_widget_popup(widget:pGtkWidget; x:gint; y:gint); cdecl;
    Function   gtk_widget_intersect(widget:pGtkWidget; area:pGdkRectangle; intersection:pGdkRectangle):gint; cdecl;
    Function   gtk_widget_basic(widget:pGtkWidget):gint; cdecl;
    Procedure gtk_widget_grab_focus(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_grab_default(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_set_name(widget:pGtkWidget; name:pgchar); cdecl;
    Function   gtk_widget_get_name (widget:pGtkWidget):pgchar; cdecl;
    Procedure gtk_widget_set_state(widget:pGtkWidget; state:GtkStateType); cdecl;
    Procedure gtk_widget_set_sensitive(widget:pGtkWidget; sensitive:gint); cdecl;
    Procedure gtk_widget_set_parent(widget:pGtkWidget; parent:pGtkWidget); cdecl;
    Procedure gtk_widget_set_parent_window(widget:pGtkWidget; parent_window:pGdkWindow); cdecl;
    Function  gtk_widget_get_parent_window (widget:pGtkWidget):PGdkWindow; cdecl;
    Procedure gtk_widget_set_uposition(widget:pGtkWidget; x:gint; y:gint); cdecl;
    Procedure gtk_widget_set_usize(widget:pGtkWidget; width:gint; height:gint); cdecl;
    Procedure gtk_widget_set_events(widget:pGtkWidget; events:gint); cdecl;
    Procedure gtk_widget_set_extension_events(widget:pGtkWidget; mode:GdkExtensionMode); cdecl;
    Function  gtk_widget_get_extension_events(widget:pGtkWidget):GdkExtensionMode; cdecl;
    Function  gtk_widget_get_toplevel (widget:pGtkWidget):PGtkWidget; cdecl;
    Function  gtk_widget_get_ancestor (widget:pGtkWidget; widget_type:GtkType):PGtkWidget; cdecl;
    Function  gtk_widget_get_colormap (widget:pGtkWidget):PGdkColormap; cdecl;
    Function  gtk_widget_get_visual (widget:pGtkWidget):PGdkVisual; cdecl;
    Function  gtk_widget_get_events(widget:pGtkWidget):gint; cdecl;
    Procedure gtk_widget_get_pointer(widget:pGtkWidget; x:pgint; y:pgint); cdecl;
    Function  gtk_widget_is_ancestor(widget:pGtkWidget; ancestor:pGtkWidget):gint; cdecl;
    Function  gtk_widget_is_child(widget:pGtkWidget; child:pGtkWidget):gint; cdecl;
    Function  gtk_widget_hide_on_delete(widget:pGtkWidget):gint; cdecl;
    Procedure gtk_widget_set_style(widget:pGtkWidget; style:pGtkStyle); cdecl;
    Procedure gtk_widget_set_rc_style(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_ensure_style(widget:pGtkWidget); cdecl;
    Function   gtk_widget_get_style (widget:pGtkWidget):PGtkStyle; cdecl;
    Procedure gtk_widget_restore_default_style(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_propagate_default_style; cdecl;
    Procedure gtk_widget_push_style(style:pGtkStyle); cdecl;
    Procedure gtk_widget_push_colormap(cmap:pGdkColormap); cdecl;
    Procedure gtk_widget_push_visual(visual:pGdkVisual); cdecl;
    Procedure gtk_widget_pop_style; cdecl;
    Procedure gtk_widget_pop_colormap; cdecl;
    Procedure gtk_widget_pop_visual; cdecl;
    Procedure gtk_widget_set_default_style(style:pGtkStyle); cdecl;
    Procedure gtk_widget_set_default_colormap(colormap:pGdkColormap); cdecl;
    Procedure gtk_widget_set_default_visual(visual:pGdkVisual); cdecl;
    Function   gtk_widget_get_default_style : PGtkStyle; cdecl;
    Function   gtk_widget_get_default_colormap : PGdkColormap; cdecl;
    Function   gtk_widget_get_default_visual : PGdkVisual; cdecl;
    Procedure gtk_widget_shape_combine_mask(widget:pGtkWidget; shape_mask:pGdkBitmap; offset_x:gint; offset_y:gint); cdecl;
    Procedure gtk_widget_dnd_drag_add(widget:pGtkWidget); cdecl;
    Procedure gtk_widget_dnd_drag_set(widget:pGtkWidget; drag_enable:guint8; type_accept_list:ppgchar; numtypes:guint); cdecl;
    Procedure gtk_widget_dnd_drop_set(widget:pGtkWidget; drop_enable:guint8; type_accept_list:ppgchar; numtypes:guint; is_destructive_operation:guint8); cdecl;
    Procedure gtk_widget_dnd_data_set(widget:pGtkWidget; event:pGdkEvent; data:gpointer; data_numbytes:gulong); cdecl;

  implementation
   
    function GTK_WIDGET_STATE(wid : pgtkwidget) : longint;
   
      begin
         GTK_WIDGET_STATE:=wid^.state;
      end;
   
    function GTK_WIDGET_SAVED_STATE(wid : pgtkwidget) : longint;
   
      begin
         GTK_WIDGET_SAVED_STATE:=wid^.saved_state;
      end;
   
    function GTK_WIDGET_FLAGS(wid : pgtkwidget) : longint;
   
      begin
         GTK_WIDGET_FLAGS:=GTK_OBJECT_FLAGS(pgtkobject(wid));
      end;
   
    function GTK_WIDGET_TOPLEVEL(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_TOPLEVEL:=((GTK_WIDGET_FLAGS(wid)) and GTK_TOPLEVEL) <> 0;
      end;
   
    function GTK_WIDGET_NO_WINDOW(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_NO_WINDOW:=((GTK_WIDGET_FLAGS(wid)) and GTK_NO_WINDOW) <> 0;
      end;
   
    function GTK_WIDGET_REALIZED(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_REALIZED:=((GTK_WIDGET_FLAGS(wid)) and GTK_REALIZED) <> 0;
      end;
   
    function GTK_WIDGET_MAPPED(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_MAPPED:=((GTK_WIDGET_FLAGS(wid)) and GTK_MAPPED) <> 0;
      end;
   
    function GTK_WIDGET_VISIBLE(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_VISIBLE:=((GTK_WIDGET_FLAGS(wid)) and GTK_VISIBLE) <> 0;
      end;
   
    function GTK_WIDGET_DRAWABLE(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_DRAWABLE:=(GTK_WIDGET_VISIBLE(wid) and GTK_WIDGET_MAPPED(wid)) <> 0;
      end;
   
    function GTK_WIDGET_SENSITIVE(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_SENSITIVE:=((GTK_WIDGET_FLAGS(wid)) and GTK_SENSITIVE) <> 0;
      end;
   
    function GTK_WIDGET_PARENT_SENSITIVE(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_PARENT_SENSITIVE:=((GTK_WIDGET_FLAGS(wid)) and 
                                        GTK_PARENT_SENSITIVE) <> 0;
      end;
   
    function GTK_WIDGET_IS_SENSITIVE(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_IS_SENSITIVE:=(GTK_WIDGET_SENSITIVE(wid) and 
                                   GTK_WIDGET_PARENT_SENSITIVE(wid)) <> 0;
      end;
   
    function GTK_WIDGET_CAN_FOCUS(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_CAN_FOCUS:=((GTK_WIDGET_FLAGS(wid)) and GTK_CAN_FOCUS) <> 0;
      end;
   
    function GTK_WIDGET_HAS_FOCUS(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_HAS_FOCUS:=((GTK_WIDGET_FLAGS(wid)) and GTK_HAS_FOCUS) <> 0;
      end;
   
    function GTK_WIDGET_CAN_DEFAULT(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_CAN_DEFAULT:=((GTK_WIDGET_FLAGS(wid)) and GTK_CAN_DEFAULT) <> 0;
      end;
   
    function GTK_WIDGET_HAS_DEFAULT(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_HAS_DEFAULT:=((GTK_WIDGET_FLAGS(wid)) and GTK_HAS_DEFAULT) <> 0;
      end;
   
    function GTK_WIDGET_HAS_GRAB(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_HAS_GRAB:=((GTK_WIDGET_FLAGS(wid)) and GTK_HAS_GRAB) <> 0;
      end;
   
    function GTK_WIDGET_IS_BASIC(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_IS_BASIC:=((GTK_WIDGET_FLAGS(wid)) and GTK_BASIC) <> 0;
      end;
   
    function GTK_WIDGET_RC_STYLE(wid : pgtkwidget) : boolean;
   
      begin
         GTK_WIDGET_RC_STYLE:=((GTK_WIDGET_FLAGS(wid)) and GTK_RC_STYLE) <> 0;
      end;

    function gtk_widget_get_type:GtkType;CDECL; external;
    procedure gtk_widget_ref(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_unref(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_destroy(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_destroyed(widget:pGtkWidget; widget_pointer:ppGtkWidget);CDECL; external;
    procedure gtk_widget_get(widget:pGtkWidget; arg:pGtkArg);CDECL; external;
    procedure gtk_widget_getv(widget:pGtkWidget; nargs:guint; args:pGtkArg);CDECL; external;
    {
    procedure gtk_widget_set(widget:pGtkWidget; ...);CDECL; external;
    }
    procedure gtk_widget_setv(widget:pGtkWidget; nargs:guint; args:pGtkArg);CDECL; external;
    procedure gtk_widget_unparent(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_show(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_show_now(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_hide(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_show_all(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_hide_all(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_map(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_unmap(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_realize(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_unrealize(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_queue_draw(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_queue_resize(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_draw(widget:pGtkWidget; area:pGdkRectangle);CDECL; external;
    procedure gtk_widget_draw_focus(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_draw_default(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_draw_children(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_size_request(widget:pGtkWidget; requisition:pGtkRequisition);CDECL; external;
    procedure gtk_widget_size_allocate(widget:pGtkWidget; allocation:pGtkAllocation);CDECL; external;
    procedure gtk_widget_install_accelerator(widget:pGtkWidget; table:pGtkAcceleratorTable; signal_name:pgchar; key:gchar; modifiers:guint8);CDECL; external;
    procedure gtk_widget_remove_accelerator(widget:pGtkWidget; table:pGtkAcceleratorTable; signal_name:pgchar);CDECL; external;
    function gtk_widget_event(widget:pGtkWidget; event:pGdkEvent):gint;CDECL; external;
    procedure gtk_widget_activate(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_reparent(widget:pGtkWidget; new_parent:pGtkWidget);CDECL; external;
    procedure gtk_widget_popup(widget:pGtkWidget; x:gint; y:gint);CDECL; external;
    function gtk_widget_intersect(widget:pGtkWidget; area:pGdkRectangle; intersection:pGdkRectangle):gint;CDECL; external;
    function gtk_widget_basic(widget:pGtkWidget):gint;CDECL; external;
    procedure gtk_widget_grab_focus(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_grab_default(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_set_name(widget:pGtkWidget; name:pgchar);CDECL; external;
    procedure gtk_widget_set_state(widget:pGtkWidget; state:GtkStateType);CDECL; external;
    procedure gtk_widget_set_sensitive(widget:pGtkWidget; sensitive:gint);CDECL; external;
    procedure gtk_widget_set_parent(widget:pGtkWidget; parent:pGtkWidget);CDECL; external;
    procedure gtk_widget_set_parent_window(widget:pGtkWidget; parent_window:pGdkWindow);CDECL; external;
    procedure gtk_widget_set_uposition(widget:pGtkWidget; x:gint; y:gint);CDECL; external;
    procedure gtk_widget_set_usize(widget:pGtkWidget; width:gint; height:gint);CDECL; external;
    procedure gtk_widget_set_events(widget:pGtkWidget; events:gint);CDECL; external;
    procedure gtk_widget_set_extension_events(widget:pGtkWidget; mode:GdkExtensionMode);CDECL; external;
    function gtk_widget_get_extension_events(widget:pGtkWidget):GdkExtensionMode;CDECL; external;
    function gtk_widget_get_events(widget:pGtkWidget):gint;CDECL; external;
    procedure gtk_widget_get_pointer(widget:pGtkWidget; x:pgint; y:pgint);CDECL; external;
    function gtk_widget_is_ancestor(widget:pGtkWidget; ancestor:pGtkWidget):gint;CDECL; external;
    function gtk_widget_is_child(widget:pGtkWidget; child:pGtkWidget):gint;CDECL; external;
    function gtk_widget_hide_on_delete(widget:pGtkWidget):gint;CDECL; external;
    procedure gtk_widget_set_style(widget:pGtkWidget; style:pGtkStyle);CDECL; external;
    procedure gtk_widget_set_rc_style(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_ensure_style(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_restore_default_style(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_propagate_default_style;CDECL; external;
    procedure gtk_widget_push_style(style:pGtkStyle);CDECL; external;
    procedure gtk_widget_push_colormap(cmap:pGdkColormap);CDECL; external;
    procedure gtk_widget_push_visual(visual:pGdkVisual);CDECL; external;
    procedure gtk_widget_pop_style;CDECL; external;
    procedure gtk_widget_pop_colormap;CDECL; external;
    procedure gtk_widget_pop_visual;CDECL; external;
    procedure gtk_widget_set_default_style(style:pGtkStyle);CDECL; external;
    procedure gtk_widget_set_default_colormap(colormap:pGdkColormap);CDECL; external;
    procedure gtk_widget_set_default_visual(visual:pGdkVisual);CDECL; external;
    procedure gtk_widget_shape_combine_mask(widget:pGtkWidget; shape_mask:pGdkBitmap; offset_x:gint; offset_y:gint);CDECL; external;
    procedure gtk_widget_dnd_drag_add(widget:pGtkWidget);CDECL; external;
    procedure gtk_widget_dnd_drag_set(widget:pGtkWidget; drag_enable:guint8; type_accept_list:ppgchar; numtypes:guint);CDECL; external;
    procedure gtk_widget_dnd_drop_set(widget:pGtkWidget; drop_enable:guint8; type_accept_list:ppgchar; numtypes:guint; is_destructive_operation:guint8);CDECL; external;
    procedure gtk_widget_dnd_data_set(widget:pGtkWidget; event:pGdkEvent; data:gpointer; data_numbytes:gulong);CDECL; external;

    function gtk_widget_get_toplevel (widget:pGtkWidget):PGtkWidget;cdecl; external;
    function gtk_widget_get_ancestor (widget:pGtkWidget; widget_type:GtkType):PGtkWidget;cdecl; external;
    function gtk_widget_get_colormap (widget:pGtkWidget):PGdkColormap;cdecl; external;
    function gtk_widget_get_visual (widget:pGtkWidget):PGdkVisual;cdecl; external;
    function  gtk_widget_get_name (widget:pGtkWidget):pgchar;cdecl; external;
    function  gtk_widget_newv (thetype:guint; nargs:guint; args:pGtkArg):PGtkWidget;cdecl; external;
    function  gtk_widget_get_default_style : PGtkStyle;cdecl; external;
    Function  gtk_widget_get_default_colormap : PGdkColormap;cdecl; external;
    function  gtk_widget_get_default_visual : PGdkVisual;cdecl; external;
    function  gtk_widget_get_style (widget:pGtkWidget):PGtkStyle;cdecl; external;
    Function gtk_widget_get_parent_window (widget:pGtkWidget):PGdkWindow;cdecl; external;


end.
