unit gtkwindow;

  interface

uses gdk,glib,gtkaccelerator,gtkbin,gtkenums,gtkwidget;

    Type
       PLongint  = ^Longint;
       PByte     = ^Byte;
       PWord     = ^Word;
       PInteger  = ^Integer;
       PCardinal = ^Cardinal;
       PReal     = ^Real;
       PDouble   = ^Double;

    {
    #define GTK_WINDOW(obj)          GTK_CHECK_CAST (obj, gtk_window_get_type (), GtkWindow)
    #define GTK_WINDOW_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, gtk_window_get_type (), GtkWindowClass)
    #define GTK_IS_WINDOW(obj)       GTK_CHECK_TYPE (obj, gtk_window_get_type ())
    }

    type

       PGtkWindow = ^TGtkWindow;
{$PACKRECORDS 4}
       TGtkWindow = record
            bin : TGtkBin;
            title : pgchar;
            wmclass_name : pgchar;
            wmclass_class : pgchar;
            thetype : GtkWindowType;
            accelerator_tables : PGList;
            focus_widget : PGtkWidget;
            default_widget : PGtkWidget;
            resize_count : gushort;
            flag0 : word;
         end;

    const
       bm_need_resize = 1;
       bp_need_resize = 0;
       bm_allow_shrink = 2;
       bp_allow_shrink = 1;
       bm_allow_grow = 4;
       bp_allow_grow = 2;
       bm_auto_shrink = 8;
       bp_auto_shrink = 3;
       bm_handling_resize = 16;
       bp_handling_resize = 4;
       bm_position = 96;
       bp_position = 5;
       bm_use_uposition = 128;
       bp_use_uposition = 7;
    Function  need_resize(var a : TGtkWindow) : guint;
    Procedure set_need_resize(var a : TGtkWindow; __need_resize : guint);
    Function  allow_shrink(var a : TGtkWindow) : guint;
    Procedure set_allow_shrink(var a : TGtkWindow; __allow_shrink : guint);
    Function  allow_grow(var a : TGtkWindow) : guint;
    Procedure set_allow_grow(var a : TGtkWindow; __allow_grow : guint);
    Function  auto_shrink(var a : TGtkWindow) : guint;
    Procedure set_auto_shrink(var a : TGtkWindow; __auto_shrink : guint);
    Function  handling_resize(var a : TGtkWindow) : guint;
    Procedure set_handling_resize(var a : TGtkWindow; __handling_resize : guint);
    Function  position(var a : TGtkWindow) : guint;
    Procedure set_position(var a : TGtkWindow; __position : guint);
    Function  use_uposition(var a : TGtkWindow) : guint;
    Procedure set_use_uposition(var a : TGtkWindow; __use_uposition : guint);

    type
       PGtkWindowClass = ^TGtkWindowClass;
{$PACKRECORDS 4}
       TGtkWindowClass = record
            parent_class : TGtkBinClass;
            move_resize : Function  (window:pGtkWindow; x:pgint; y:pgint; width:gint; height:gint):gint; cdecl;
            set_focus : Procedure (window:pGtkWindow; focus:pGtkWidget); cdecl;
         end;


    Function  gtk_window_get_type:guint; cdecl;


    Function  gtk_window_new (thetype:GtkWindowType):PGtkWidget; cdecl;

    Procedure gtk_window_set_title(window:pGtkWindow; title:pgchar); cdecl;

    Procedure gtk_window_set_wmclass(window:pGtkWindow; wmclass_name:pgchar; wmclass_class:pgchar); cdecl;

    Procedure gtk_window_set_focus(window:pGtkWindow; focus:pGtkWidget); cdecl;

    Procedure gtk_window_set_default(window:pGtkWindow; defaultw:pGtkWidget); cdecl;

    Procedure gtk_window_set_policy(window:pGtkWindow; allow_shrink:gint; allow_grow:gint; auto_shrink:gint); cdecl;

    Procedure gtk_window_add_accelerator_table(window:pGtkWindow; table:pGtkAcceleratorTable); cdecl;

    Procedure gtk_window_remove_accelerator_table(window:pGtkWindow; table:pGtkAcceleratorTable); cdecl;

    Procedure gtk_window_position(window:pGtkWindow; position:GtkWindowPosition); cdecl;

    Function  gtk_window_activate_focus(window:pGtkWindow):gint; cdecl;

    Function  gtk_window_activate_default(window:pGtkWindow):gint; cdecl;


  implementation

const External_library='gtk'; {Setup as you need!}

    function need_resize(var a : TGtkWindow) : guint;
      begin
         need_resize:=(a.flag0 and bm_need_resize) shr bp_need_resize;
      end;

    procedure set_need_resize(var a : TGtkWindow; __need_resize : guint);
      begin
         a.flag0:=a.flag0 or ((__need_resize shl bp_need_resize) and bm_need_resize);
      end;

    function allow_shrink(var a : TGtkWindow) : guint;
      begin
         allow_shrink:=(a.flag0 and bm_allow_shrink) shr bp_allow_shrink;
      end;

    procedure set_allow_shrink(var a : TGtkWindow; __allow_shrink : guint);
      begin
         a.flag0:=a.flag0 or ((__allow_shrink shl bp_allow_shrink) and bm_allow_shrink);
      end;

    function allow_grow(var a : TGtkWindow) : guint;
      begin
         allow_grow:=(a.flag0 and bm_allow_grow) shr bp_allow_grow;
      end;

    procedure set_allow_grow(var a : TGtkWindow; __allow_grow : guint);
      begin
         a.flag0:=a.flag0 or ((__allow_grow shl bp_allow_grow) and bm_allow_grow);
      end;

    function auto_shrink(var a : TGtkWindow) : guint;
      begin
         auto_shrink:=(a.flag0 and bm_auto_shrink) shr bp_auto_shrink;
      end;

    procedure set_auto_shrink(var a : TGtkWindow; __auto_shrink : guint);
      begin
         a.flag0:=a.flag0 or ((__auto_shrink shl bp_auto_shrink) and bm_auto_shrink);
      end;

    function handling_resize(var a : TGtkWindow) : guint;
      begin
         handling_resize:=(a.flag0 and bm_handling_resize) shr bp_handling_resize;
      end;

    procedure set_handling_resize(var a : TGtkWindow; __handling_resize : guint);
      begin
         a.flag0:=a.flag0 or ((__handling_resize shl bp_handling_resize) and bm_handling_resize);
      end;

    function position(var a : TGtkWindow) : guint;
      begin
         position:=(a.flag0 and bm_position) shr bp_position;
      end;

    procedure set_position(var a : TGtkWindow; __position : guint);
      begin
         a.flag0:=a.flag0 or ((__position shl bp_position) and bm_position);
      end;

    function use_uposition(var a : TGtkWindow) : guint;
      begin
         use_uposition:=(a.flag0 and bm_use_uposition) shr bp_use_uposition;
      end;

    procedure set_use_uposition(var a : TGtkWindow; __use_uposition : guint);
      begin
         a.flag0:=a.flag0 or ((__use_uposition shl bp_use_uposition) and bm_use_uposition);
      end;

    function gtk_window_new (thetype:GtkWindowType):PGtkWidget;cdecl;external;


    function gtk_window_get_type:guint;CDECL; external;

    procedure gtk_window_set_title(window:pGtkWindow; title:pgchar);CDECL; external;

    procedure gtk_window_set_wmclass(window:pGtkWindow; wmclass_name:pgchar; wmclass_class:pgchar);CDECL; external;

    procedure gtk_window_set_focus(window:pGtkWindow; focus:pGtkWidget);CDECL; external;

    procedure gtk_window_set_default(window:pGtkWindow; defaultw:pGtkWidget);CDECL; external;

    procedure gtk_window_set_policy(window:pGtkWindow; allow_shrink:gint; allow_grow:gint; auto_shrink:gint);CDECL; external;

    procedure gtk_window_add_accelerator_table(window:pGtkWindow; table:pGtkAcceleratorTable);CDECL; external;

    procedure gtk_window_remove_accelerator_table(window:pGtkWindow; table:pGtkAcceleratorTable);CDECL; external;

    procedure gtk_window_position(window:pGtkWindow; position:GtkWindowPosition);CDECL; external;

    function gtk_window_activate_focus(window:pGtkWindow):gint;CDECL; external;

    function gtk_window_activate_default(window:pGtkWindow):gint;CDECL; external;


end.
